<?php
/*
	Connect Daily Web Calendar Software

	Copyright 2007, MH Software, Inc. All Rights Reserved
'	5023 W 120th Ave #311, Broomfield CO 80020
	+1 303 438 9585

	Last Edit By: "$Author: gsexton $"
	Last Checkin: "$Date: 2008/09/17 20:23:44 $"
	Revision #  : "$Revision: 1.3 $"

    This file acts as a simple AJAX proxy page. It uses 
    fopen() or CURL, depending upon what's available.
*/
function performProxyCurl($sURL){
    $ch=curl_init($sURL);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_exec($ch);
    curl_close($ch);
}

function performProxyFOpen($sURL) {
    $handle=fopen($sURL,"r");
    if (!$handle) {
        echo "Error opening source "+$sURL;
        exit;
    }
    $text="";
    while (!feof($handle)) {
        $text.=fgets($handle);
    }
    fclose($handle);
    echo $text;
}

function getDomain($sURL){
    // Return the domain name of the request.
    $copy=strtolower($sURL);
    $iPos=strpos($copy,"://");
    if ($iPos!==false) {
        $copy=substr($copy,$iPos+3);
        $iPos=strpos($copy,"/");
        if ($iPos!==false) {
            $copy=substr($copy,0,$iPos);
        }
    }
    $iPos=strpos($copy,".");
    if ($iPos!==false) {
        $copy=substr($copy,$iPos+1);
    }
    return $copy;
}


$sURL=$_GET["URL"];
$reqDomain=getDomain($sURL);
$myDomain=getDomain($_SERVER["HTTP_HOST"]);
if ($reqDomain!==$myDomain and $reqDomain!=="mhsoftware.com") {
    header("Status: 403 We're not an open proxy service here.");
    exit;
}
// Check if we're allowed to proxy for this domain.


// Set the content type.
$iXML=strpos($sURL,".xml");
if ($iXML===false) {
    header('Content-type: text/html');
} else {
    header('Content-type: text/xml');
}
// Disable caching
header("Cache-Control: no-cache, must-revalidate");
header("Pragma: no-cache");

// Write the actual data.
$useFOpen=ini_get("allow_url_fopen");
if ($useFOpen===false or strtolower($useFOpen)==="off") {
    // by configuration, allow_url_fopen is not enabled. Try CURL
    performProxyCurl($sURL);
} else {
    performProxyFOpen($sURL);
}
?>
