#!/usr/bin/perl -w
#######################################################################
#	Connect Daily Web Calendar Software
#
#	Copyright 2007, MH Software, Inc. All Rights Reserved
#	5023 W 120th Ave #311, Broomfield CO 80020
#	+1 303 438 9585
#
#	Last Edit By: "$Author: gsexton $"
#	Last Checkin: "$Date: 2008/09/17 20:23:44 $"
#	Revision #  : "$Revision: 1.2 $"
#
#    This file acts as a simple AJAX proxy.
########################################################################


use CGI qw(:standard);
use Net::HTTP;
use Net::HTTPS;
use Encode;
use strict;

###Strip http:// or https:// from URL query string
my $ssl  = 0;
my $host = param("URL");
if ($host=~/https/) {$ssl = 1; $host = substr($host, 8);}
if ($host=~/http/) {$host = substr($host, 7);}

###Separate host and path
my $path = "/";
if ($host=~/\//) {
 $path = substr($host, index($host, "/"));
 $host = substr($host, 0, index($host, "/"));
}

###Deal with Referer & Accept-Language headers
my $referer = $ENV{HTTP_REFERER};
if (! $referer) {
 $referer = $ENV{HTTP_HOST} + $ENV{REQUEST_URI};
}
my $accept_language = $ENV{HTTP_ACCEPT_LANGUAGE};

###Create Net:HTTP(S) handle to $host with proper HTTP headers
my $http_handle;
eval {
 if ($ssl) {
   $http_handle = Net::HTTPS->new(Host => $host, 'Referer' => $referer, 'Accept-Language' => $accept_language) || die $@;
 }
 else {
   $http_handle = Net::HTTP->new(Host => $host, 'Referer' => $referer, 'Accept-Language' => $accept_language) || die $@;
 }
};
if ($@)
{
 print $@;
 exit;
}

###Write request to $path at $host
$http_handle->write_request(GET => $path);
my($code, $mess, %h) = $http_handle->read_response_headers;

###Print correct content type for html & xml
if (($path=~/\.xml/) || ($path=~/\.XML/)) {
 print "Content-type: text/xml\n\n";
}
else {
 print "Content-type: text/html\n\n";
}

###Read data from $http_handle, utf-8 decode data so it is not encoded twice, print out to browser
while (1) {
   my $buf;
   my $n = $http_handle->read_entity_body($buf, 1024);
   last unless $n;
   print decode_utf8($buf);
}

