<%@ page language="java" contentType="text/html" %>
<%@ page import="java.util.*,com.MHSoftware.dates.SaneDate,com.mhsoftware.cdaily.business.calitem,com.mhsoftware.cdaily.support.*" %>
<%
/*

--Calendar item properties are:--

public int cal_item_id;
public int calendar_id;
public int item_type_id;

public int owner;
public int approved;
public SaneDate starting_date;
public SaneDate ending_date;
public String starting_time;
public String ending_time;
public int rec_type;
public String description;
public String contact_name;
public String contact_info;
public String add_info_url;
public Timestamp last_update;
public String long_description;
public String owner_name;		// Virtual Field from View
*/

//NOTE:  THE INCLUDE CALENDARS DEFAULT TO approved=1 (SHOW ONLY APPROVED)
//       PASS approved=0 IF NON-APPROVED EVENTS NEED TO BE SHOWN.

String absolutePrefix = request.getScheme() + "://" + request.getServerName() + request.getContextPath() + "/";
int DAYS_DISPLAY=7;    // Set this to 7 for a week view, 1 for a single day
boolean SHOW_EMPTY_DAYS=true;


SaneDate startDate=new SaneDate();	//This date will be the first day of the displayed interval
SaneDate endDate=new SaneDate();	//This date will be the last day of the displayed interval
SaneDate currentDate=new SaneDate();	//Current date w/in start/end interval (itterates)
SaneDate today = new SaneDate();	//This date will *always* be today.
SaneDate nextDate;
SaneDate prevDate;
int startMonthOffset = 0;	//Number of months the start date is offset from the current month
int endMonthOffset = 0;		//Number of months the end date is offset from the current month

calitem ci;
String cCriteria, cTime;
String referrer = "";

//This page is intended to be accessed by other pages, but includes nav links,
//so it must know what URL to link to
if (request.getParameter("referrer")!=null) {
	referrer = request.getParameter("referrer");
} else {
	referrer = "week_include.jsp";
}

//Look to see if a date was passed as an argument.
if (request.getParameter("date")!=null) {
	startDate=new SaneDate(Integer.parseInt(request.getParameter("date")));
}

startDate.subtract(startDate.getDOW()-1);	//Ensure current date is first day of week

//Check for an offset.  Offset is in number of weeks (+/-)
if (request.getParameter("offset")!=null) {
	int offset = Integer.parseInt(request.getParameter("offset")) * DAYS_DISPLAY;
	startDate.add(offset);
}

currentDate = new SaneDate(startDate.getJulianDate());
endDate = new SaneDate(startDate.getJulianDate() + DAYS_DISPLAY - 1);
nextDate = new SaneDate(startDate.getJulianDate() + DAYS_DISPLAY);
prevDate = new SaneDate(startDate.getJulianDate() - DAYS_DISPLAY);
startMonthOffset = (startDate.getMonth() - today.getMonth()) + ( 12 * (startDate.getYear() - today.getYear()) );
endMonthOffset = (endDate.getMonth() - today.getMonth()) + ( 12 * (endDate.getYear() - today.getYear()) );

//
// Call the helper method to get the item vector, and parse the options
//
Vector v=CalHelper.getItemVectorAndOptions(request,request.getLocale());
//
// Get an array of vectors, where each element in the array corresponds
// to one day. The vectors contain the calendar items that occurr on the
// specified day.
//
Vector[] avDays=CalHelper.getDayVector(startDate,endDate,v,WebApp.getTimeZone().getID(),Locale.getDefault());
//
//	Get the criteria that was parsed out by getItemVectorAndOptions()
//
cCriteria = (String)request.getAttribute("Criteria");


//Debug - view passed criteria and query
out.println("<!-- Criteria:" + cCriteria + " Query:" + request.getQueryString() + "-->");

%>
<script Language=Javascript TYPE="text/javascript">
function popItem(iItemID, iSpecificDate) {
    window.open("<%= absolutePrefix %>ViewItem.html?detail=0&style_sheet=beloit_default.css&integral=0&dtwhen="+iSpecificDate+"&cal_item_id="+iItemID,"ViewItemWin","scrollbars=yes,resizable=yes,status=no,location=no,menubar=no,toolbar=no,width=600,height=500");
 }
function popMonth(offset) {
    window.open("<%= absolutePrefix %>ViewCal.html?<%= cCriteria %>&offset=" + offset + "&style_sheet=beloit_default.css&integral=0","ViewMonthWin","scrollbars=yes,resizable=yes,status=no,location=no,menubar=no,toolbar=no");
}
function popPrintableWeek() {
    window.open("<%= absolutePrefix %>printable_week.jsp?<%= cCriteria %>&date=" + <%= startDate.getJulianDate() %>,"PrintableWeek","scrollbars=yes,resizable=yes,status=no,location=no,menubar=yes,toolbar=yes");
}
</script>
<p class="CalTodayLabel">Today is <%= new SaneDate().toLongString() %></p>
<hr size="1" color="#FF9900" width="100%">
<p class="CalRangeLabel">Events for the week:<br/><%= startDate.toLongString() %> - <%= endDate.toLongString() %></p>
<p class="CalDateNav" stype="vertical-align: center"><a class="CalDateNav" href="JavaScript:popPrintableWeek()" title="View a printable week in a new window"><img alt="Printable Version" src="<%= absolutePrefix %>images/icon-print.gif">&nbsp;Printable Version</a></p>
<table width="100%" cellspacing="0" cellpadding="0">
<tr>
<td align="left" nowrap="true" valign="bottom"><a class="CalDateNav" title="View the previous week" href="<%= referrer %>?date=<%= prevDate.getJulianDate() %>"><img class="CalNavLeft" src="<%= absolutePrefix %>images/nav-prevmonth.gif" />Prev Week</a></td>
<% if (startMonthOffset == endMonthOffset) { %>
<td align="center" valign="bottom"><a class="CalDateNav" title="View entire month in a new window" href="JavaScript:popMonth(<%= startMonthOffset %>)">View<br/>Month</a></td>
<% } else { %>
<td align="center" valign="bottom"><a class="CalDateNav" title="View entire month in a new window" href="JavaScript:popMonth(<%= startMonthOffset %>)">View<br/><%= startDate.getCMonth() %></a></td>
<td align="center" valign="bottom"><a class="CalDateNav" title="View entire month in a new window" href="JavaScript:popMonth(<%= endMonthOffset %>)">View<br/><%= endDate.getCMonth() %></a></td>
<% } %>
<td align="right" nowrap="true" valign="bottom"><a class="CalDateNav" title="View the next week" href="<%= referrer %>?date=<%= nextDate.getJulianDate() %>"><img class="CalNavRight" src="<%= absolutePrefix %>images/nav-nextmonth.gif" />Next Week</a></td>
</tr>
</table>
<hr size="1" color="#FF9900" width="100%">

<TABLE>
<%
for (int i=0; i < avDays.length; i++) {
	if (avDays[i].size()==0) {
		if (SHOW_EMPTY_DAYS) {
%>
<TR>
<TD colspan="3"><p class="CalDayLabel"><%=currentDate.toLongString()%> (No scheduled events)</p></TD>
</TR>
<%
		}

	} else {
%>
<TR>
<TD colspan="3"><p class="CalDayLabel"><%=currentDate.toLongString()%></p></TD>
</TR>
<%
		Enumeration e=avDays[i].elements();
		while (e.hasMoreElements()) {
			ci=(calitem)e.nextElement();
			cTime=(ci.starting_time==null ? "All Day" : ci.starting_time);
%>
<TR>
<TD VALIGN="TOP"><IMG Border=0 SRC="<%= absolutePrefix %>images/nav-nextmonth.gif" ALT="Item" /></TD>
<TD VALIGN="TOP" nowrap="true"><p class="CalTimeLabel"><%=cTime%></p></TD>
<TD VALIGN="TOP"><a class="CalItemLink" HREF="JavaScript:popItem(<%=ci.cal_item_id%>,<%=currentDate.getJulianDate()%>)"><%=ci.description%></a></TD>
</TR>
<%
			String infoURL = ci.add_info_url;
			if (infoURL != null && ! infoURL.equals("")) {
				if (! infoURL.startsWith("http://")) infoURL = "http://" + infoURL;
%>
<TR>
<TD/>
<TD/>
<TD><p class="CalItemInfo">For more information visit:&nbsp;<a class="CalItemInfoLink" href="<%= infoURL %>" target="_blank"><%= infoURL %></a></p></TD>
</TR>
<%			}
		}
	}
	currentDate.add(1);
}
%>
</TABLE>
