<!doctype html>
<%@ page contentType = "text/html; charset=UTF-8"%>
<%@ page import="java.util.*,com.mhsoftware.cdaily.support.*,java.io.*,com.MHSoftware.dates.SaneDate,com.mhsoftware.cdaily.business.*,com.mhsoftware.cdaily.support.*,com.mhsoftware.cdaily.servlet.*,com.MHSoftware.servlet.*" %>
<%
/*
    Connect Daily Web Calendar Software
    
    Copyright 2008, MH Software, Inc. All Rights Reserved
    5023 W 120th Ave #311, Broomfield CO 80020
    +1 303 438 9585
    
    Last Edit By: "$Author: gsexton $"
    Last Checkin: "$Date: 2014/06/03 15:12:29 $"
    Revision #  : "$Revision: 1.10 $"
        
    This JSP page is a sample page that shows how you can create
    a completely customized display for a day, week, or event view.
    For a week view, set the DAYS_DISPLAY variable to 7. For a
    single day, set it to one day.
    If you only have a few events, you could set the DAYS_DISPLAY
    to something like 90. The output would then be a list of events 
    for the next 90 days.
*/
int DAYS_DISPLAY=WebApp.getIntProperty("RSSDefaultDaySpan",6);    // This argument will be overridden by the URL argument dayspan=
CalServlet cs=new CalServlet();
// Get our Effective User
//
User oUser=cs.getUser(request,response,true);
if (oUser==null) {
    return;
}
Locale lc=cs.getNegotiatedLocale(request);
ResourceBundle rb=CalServlet.getResourceBundle(lc);
ParameterParser pp=new ParameterParser(request,WebApp.CHARSET);
SaneDate sd=new SaneDate(TimeZone.getTimeZone(CalServlet.getDisplayTZ(request,oUser)),lc),sdEnd;
//
//  Look to see if a date was passed as an argument.
//
if (request.getParameter("date")!=null) {
    sd=new SaneDate(Integer.parseInt(request.getParameter("date")));
} else if (request.getParameter("start")!=null) {
    sd=new SaneDate(Integer.parseInt(request.getParameter("start")));
} else if (request.getParameter("offset")!=null) {
        sd.add(pp.getIntParameter("offset"));
}

sd.setLocale(lc);
final int dayspan=pp.getIntParameter("dayspan",DAYS_DISPLAY)-1;
sdEnd=new SaneDate(sd.getJulianDate()+dayspan);
//
// Call the helper method to get the item vector, and parse the options
//
Vector v=CalHelper.getItemVectorAndOptions(request,lc);
// Get an array of vectors, where each element in the array corresponds
// to one day. The vectors contain the calendar items that occurr on the
// specified day.
Vector[] avDays=CalHelper.getDayVector(sd,sdEnd,CalHelper.processAdditionalFilters(v,request,oUser.user_id),WebApp.getTimeZone().getID(),lc);
//
// Set up a calendar item formatter. It does some handy things.
//
CalendarItemFormatter cif=(CalendarItemFormatter)request.getAttribute("Formatter");
cif.setResourceBundle(rb);
cif.setIncludeResources(pp.getBooleanParameter("show_resources",oUser.isPrefSet(User.PREF_SHOWRESOURCES_ON)));
cif.setTimeZone(WebApp.getTimeZone());
// cif.setIncludeResources(true); // true to force on, false to force off
%>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <%=CalServlet.getGeneratorMeta()%>
	
    <meta name="author" content="http://www.mhsoftware.com/connectdaily.htm">
    <meta name="copyright" content="Copyright 2002-2014, MH Software, Inc. All Rights Reserved">
    <title>Event List</title>
    <%=CalServlet.getDijitCSS()%>
    	
    <link REL="stylesheet" HREF="style.css" TYPE="text/css">
</head>
    <body style="padding: 1em;">
    <%=CalServlet.getDijitScript(lc,"dijit.Dialog")%>
    
    <script TYPE="text/javascript" SRC="scripts/<%=WebApp.PRODUCT_VERSION%>/popWindows.js">
    </script>
        <%
        //
        // Iterate over the array of days.
        //
        String sLastTime="~";
        final int iMax=pp.getIntParameter("max_events",Integer.MAX_VALUE);
        int iCount=0;
        for (int i=0; i < avDays.length && iCount<iMax; i++) {
            if (avDays[i].size()==0) {
                sd.add(1);
                continue;
            }
        %>
		
            <%
            Enumeration e=avDays[i].elements();
            calitem ci;
            String cTime;
            while (e.hasMoreElements()) {
                ci=(calitem)e.nextElement();
                cif.setItem(ci);
                if (!cif.isDisplayed()) {
                    continue;
                }
                iCount++;
                cTime=cif.getTimeLabel(sd,CalendarItemFormatter.FLAG_START);
                if (cTime==null) {
                    cTime=sd.toLongString();
                } else {
                    cTime=(dayspan<0 ? cTime : sd.toLongString()+" - "+cTime);
                }
                if (!sLastTime.equals(cTime)) {
                    sLastTime=cTime;
                    %>
                    
    <p class="StartTime">
<%=cTime%>
    </p>
                    <%
                }
            %>
		    
    <p Class="Title">
<%=cif.getEventDescription(sd,new StringBuffer()).toString()%>
    </p>
    </p>
              <%
            if (ci.add_info_url!=null) {
            %>
		        <a Class="ItemLink" target=_BLANK href="<%=ci.add_info_url%>"><%=ci.add_info_url%></a>
    <br>
              <%
            }
            if (ci.location_id!=null) {
                location loc=new location(ci.location_id.intValue());
                if (MapHelper.isMappable(loc)) {
                    out.print(MapHelper.getCompleteLocationAsMapLink(loc));
				}
			}
            if (ci.long_description!=null) {
            %>
	          
    <p class="Description">
<%=ci.long_description%>
	          
              <%
            }
            Vector vAtt=ci.getAttachments();
            if (vAtt!=null && !vAtt.isEmpty()) {
                for (int iAtt=0; iAtt < vAtt.size(); iAtt++) {
                    calitemattachments cia=(calitemattachments)vAtt.elementAt(iAtt);
                    attachments att=new attachments(cia.attachment_id);
                    if (att.mime_type.startsWith("image/")) {
                        %>
                         
    <br>
    <img SRC="attachments/<%=att.attachment_id%>/<%=ci.cal_item_id%>/<%=cia.file_name%>">
                        <%
                    }
                }
            }
            %>
	        
    </p>
            <%
            }
            sd.add(1);
        }
        %>
    
    </body>
</html>
