package com.mhsoftware.cdaily.support;

import com.mhsoftware.cdaily.business.calitem;
import com.mhsoftware.cdaily.support.CalendarItemFormatter;
import com.MHSoftware.dates.SaneDate;

/** This class provides the default strings used for calendar item display.
 * Customers can override this class to customize the text returned for a calendar item.
 */
public class SampleItemFormatter extends CalendarItemFormatter {

 String Criteria;


    /** Return the A title string to be displayed for the event.
     */
    public StringBuffer getLinkTitle(final calitem ci, final SaneDate sdWhen,  StringBuffer bufAppend){
        if ( ci.starting_time != null ) {
            int iTime = com.MHSoftware.times.TimeUtils.parseTime(ci.starting_time);
            if (iTime > 0) {
                bufAppend.append(ci.starting_time.trim());
            }


            if ( ci.ending_time != null ) {
                if (ci.getType()==calitem.TYPE_ONETIME && ci.ending_date!=null && ci.ending_date.getJulianDate()>sdWhen.getJulianDate()) {
                    // If it's a one time and the ending date is not null and the current date less than the end date we do not
                    // display the end-time.
                } else {
                    bufAppend.append('-').append(ci.ending_time.trim());
                }

            }
        }

        return bufAppend;
    }

    /** Return the description that should be displayed for the event.
     */
    public StringBuffer getEventDescription(final calitem ci, final SaneDate sdWhen, StringBuffer bufAppend){
		if (sdWhen!=null && sdWhen.getDOW()==2) {
			bufAppend.append("Yuck - Monday - ");
		}
        return bufAppend.append(ci.description);
    }

}
