'
'	This script will update your 2.1.8 database schema to
'	version 2.1.9. If your Access database is not in the default
'	location, you will need to change the DSN String below.
'
'	One Side Note: Because Access is brain dead it wont display
'	queries created this way.  Refer to KB Article Q246213 
'	PRB: Views Created Using ADOX Are Not Visible in Access 2000

const DSN_STRING="provider=Microsoft.Jet.OLEDB.4.0;data source=c:\Program Files\MH Software\Connect Daily\TCBase\webapps\calendar\WEB-INF\sql\access\calendar.mdb;"


dim oConn, cat



'
'	Prepare the connection and catalog object.
'
set oConn=WScript.CreateObject("ADODB.Connection")
oConn.Open DSN_STRING
set cat=WScript.Createobject("ADOX.Catalog")
set cat.activeConnection=oConn

oConn.execute "alter table calendar add column default_style integer;"
cat.Tables("calendar").Columns("default_style").Properties("Default") = 0
oConn.execute "update calendar set default_style=0 where default_style is null;"

oConn.execute "alter table calitem add column style_id integer;"
cat.Tables("calitem").Columns("style_id").Properties("Default") = 0
oConn.execute "update calitem set style_id=0 where style_id is null;"

oConn.Execute "drop view vCalendar;"
oConn.Execute "create view vCalendar as SELECT calendar.*, iif(isnull([users].[full_name]), [users].[user_name], [users].[full_name]) AS owner_name FROM users RIGHT JOIN calendar ON [users].[user_id]=[calendar].[owner];"

oConn.Execute "drop view vCalendarUser;"
oConn.Execute "create view vCalendarUser as SELECT caluser.calendar_id, calendar.name, caluser.user_id, users.user_name, iif(isnull(users.full_name),users.user_name,users.full_name) AS full_name "+_
	"FROM users INNER JOIN (CalUser INNER JOIN calendar ON calendar.calendar_id = caluser.calendar_id) ON CalUser.User_ID=Users.User_ID;"

oConn.Execute "drop View vCalGroup;"
oConn.Execute "create view vCalGroup as SELECT calgroup.*, iif(isnull([users].[full_name]),[users].[user_name],[users].[full_name]) AS owner_name "+_
	"FROM users INNER JOIN calgroup ON [users].[user_id]=[calgroup].[owner];"


oConn.Execute "drop view vCalGroupUser;"
oConn.Execute "create view vCalGroupUser as SELECT [calgroupuser].[cal_group_id], [calgroupuser].[user_id], iif(isnull([users].[full_name]),[users].[user_name], [users].[full_name]) AS full_name, [calgroup].[title] AS cal_group_title "+_
	"FROM users INNER JOIN (calgroup INNER JOIN calgroupuser ON [calgroup].[cal_group_id]=[calgroupuser].[cal_group_id]) ON [users].[user_id]=[calgroupuser].[user_id];"


oConn.Execute "drop view vCalItem;"
oConn.Execute "Create View vCalItem as SELECT calitem.*, IIf(isnull([users].[full_name]),[users].[user_name],[users].[full_name]) AS Owner_name "+_
	"FROM users LEFT JOIN calitem ON [users].[user_id]=[calitem].[owner];"


oConn.Execute "drop view vResourceApprover;"
oConn.Execute "Create View vResourceApprover as SELECT [resourceapprover].[resource_id], [resourceapprover].[approver_id], [resources].[resource_type_id], [resources].[resource_name], iif(isnull([users].[full_name]),[users].[user_name],[users].[full_name]) AS full_name, [resourcetype].[type_description] "+_
	"FROM users INNER JOIN (resourcetype INNER JOIN (resources INNER JOIN resourceapprover ON [resources].[resource_id]=[resourceapprover].[resource_id]) ON [resourcetype].[resource_type_id]=[resources].[resource_type_id]) "+_
	"ON [users].[user_id]=[resourceapprover].[approver_id];"

oConn.Execute "update users set security_level=security_level+4096 where security_level < 4096
oConn.Execute "update cd_dbversion set version_str='2.1.9';"

oConn.close
set oConn=nothing

WScript.Echo "Schema is now updated to version 2.1.9"

