option explicit
'
'	This script will update your 3.0.x database schema to
'	version 3.1.0. If your Access database is not in the default
'	location, you will need to change the DSN String below.
'
'	One Side Note: Because Access is brain dead it wont display
'	queries created this way.  Refer to KB Article Q246213 
'	PRB: Views Created Using ADOX Are Not Visible in Access 2000

const DSN_STRING="provider=Microsoft.Jet.OLEDB.4.0;data source=Calendar.mdb;"
const adParamInput=1
Const adSmallInt = 2
Const adInteger = 3
const adDate=7
const adGUID = 72
Const adVarWChar = 202
Const adDBDate = 133
Const adDBTime = 134
Const adDBTimeStamp = 135
Const adLongVarWChar = 203
const adKeyPrimary=1
const adKeyForeign=2
const adKeyUnique=3

const adRICascade=1
const adRINone=0

const adColNullable=2

sub addColumn(oTable,cName,iType,iColSize,xDefault,bNullable,bAutoIncrement)
if isempty(iColSize)  then
   oTable.Columns.Append cName,iType
else
   oTable.Columns.Append cName,iType,iColSize
end if

if bNullable then
      ' oTable.Columns(cName).Attributes=adColNullable
      
      oTable.columns(cName).Properties("Nullable")=true
      if iType=adVarWChar or iType=adLongVarWChar then
            oTable.Columns(cName).properties("Jet OLEDB:Allow Zero Length")=false
      end if
else
   oTable.columns(cName).Properties("Nullable")=false
  if not isempty(xDefault) then
   oTable.columns(cName).Properties("Default")=xDefault
   end if
   if iType=adVarWChar or iType=adLongVarWChar then
      oTable.Columns(cName).properties("Jet OLEDB:Allow Zero Length")=false
   end if
end if
   if bAutoIncrement then
      oTable.Columns(cName).Properties("AutoIncrement")=true
   end if
end sub

function containsTable(oCatalog,cTableName)
dim oT,i,lResult
lResult=false
cTableName=ucase(cTableName)
for each oT in oCatalog.Tables
   if ucase(oT.Name)=cTableName then
      lResult=true
   end if
next
containsTable=lResult
end function

sub dropTable(oCatalog, cTableName)
dim oKey,oTable

set oTable=oCatalog.tables(cTableName)

for each oKey in oTable.Keys
      oTable.Keys.Delete oKey.Name
next

oCatalog.Tables.Delete cTableName

end sub

sub addForeignKey(oTable,cName,cColumn,cRefTable,cRefColumn,bCascadeDelete)

dim oKey
set oKey=WScript.CreateObject("ADOX.Key")
oKey.Name=cName
oKey.Type=adKeyForeign
oKey.Columns.append cColumn
oKey.RelatedTable=cRefTable

if isempty(cRefColumn) then
   oKey.Columns(cColumn).RelatedColumn=cColumn
else
   oKey.Columns(cColumn).RelatedColumn=cRefColumn
end if
if bCascadeDelete then
   oKey.DeleteRule=adRICascade
end if
oTable.keys.append oKey
end sub


dim oConn, cat, oTable, oKey,oCol,oIndex,oView, oRS,lAddToken

'
'	Prepare the connection and catalog object.
'
set oConn=WScript.CreateObject("ADODB.Connection")
oConn.Open DSN_STRING
set cat=WScript.Createobject("ADOX.Catalog")
set cat.activeConnection=oConn
set oTable=cat.tables("Users")

oConn.execute "alter table calendar add column def_privacy integer null"
cat.tables("calendar").columns("def_privacy").Properties("Default")=0
oConn.execute "update calendar set def_privacy=0 where def_privacy is null;"

oConn.Execute "alter table Resources add resource_shared integer null"
oConn.Execute "alter table Resources add description text null"
cat.tables("resources").columns("resource_shared").Properties("Default")=0
oConn.execute "update resources set resource_shared=0 where resource_shared is null;"

oConn.Execute "alter table calitem add link_type integer null"
oConn.Execute "alter table calitem add tz_string varchar(64)"
cat.tables("calitem").columns("link_type").Properties("Default")=0
oConn.Execute "update calitem set link_type=0 where link_type is null;"
oConn.Execute "update calitem set link_type=1 where parent_item>0;"

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  create the Attachments
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''      
set oTable =CreateObject("ADOX.Table")
oTable.ParentCatalog=cat
oTable.name="Attachments"
addColumn oTable,"attachment_id",adInteger,empty,empty,false,true
addColumn oTable,"file_size",adInteger,empty,0,false,false
addColumn oTable,"file_name",adVarWChar,200,empty,false,false
addColumn oTable,"def_description",adLongVarWChar,empty,empty,true,false
addColumn oTable,"mime_type",adVarWChar,64,empty,true,false
addColumn oTable,"md5sum",adVarWChar,32,empty,true,false
addColumn oTable,"date_uploaded",adDate,empty,"now()",false,false

set oKey=WScript.CreateObject("ADOX.Key")
oKey.NAME="PK_Attachments"
oKey.Columns.append "attachment_id"
oTable.keys.append oKey

set oIndex=CreateObject("ADOX.Index")
oIndex.name="IX_ATT_FNAME"
oIndex.columns.append "file_name"
oTable.Indexes.append oIndex

set oIndex=CreateObject("ADOX.Index")
oIndex.name="IX_ATT_MIMEFNAME"
oIndex.columns.append "mime_type"
oIndex.columns.append "file_name"
oTable.Indexes.append oIndex

cat.tables.append oTable



set oTable=CreateObject("ADOX.Table")
oTable.parentCatalog=cat
oTable.Name="CalItemAttachments"
addColumn oTable,"attachment_id",adInteger,empty,empty,false,false
addColumn oTable,"cal_item_id",adInteger,empty,empty,false,false
addColumn oTable,"file_name",adVarWChar,200,empty,false,false
addColumn oTable,"description",adLongVarWChar,empty,empty,true,false

set oKey=WScript.CreateObject("ADOX.Key")
oKey.Name="PK_CIA"
oKey.columns.append "attachment_id"
oKey.columns.append "cal_item_id"
oTable.Keys.append oKey
addForeignKey oTable,"FK_CIA_ATT","attachment_id","Attachments",empty,false
addForeignKey oTable,"FK_CIA_CI","cal_item_id","calitem",empty,true

cat.tables.append oTable


set oRS=oConn.execute("select * from candidatetokens where token='tok_OwnApproved'")
lAddToken=oRS.eof
oRS.close
if lAddToken then
   oConn.Execute "insert into candidatetokens (object_type_id,instance,token,is_default,creator_default,sort_order) values ("+_
   "32768,1,'tok_OwnApproved',0,0,14);"
end if


oConn.Execute "CREATE VIEW vMimeTypes as select [mime_type],count(*) as ref_count from attachments group by mime_type"

oConn.Execute "update cd_dbversion set version_str='3.1.0';"

oConn.close
set oConn=nothing

WScript.Echo "Schema is now updated to version 3.1.0"

