option explicit
'
'	This script will update your 3.1.x database schema to
'	version 3.2.0. If your Access database is not in the default
'	location, you will need to change the DSN String below.
'
'	One Side Note: Because Access is brain dead it wont display
'	queries created this way.  Refer to KB Article Q246213
'	PRB: Views Created Using ADOX Are Not Visible in Access 2000

const DSN_STRING="provider=Microsoft.Jet.OLEDB.4.0;data source=Calendar.mdb;"
const adParamInput=1
Const adSmallInt = 2
Const adInteger = 3
const adDate=7
const adGUID = 72
Const adVarWChar = 202
Const adDBDate = 133
Const adDBTime = 134
Const adDBTimeStamp = 135
Const adLongVarWChar = 203
const adKeyPrimary=1
const adKeyForeign=2
const adKeyUnique=3

const adRICascade=1
const adRINone=0

const adColNullable=2

sub addColumn(oTable,cName,iType,iColSize,xDefault,bNullable,bAutoIncrement)
if isempty(iColSize)  then
   oTable.Columns.Append cName,iType
else
   oTable.Columns.Append cName,iType,iColSize
end if

if bNullable then
      ' oTable.Columns(cName).Attributes=adColNullable

      oTable.columns(cName).Properties("Nullable")=true
      if iType=adVarWChar or iType=adLongVarWChar then
            oTable.Columns(cName).properties("Jet OLEDB:Allow Zero Length")=false
      end if
else
   oTable.columns(cName).Properties("Nullable")=false
  if not isempty(xDefault) then
   oTable.columns(cName).Properties("Default")=xDefault
   end if
   if iType=adVarWChar or iType=adLongVarWChar then
      oTable.Columns(cName).properties("Jet OLEDB:Allow Zero Length")=false
   end if
end if
   if bAutoIncrement then
      oTable.Columns(cName).Properties("AutoIncrement")=true
   end if
end sub

function containsTable(oCatalog,cTableName)
dim oT,i,lResult
lResult=false
cTableName=ucase(cTableName)
for each oT in oCatalog.Tables
   if ucase(oT.Name)=cTableName then
      lResult=true
   end if
next
containsTable=lResult
end function

sub dropTable(oCatalog, cTableName)
dim oKey,oTable

set oTable=oCatalog.tables(cTableName)

for each oKey in oTable.Keys
      oTable.Keys.Delete oKey.Name
next

oCatalog.Tables.Delete cTableName

end sub

sub addForeignKey(oTable,cName,cColumn,cRefTable,cRefColumn,bCascadeDelete)

dim oKey
set oKey=WScript.CreateObject("ADOX.Key")
oKey.Name=cName
oKey.Type=adKeyForeign
oKey.Columns.append cColumn
oKey.RelatedTable=cRefTable

if isempty(cRefColumn) then
   oKey.Columns(cColumn).RelatedColumn=cColumn
else
   oKey.Columns(cColumn).RelatedColumn=cRefColumn
end if
if bCascadeDelete then
   oKey.DeleteRule=adRICascade
end if
oTable.keys.append oKey
end sub


dim oConn, cat, oTable, oKey,oCol,oIndex,oView, oRS,lAddToken

'
'	Prepare the connection and catalog object.
'
set oConn=WScript.CreateObject("ADODB.Connection")
oConn.Open DSN_STRING
set cat=WScript.Createobject("ADOX.Catalog")
set cat.activeConnection=oConn
set oTable=cat.tables("Users")



oConn.execute "alter table users add lastblogin timestamp null;"
oConn.execute "alter table users add pwhistory text null;"
oConn.execute "alter table users add blogincount integer;"
oConn.execute "alter table users add grlogrem integer;"
oConn.execute "alter table users add pwchangedate timestamp null;"
oConn.execute "alter table users add plannerstart varchar(32);"
oConn.execute "alter table users add plannerend varchar(32);"

oConn.execute "update users set blogincount=0,plannerstart='0800',plannerend='1700',grlogrem=3 where plannerstart is null;"
cat.tables("users").columns("blogincount").Properties("Default")=0
cat.tables("users").columns("grlogrem").Properties("Default")=3
cat.tables("users").columns("pwchangedate").Properties("Default")="now()"



oConn.execute "alter table calendar add prefs integer;"
oConn.execute "update calendar set prefs=0 where prefs is null;"
cat.tables("calendar").columns("prefs").Properties("Default")=0

oConn.Execute "alter table calitem add itemguid varchar(128)"

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  create the CalGuestMap
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
set oTable =CreateObject("ADOX.Table")
oTable.ParentCatalog=cat
oTable.name="CalGuestMap"
addColumn oTable,"mapentry_id",adInteger,empty,empty,false,true
addColumn oTable,"strexpr",adVarWChar,128,empty,false,false
addColumn oTable,"guest_user",adInteger,128,empty,false,false

set oKey=WScript.CreateObject("ADOX.Key")
oKey.NAME="PK_CalGuestMap"
oKey.Columns.append "mapentry_id"
oTable.keys.append oKey

addForeignKey oTable,"FK_CGM_USERS","guest_user","Users","User_ID",true

cat.tables.append oTable

oConn.execute "create view vCalGuestMap AS select CGM.*, U.user_name "+_
   "FROM CalGuestMap CGM INNER JOIN Users U ON CGM.guest_user=U.user_id"


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  create the ItemStyles Table
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
set oTable =CreateObject("ADOX.Table")
oTable.ParentCatalog=cat
oTable.name="ItemStyles"
addColumn oTable,"itemstyle_id",adInteger,empty,empty,false,true
addColumn oTable,"std",adVarWChar,200,empty,false,false
addColumn oTable,"hover",adVarWChar,200,empty,true,false
addColumn oTable,"visited",adVarWChar,200,empty,true,false
set oKey=WScript.CreateObject("ADOX.Key")
oKey.NAME="PK_ItemStyles"
oKey.Columns.append "ItemStyle_ID"
oTable.keys.append oKey

cat.tables.append oTable




oConn.Execute "update cd_dbversion set version_str='3.2.0';"

oConn.close
set oConn=nothing

WScript.Echo "Schema is now updated to version 3.2.0"

