option explicit
'
'	This script will update your 3.2.x database schema to
'	version 3.2.0. If your Access database is not in the default
'	location, you will need to change the DSN String below.
'
'	One Side Note: Because Access is brain dead it wont display
'	queries created this way.  Refer to KB Article Q246213
'	PRB: Views Created Using ADOX Are Not Visible in Access 2000

const DSN_STRING="provider=Microsoft.Jet.OLEDB.4.0;data source=Calendar.mdb;"
const adParamInput=1
Const adSmallInt = 2
Const adInteger = 3
const adDate=7
const adGUID = 72
Const adVarWChar = 202
Const adDBDate = 133
Const adDBTime = 134
Const adDBTimeStamp = 135
Const adLongVarWChar = 203
const adKeyPrimary=1
const adKeyForeign=2
const adKeyUnique=3

const adRICascade=1
const adRINone=0

const adColNullable=2

sub addColumn(oTable,cName,iType,iColSize,xDefault,bNullable,bAutoIncrement)
if isempty(iColSize)  then
   oTable.Columns.Append cName,iType
else
   oTable.Columns.Append cName,iType,iColSize
end if

if bNullable then
      ' oTable.Columns(cName).Attributes=adColNullable

      oTable.columns(cName).Properties("Nullable")=true
      if iType=adVarWChar or iType=adLongVarWChar then
            oTable.Columns(cName).properties("Jet OLEDB:Allow Zero Length")=false
      end if
else
   oTable.columns(cName).Properties("Nullable")=false
  if not isempty(xDefault) then
   oTable.columns(cName).Properties("Default")=xDefault
   end if
   if iType=adVarWChar or iType=adLongVarWChar then
      oTable.Columns(cName).properties("Jet OLEDB:Allow Zero Length")=false
   end if
end if
   if bAutoIncrement then
      oTable.Columns(cName).Properties("AutoIncrement")=true
   end if
end sub

function containsTable(oCatalog,cTableName)
dim oT,i,lResult
lResult=false
cTableName=ucase(cTableName)
for each oT in oCatalog.Tables
   if ucase(oT.Name)=cTableName then
      lResult=true
   end if
next
containsTable=lResult
end function

sub dropTable(oCatalog, cTableName)
dim oKey,oTable

set oTable=oCatalog.tables(cTableName)

for each oKey in oTable.Keys
      oTable.Keys.Delete oKey.Name
next

oCatalog.Tables.Delete cTableName

end sub

sub addForeignKey(oTable,cName,cColumn,cRefTable,cRefColumn,bCascadeDelete)

dim oKey
set oKey=WScript.CreateObject("ADOX.Key")
oKey.Name=cName
oKey.Type=adKeyForeign
oKey.Columns.append cColumn
oKey.RelatedTable=cRefTable

if isempty(cRefColumn) then
   oKey.Columns(cColumn).RelatedColumn=cColumn
else
   oKey.Columns(cColumn).RelatedColumn=cRefColumn
end if
if bCascadeDelete then
   oKey.DeleteRule=adRICascade
end if
oTable.keys.append oKey
end sub


dim oConn, cat, oTable, oKey,oCol,oIndex,oView, oRS,lAddToken

'
'	Prepare the connection and catalog object.
'
set oConn=WScript.CreateObject("ADODB.Connection")
oConn.Open DSN_STRING
set cat=WScript.Createobject("ADOX.Catalog")
set cat.activeConnection=oConn

oConn.execute "alter table calendar add default_type integer;"
oConn.execute "update calendar set default_type=0 where default_type is null;"
cat.tables("calendar").columns("default_type").properties("Default")=0

set oTable=cat.tables("CalItem")
oConn.execute "alter table calitem add rinterval integer;"
oConn.execute "update calitem set rinterval=0 where rinterval is null;"

oTable.columns("rinterval").properties("Default")=0

oConn.execute "alter table calitem add [xml_data] text;"


oConn.execute "alter table resourcetype add max_resources integer;"
oConn.execute "update resourcetype set max_resources=0 where max_resources is null;"
cat.tables("resourcetype").columns("max_resources").properties("Default")=0


oConn.execute "alter table resources add descrmode integer;"
oConn.execute "update resources set descrmode=0 where descrmode is null;"
cat.tables("resources").columns("descrmode").properties("Default")=0

oConn.execute "alter table notuseritem add day_list text null;"

oConn.execute "alter table users add user_prefs text null;"

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  create the xmldocs table
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
set oTable =CreateObject("ADOX.Table")
oTable.ParentCatalog=cat
oTable.name="XMLDocs"
addColumn oTable,"xmldoc_id",adInteger,empty,empty,false,true
addColumn oTable,"doc_type",adInteger,empty,empty,false,false
addColumn oTable,"name",adVarWChar,30,empty,false,false
addColumn oTable,"last_update",adDate,empty,"Now()",false,false
addColumn oTable,"xml_doc",adLongVarWChar,empty,empty,false,false

set oKey=WScript.CreateObject("ADOX.Key")
oKey.NAME="PK_XMLDocs"
oKey.Columns.append "xmldoc_id"
oTable.keys.append oKey
cat.tables.append oTable


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  create the caltabs table
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
set oTable =CreateObject("ADOX.Table")
oTable.ParentCatalog=cat
oTable.name="CalTabs"
addColumn oTable,"xmldoc_id",adInteger,empty,empty,false,false
addColumn oTable,"calendar_id",adInteger,empty,empty,false,false
addColumn oTable,"tab_order",adInteger,empty,empty,false,false
set oKey=WScript.CreateObject("ADOX.Key")
oKey.NAME="PK_CalTabs"
oKey.Columns.append "xmldoc_id"
oKey.columns.append "calendar_id"
oTable.keys.append oKey

addForeignKey oTable,"FK_CT_XMLDOC","xmldoc_id","XMLDocs","xmldoc_id",false
addForeignKey oTable,"FK_CT_CAL","calendar_id","Calendar","calendar_id",true

cat.tables.append oTable

cat.tables.delete "ItemStyles"
          
cat.views.delete "vCalItem"
oConn.execute "create view vCalItem AS SELECT calitem.*, " + _
   "IIf(IsNull(users.full_name),users.user_name,users.full_name) AS Owner_name "+ _
   "FROM calitem LEFT JOIN users ON calitem.owner = users.user_id;"

oConn.execute "create view vCalTabs AS SELECT caltabs.*, xmldocs.xml_doc "+_
   "FROM xmldocs INNER JOIN caltabs ON xmldocs.xmldoc_id = caltabs.xmldoc_id;"


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  create the notification_others Table
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
set oTable =CreateObject("ADOX.Table")
oTable.ParentCatalog=cat
oTable.name="Notification_Others"
addColumn oTable,"n_user_id",adInteger,empty,empty,false,false
addColumn oTable,"type_id",adInteger,empty,empty,false,false
addColumn oTable,"entry_id",adInteger,empty,empty,false,false
addColumn oTable,"entity_type",adInteger,empty,empty,false,false
addColumn oTable,"entity_id",adInteger,empty,empty,false,false

set oKey=WScript.CreateObject("ADOX.Key")
oKey.NAME="PK_NO"
oKey.Columns.append "n_user_id"
oKey.Columns.append "type_id"
oKey.Columns.append "entry_id"
oKey.Columns.append "entity_type"
oKey.Columns.append "entity_id"
oTable.keys.append oKey

addForeignKey oTable,"FK_NO_NU","n_user_id","NotificationUser","n_user_id",true
addForeignKey oTable,"FK_NO_TI_OT","type_id","ObjectTypes","object_type_id",false
addForeignKey oTable,"FK_NO_ET_OT","entity_type","ObjectTypes","object_type_id",false
                               
cat.tables.append oTable


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  create the notification_others Table
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
set oTable =CreateObject("ADOX.Table")
oTable.ParentCatalog=cat
oTable.name="Configuration"
addColumn oTable,"config_type",adInteger,empty,empty,false,false
addColumn oTable,"last_updt",adDate,empty,"Now()",false,false
addColumn oTable,"config",adLongVarWChar,empty,empty,false,false

set oKey=WScript.CreateObject("ADOX.Key")
oKey.NAME="PK_CFG"
oKey.Columns.append "config_type"
oTable.keys.append oKey

cat.tables.append oTable

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  Finally, table inserts and deletes
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
oConn.Execute "delete from candidatetokens where object_type_id=32776 and token='tok_View';"
oConn.Execute "delete from objectsecurity where secured_obj_type=32776 and token='tok_View';"
oConn.Execute "INSERT INTO ObjectTypes (object_type_id, type_name, sort_order, table_name, field_name) "+_
    "VALUES (32777,'Reminder',10,null,null);"
oConn.Execute "INSERT INTO ObjectTypes (object_type_id, type_name, sort_order, table_name, field_name) "+_
   "VALUES (32778,'NotificationFilter',11,'NotificationFilter','filter_id');"
oConn.Execute "INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default) "+_
   "VALUES (32775, 0, 'tok_EditPrefs', 6, 1);"
oConn.Execute "INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default) "+_
   "VALUES (32775, 0, 'tok_CreateReminders', 6, 1);"
oConn.Execute "INSERT INTO CandidateTokens (object_type_id, instance, token, sort_order,is_default) "+_
   "VALUES (32777, 0, 'tok_AddOthersRem',8,0);"
oConn.Execute "INSERT INTO CandidateTokens (object_type_id, instance, token, sort_order,is_default) "+_
   "VALUES (32778, 0, 'tok_AddOthersFilt',9,0);"
oConn.Execute "INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default) "+_
    "VALUES (32775, 0, 'tok_CustomFieldDef', 10, 0);"
oConn.Execute "Insert into objectsecurity (entity_id,entity_type,secured_obj_type,secured_obj_id,token) "+_
   "select groups.group_id,1,32775,-1,candidatetokens.Token "+_
   "from groups,candidatetokens "+_
   "where "+_
   "candidatetokens.instance=0 AND "+_
   "candidatetokens.object_type_id=32775 AND "+_
   "candidatetokens.is_default=1 AND "+_
   "candidatetokens.token in ('tok_EditPrefs','tok_CreateReminders');"

oConn.Execute "update cd_dbversion set version_str='3.3.0';"

oConn.close
set oConn=nothing

WScript.Echo "Schema is now updated to version 3.3.0"

