option explicit
'
'	This script will update your 3.3.x database schema to
'	version 3.4.0. If your Access database is not in the default
'	location, you will need to change the DSN String below.
'
'	One Side Note: Because Access is brain dead it wont display
'	queries created this way.  Refer to KB Article Q246213
'	PRB: Views Created Using ADOX Are Not Visible in Access 2000

const DSN_STRING="provider=Microsoft.Jet.OLEDB.4.0;data source=Calendar.mdb;"
const adParamInput=1
Const adSmallInt = 2
Const adInteger = 3
const adDate=7
const adGUID = 72
Const adVarWChar = 202
Const adDBDate = 133
Const adDBTime = 134
Const adDBTimeStamp = 135
Const adLongVarWChar = 203
const adKeyPrimary=1
const adKeyForeign=2
const adKeyUnique=3

const adRICascade=1
const adRINone=0

const adColNullable=2

sub addColumn(oTable,cName,iType,iColSize,xDefault,bNullable,bAutoIncrement)
if isempty(iColSize)  then
   oTable.Columns.Append cName,iType
else
   oTable.Columns.Append cName,iType,iColSize
end if

if bNullable then
      ' oTable.Columns(cName).Attributes=adColNullable

      oTable.columns(cName).Properties("Nullable")=true
      if iType=adVarWChar or iType=adLongVarWChar then
            oTable.Columns(cName).properties("Jet OLEDB:Allow Zero Length")=false
      end if
else
   oTable.columns(cName).Properties("Nullable")=false
  if not isempty(xDefault) then
   oTable.columns(cName).Properties("Default")=xDefault
   end if
   if iType=adVarWChar or iType=adLongVarWChar then
      oTable.Columns(cName).properties("Jet OLEDB:Allow Zero Length")=false
   end if
end if
   if bAutoIncrement then
      oTable.Columns(cName).Properties("AutoIncrement")=true
   end if
end sub

function containsTable(oCatalog,cTableName)
dim oT,i,lResult
lResult=false
cTableName=ucase(cTableName)
for each oT in oCatalog.Tables
   if ucase(oT.Name)=cTableName then
      lResult=true
   end if
next
containsTable=lResult
end function

sub dropTable(oCatalog, cTableName)
dim oKey,oTable

set oTable=oCatalog.tables(cTableName)

for each oKey in oTable.Keys
      oTable.Keys.Delete oKey.Name
next

oCatalog.Tables.Delete cTableName

end sub

sub addForeignKey(oTable,cName,cColumn,cRefTable,cRefColumn,bCascadeDelete)

dim oKey
set oKey=WScript.CreateObject("ADOX.Key")
oKey.Name=cName
oKey.Type=adKeyForeign
oKey.Columns.append cColumn
oKey.RelatedTable=cRefTable

if isempty(cRefColumn) then
   oKey.Columns(cColumn).RelatedColumn=cColumn
else
   oKey.Columns(cColumn).RelatedColumn=cRefColumn
end if
if bCascadeDelete then
   oKey.DeleteRule=adRICascade
end if
oTable.keys.append oKey
end sub


dim oConn, cat, oTable, oKey,oCol,oIndex,oView, oRS,lAddToken

'
'	Prepare the connection and catalog object.
'
set oConn=WScript.CreateObject("ADODB.Connection")
oConn.Open DSN_STRING
set cat=WScript.Createobject("ADOX.Catalog")
set cat.activeConnection=oConn

oConn.execute "alter table resourcetype add is_location integer;"
oConn.execute "update resourcetype set is_location=0 where is_location is null;"
cat.tables("resourcetype").columns("is_location").properties("Default")=0

oConn.execute "update notuseritem set days_offset=0 where days_offset is null;"
cat.tables("notuseritem").columns("days_offset").properties("Default")=0


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  create the calimportlinks table
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
set oTable =CreateObject("ADOX.Table")
oTable.ParentCatalog=cat
oTable.name="calimportlinks"
addColumn oTable,"callink_id",adInteger,empty,empty,false,true
addColumn oTable,"calendar_id",adInteger,empty,empty,false,false
addColumn oTable,"refresh_interval",adInteger,empty,empty,false,false
addColumn oTable,"enabled",adInteger,empty,0,false,false
addColumn oTable,"last_executed",adDate,empty,"Now()",false,false
addColumn oTable,"last_messages",adLongVarWChar,empty,empty,true,false
addColumn oTable,"settings",adLongVarWChar,empty,empty,true,false

set oKey=WScript.CreateObject("ADOX.Key")
oKey.NAME="PK_CILINKS"
oKey.Columns.append "callink_id"
oTable.keys.append oKey

addForeignKey oTable,"FK_CIL_CALENDAR","calendar_id","calendar","calendar_id",true

cat.tables.append oTable


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  create the logentry table
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
set oTable =CreateObject("ADOX.Table")
oTable.ParentCatalog=cat
oTable.name="logentry"
addColumn oTable,"entry_id",adInteger,empty,empty,false,true
addColumn oTable,"object_type",adInteger,empty,empty,false,false
addColumn oTable,"object_id",adInteger,empty,empty,false,false
addColumn oTable,"twhen",adDate,empty,"Now()",false,false
addColumn oTable,"user_name",adVarWChar,80,empty,true,false
addColumn oTable,"message",adLongVarWChar,empty,empty,true,false

set oKey=WScript.CreateObject("ADOX.Key")
oKey.NAME="PK_LOGENTRY"
oKey.Columns.append "entry_id"
oTable.keys.append oKey

set oIndex=CreateObject("ADOX.Index")
oIndex.name="IX_LE_OTOI"
oIndex.columns.append "object_type"
oIndex.columns.append "object_id"
oTable.Indexes.append oIndex

cat.tables.append oTable


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  create the undoinfo table
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
set oTable =CreateObject("ADOX.Table")
oTable.ParentCatalog=cat
oTable.name="undoinfo"
addColumn oTable,"entry_id",adInteger,empty,empty,false,true
addColumn oTable,"user_id",adInteger,empty,empty,false,false
addColumn oTable,"object_type",adInteger,empty,empty,false,false
addColumn oTable,"object_id",adInteger,empty,empty,false,false
addColumn oTable,"import_type",adInteger,empty,empty,false,false
addColumn oTable,"twhen",adDate,empty,"Now()",false,false
addColumn oTable,"import_source",adLongVarWChar,empty,empty,true,false
addColumn oTable,"insert_ranges",adLongVarWChar,empty,empty,true,false
addColumn oTable,"undo_data",adLongVarWChar,empty,empty,true,false

set oKey=WScript.CreateObject("ADOX.Key")
oKey.NAME="PK_LOGENTRY"
oKey.Columns.append "entry_id"
oTable.keys.append oKey

addForeignKey oTable,"FK_UI_U","user_id","users","user_id",true


cat.tables.append oTable

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  Changed Views
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
cat.views.delete "vResource"
oConn.execute "CREATE VIEW vResource AS SELECT resources.*, resourcetype.type_description, resourcetype.is_location "+_
   "FROM resources  INNER JOIN resourcetype ON resourcetype.Resource_Type_id=resources.Resource_Type_id"

cat.views.delete "vCalItemResource"
oConn.execute "CREATE VIEW vCalItemResource AS "+_
   "SELECT "+_
   	"calitemresource.cal_item_id, "+_
   	"calitemresource.resource_id, "+_
   	"calitemresource.approved, "+_
   	"resourcetype.type_description, "+_
   	"resourcetype.is_location, "+_
   	"resources.resource_type_id, "+_
   	"resources.resource_name "+_
  	"FROM resourcetype INNER JOIN (resources INNER JOIN calitemresource ON resources.resource_id=calitemresource.resource_id) ON resourcetype.resource_type_id=resources.resource_type_id;"
   		
                                            
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  Finally, table inserts and deletes
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

oConn.execute "update objecttypes set table_name='NotificationFilter' where object_type_id=32778 and table_name<>'NotificationFilter';"
oConn.execute "delete from objecttypes where object_type_id=32779;"
oConn.execute "INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name) "+_
   "VALUES (32779,'NotificationUser',12,'NotificationUser','n_user_id');"
oConn.execute "INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name) "+_
    "VALUES (32780,'CalItem',13,'CalItem','cal_item_id');"

oConn.Execute "update cd_dbversion set version_str='3.4.0';"

oConn.close
set oConn=nothing

WScript.Echo "Schema is now updated to version 3.4.0"

