connect 'jdbc:derby:calendardb;create=true';
~
DROP VIEW vNotUserItem
~
DROP VIEW vObjectSecurity
~
DROP VIEW vCandidateTokens
~
DROP VIEW vGroupUsers
~
DROP VIEW vCalItem
~
DROP VIEW vCalItemResource
~
DROP VIEW vResource
~
DROP VIEW vResourceGroupResource
~
DROP VIEW vCalCalendar
~
DROP VIEW vObjectUsers
~
DROP VIEW vMimeTypes
~
DROP VIEW vCalGuestMap
~
DROP VIEW vCalTabs
~
CREATE VIEW vObjectUsers AS
SELECT
 secured_obj_id,
 secured_obj_type,
 token,
 GU.group_id,
 CASE WHEN entity_type=2 THEN entity_id ELSE user_id END AS user_id,
 OT.type_name,
 OT.sort_order,
 OT.table_name,
 OT.field_name
FROM
 objectsecurity
 LEFT OUTER JOIN groupusers GU
 ON objectsecurity.entity_type=1 AND GU.group_id=objectsecurity.entity_id
 INNER JOIN objecttypes OT
 ON objectsecurity.secured_obj_type=OT.object_type_id
~
CREATE VIEW vCalCalendar AS
SELECT
 CC.calendar_id,
 CC.child_id,
 CC.display_opts,
 CCP.name AS parent_name,
 CCC.Name AS child_name
FROM
 calcalendar CC
 INNER JOIN calendar CCP ON CCP.calendar_id=CC.calendar_id
 INNER JOIN calendar CCC ON CCC.calendar_id=CC.child_id
~
CREATE VIEW vResource AS
SELECT
 R.resource_id,
 R.resource_type_id,
 R.active,
 R.location_id,
 R.resource_name,
 R.resource_shared,
 R.description,
 R.attributes,
 RT.type_description,
 LOC.location_name,
 RT.is_location
FROM
 resources R
 INNER JOIN resourcetype RT ON RT.Resource_Type_id=R.Resource_Type_id
 LEFT OUTER JOIN location LOC on LOC.location_id=R.location_id
~
CREATE VIEW vCalItemResource AS
SELECT
 CIR.cal_item_id,
 CIR.resource_id,
 CIR.approved,
 RT.type_description,
 RT.is_location,
 R.resource_type_id,
 R.location_id,
 R.resource_name
FROM
 calitemresource CIR
 INNER JOIN resources R ON R.Resource_id=CIR.Resource_id
 INNER JOIN resourcetype RT ON RT.Resource_type_id=R.Resource_Type_id
~
CREATE VIEW vCalItem AS
SELECT
 CI.*,
 case when U.Full_Name is null then U.User_Name else U.Full_Name end as owner_name
From
 calitem CI
 LEFT OUTER JOIN users U
 ON CI.owner=U.user_id
~
CREATE VIEW vGroupUsers AS
SELECT
 GU.group_id,
 GU.user_id,
 G.group_name,
 U.user_name,
 U.full_name
FROM
 groupusers GU
 INNER JOIN groups G ON GU.group_id=G.group_id
 INNER JOIN users U ON GU.user_id=U.user_id
~
CREATE VIEW vObjectSecurity AS
SELECT
 OSEC.*,
 OT.type_name,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order
FROM
 objectsecurity OSEC
 INNER JOIN objecttypes OT
 ON OSEC.secured_obj_type=OT.object_type_id
 INNER JOIN candidatetokens CT
 ON OSEC.secured_obj_type=CT.object_type_id AND OSEC.token=CT.token
~
CREATE VIEW vCandidateTokens AS
SELECT
 CT.*,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order,
 OT.type_name
FROM
 candidatetokens CT
 INNER JOIN objecttypes OT
 ON CT.object_type_id=OT.object_type_id
~
CREATE VIEW vNotUserItem AS
select NUI.*,
 CI.description
from notuseritem NUI
 LEFT JOIN calitem CI
 ON NUI.cal_item_id=CI.cal_item_id
~
CREATE VIEW vResourceGroupResource AS
Select
 RGR.*,
 R.resource_name
from resourcegroupresource RGR
 INNER JOIN resources R
 ON R.Resource_ID=RGR.Resource_ID
~
CREATE VIEW vMimeTypes as
select
 mime_type,
 count(*) as ref_count
from attachments
group by mime_type
~
create view vCalGuestMap AS
select CGM.*,
 U.user_name
FROM
 calguestmap CGM
 INNER JOIN users U
 ON CGM.guest_user=U.user_id
~
CREATE VIEW vCalTabs as
select
 caltabs.xmldoc_id,
 caltabs.calendar_id,
 caltabs.tab_order,
 xmldocs.xml_doc
from caltabs
 INNER JOIN xmldocs
 ON xmldocs.xmldoc_id=caltabs.xmldoc_id
~
update cd_dbversion set version_str='3.2.0'
~
