SET ANSI_PADDING OFF
DROP VIEW vNotUserItem
~
DROP VIEW vObjectSecurity
~
DROP VIEW vCandidateTokens
~
DROP VIEW vGroupUsers
~
DROP VIEW vCalItem
~
DROP VIEW vCalItemResource
~
DROP VIEW vResource
~
DROP VIEW vResourceGroupResource
~
DROP VIEW vCalCalendar
~
DROP VIEW vObjectUsers
~
DROP VIEW vMimeTypes
~
DROP VIEW vCalGuestMap
~
DROP VIEW vCalTabs
~
alter table resourcetype add is_location int DEFAULT 0
~
update resourcetype set is_location=0 where is_location is null
~
UPDATE notuseritem set days_offset=0 where days_offset is null
~
alter table notuseritem add constraint DF_NUI_DO default(0) for days_offset
~
DROP TABLE undoinfo
~
CREATE TABLE calimportlinks (
 callink_id int NOT NULL PRIMARY KEY IDENTITY,
 calendar_id int NOT NULL,
 refresh_interval int NOT NULL,
 enabled int DEFAULT 0 NOT NULL,
 last_executed DateTime NOT NULL,
 last_messages TEXT NULL,
 settings TEXT NULL,
 CONSTRAINT FK_CIL_CAL FOREIGN KEY (calendar_id) references calendar (calendar_id) ON DELETE CASCADE
 )
~
CREATE INDEX IX_CIL_CAL on calimportlinks (calendar_id)
~
CREATE TABLE logentry (
 entry_id int NOT NULL PRIMARY KEY IDENTITY,
 object_type int NOT NULL,
 object_id int NOT NULL,
 twhen DateTime NOT NULL,
 user_name varchar(80) NULL,
 message TEXT NULL
 )
~
CREATE INDEX IX_LE_OTOI ON logentry (object_type,object_id)
~
CREATE TABLE undoinfo (
 entry_id int NOT NULL PRIMARY KEY IDENTITY,
 user_id int NOT NULL,
 object_type int DEFAULT -1 NOT NULL,
 object_id int DEFAULT -1 NOT NULL,
 import_type int DEFAULT 0 NOT NULL,
 twhen DateTime NOT NULL,
 import_source TEXT NULL,
 insert_ranges TEXT NULL,
 undo_data TEXT NULL,
 CONSTRAINT FK_UI_U FOREIGN KEY (user_id) references users (user_id) ON DELETE CASCADE
 )
~
CREATE INDEX IX_UNDO_UID on undoinfo (user_id)
~
delete from objecttypes where object_type_id=32779
~
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32779,'NotificationUser',12,'NotificationUser','n_user_id')
~
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32780,'CalItem',13,'CalItem','cal_item_id')
~
update cd_dbversion set version_str='3.4.0'
~
CREATE VIEW vObjectUsers AS
SELECT
 secured_obj_id,
 secured_obj_type,
 token,
 GU.group_id,
 CASE WHEN entity_type=2 THEN entity_id ELSE user_id END AS user_id,
 OT.type_name,
 OT.sort_order,
 OT.table_name,
 OT.field_name
FROM
 objectsecurity
 LEFT OUTER JOIN groupusers GU
 ON objectsecurity.entity_type=1 AND GU.group_id=objectsecurity.entity_id
 INNER JOIN objecttypes OT
 ON objectsecurity.secured_obj_type=OT.object_type_id
~
CREATE VIEW vCalCalendar AS
SELECT
 CC.calendar_id,
 CC.child_id,
 CC.display_opts,
 CCP.name AS parent_name,
 CCC.Name AS child_name
FROM
 calcalendar CC
 INNER JOIN calendar CCP ON CCP.calendar_id=CC.calendar_id
 INNER JOIN calendar CCC ON CCC.calendar_id=CC.child_id
~
CREATE VIEW vResource AS
SELECT
 R.resource_id,
 R.resource_type_id,
 R.active,
 R.location_id,
 R.resource_name,
 R.resource_shared,
 R.description,
 R.attributes,
 RT.type_description,
 LOC.location_name,
 RT.is_location
FROM
 resources R
 INNER JOIN resourcetype RT ON RT.Resource_Type_id=R.Resource_Type_id
 LEFT OUTER JOIN location LOC on LOC.location_id=R.location_id
~
CREATE VIEW vCalItemResource AS
SELECT
 CIR.cal_item_id,
 CIR.resource_id,
 CIR.approved,
 RT.type_description,
 RT.is_location,
 R.resource_type_id,
 R.location_id,
 R.resource_name
FROM
 calitemresource CIR
 INNER JOIN resources R ON R.Resource_id=CIR.Resource_id
 INNER JOIN resourcetype RT ON RT.Resource_type_id=R.Resource_Type_id
~
CREATE VIEW vCalItem AS
SELECT
 CI.*,
 coalesce(U.Full_Name, U.User_Name) as owner_Name
From
 calitem CI
 LEFT OUTER JOIN users U
 ON CI.owner=U.user_id
~
CREATE VIEW vGroupUsers AS
SELECT
 GU.group_id,
 GU.user_id,
 G.group_name,
 U.user_name,
 U.full_name
FROM
 groupusers GU
 INNER JOIN groups G ON GU.group_id=G.group_id
 INNER JOIN users U ON GU.user_id=U.user_id
~
CREATE VIEW vObjectSecurity AS
SELECT
 OSEC.*,
 OT.type_name,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order
FROM
 objectsecurity OSEC
 INNER JOIN objecttypes OT
 ON OSEC.secured_obj_type=OT.object_type_id
 INNER JOIN candidatetokens CT
 ON OSEC.secured_obj_type=CT.object_type_id AND OSEC.token=CT.token
~
CREATE VIEW vCandidateTokens AS
SELECT
 CT.*,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order,
 OT.type_name
FROM
 candidatetokens CT
 INNER JOIN objecttypes OT
 ON CT.object_type_id=OT.object_type_id
~
CREATE VIEW vNotUserItem AS
select NUI.*,
 CI.description
from notuseritem NUI
 LEFT JOIN calitem CI
 ON NUI.cal_item_id=CI.cal_item_id
~
CREATE VIEW vResourceGroupResource AS
Select
 RGR.*,
 R.resource_name
from resourcegroupresource RGR
 INNER JOIN resources R
 ON R.Resource_ID=RGR.Resource_ID
~
CREATE VIEW vMimeTypes as
select
 mime_type,
 count(*) as ref_count
from attachments
group by mime_type
~
create view vCalGuestMap AS
select CGM.*,
 U.user_name
FROM
 calguestmap CGM
 INNER JOIN users U
 ON CGM.guest_user=U.user_id
~
CREATE VIEW vCalTabs as
select
 caltabs.xmldoc_id,
 caltabs.calendar_id,
 caltabs.tab_order,
 xmldocs.xml_doc
from caltabs
 INNER JOIN xmldocs
 ON xmldocs.xmldoc_id=caltabs.xmldoc_id
~
~
