
drop function passOneElimination
COMMAND_TERM
delimiter //
CREATE FUNCTION passOneElimination (
        pRecType int,
        pStartDate int,
        pEndDate int,
        pRangeStart int,
        pRangeEnd int
        ) RETURNS int DETERMINISTIC CONTAINS sql
begin
declare iResult int default 0;

declare iStartDate, iEndDate int;

declare INTEGER_MIN_VALUE int default -2147483648;
declare INTEGER_MAX_VALUE int default 2147483647;

set iStartDate=coalesce(pStartDate,INTEGER_MIN_VALUE);
set iEndDate=coalesce(pEndDate,INTEGER_MAX_VALUE);


if (iStartDate<pRangeStart) then
     begin
             if pRangeStart<=iEndDate then
                     set iResult=1;
             end if;
     end;
else
     begin
             if iStartDate=pRangeStart OR iStartDate<=pRangeEnd then
                     set iResult=1;
             end if;
     end;
end if;

RETURN iResult;
end//
delimiter ;//
