DROP VIEW vResourceApprover
~
DROP VIEW vNotUserItem
~
DROP VIEW vObjectSecurity
~
DROP VIEW vCandidateTokens
~
DROP VIEW vGroupUsers
~
DROP VIEW vCalItem
~
DROP VIEW vCalItemResource
~
DROP VIEW vResource
~
DROP VIEW vResourceGroupResource
~
DROP VIEW vCalCalendar
~
DROP VIEW vObjectUsers
~
DROP VIEW vMimeTypes
~
DROP VIEW vCalGuestMap
~
DROP VIEW vCalTabs
~
CREATE SEQUENCE calguestmap_seq
~
CREATE SEQUENCE itemstyles_seq
~
CREATE TABLE CalGuestMap (
 mapentry_id number(10) NOT NULL PRIMARY KEY ,
 strexpr varchar(128) NOT NULL,
 guest_user number(10) NOT NULL,
 CONSTRAINT FK_CGM_U FOREIGN KEY (guest_user) references Users
 )
~
CREATE TABLE ItemStyles (
 itemstyle_id number(10) NOT NULL PRIMARY KEY ,
 std varchar(200) NOT NULL,
 hover varchar(200) NOT NULL,
 visited varchar(200) NOT NULL
 )
~
CREATE TRIGGER CGM_ME_TRIGGER before insert on CalGuestMap
for each row
begin
 select calguestmap_seq.nextval into :new.mapentry_id from dual;
end;
~
CREATE TRIGGER IS_IID_TRIGGER before insert on ItemStyles
for each row
begin
 select itemstyles_seq.nextval into :new.itemstyle_id from dual;
end;
~
alter table calitem add itemguid varchar(128)
~
alter table users add lastblogin TIMESTAMP NULL
~
alter table users add pwhistory CLOB
~
alter table users add plannerstart varchar(32) NULL
~
alter table users add plannerend varchar(32) NULL
~
alter table calendar add prefs number(10) default 0
~
update calendar set prefs=0 where prefs is null
~
alter table users add blogincount number(10) default 0
~
update users set blogincount=0 where blogincount is null
~
alter table users add pwchangedate TIMESTAMP DEFAULT SYSDATE NOT NULL
~
update users set pwchangedate=SYSDATE where pwchangedate is null
~
alter table users add grlogrem number(10) DEFAULT 3
~
update users set grlogrem=99999 where grlogrem is null
~
INSERT INTO CandidateTokens (object_type_id, instance, token, sort_order,is_default,creator_default)
 VALUES (32768, 1, 'tok_OwnApproved', 14, 0, 0)
~
create view vObjectUsers as
SELECT ObjectSecurity.secured_obj_id,
 ObjectSecurity.secured_obj_type,
 ObjectSecurity.token,
 GU.group_id,
 GU.User_ID,
 ObjectTypes.type_name,
 ObjectTypes.sort_order,
 ObjectTypes.table_name,
 ObjectTypes.field_name
FROM ObjectTypes
 RIGHT JOIN (ObjectSecurity inner join GroupUsers GU ON GU.Group_ID=ObjectSecurity.Entity_ID)
 ON ObjectTypes.object_type_id=ObjectSecurity.secured_obj_type
WHERE entity_type=1
UNION ALL SELECT ObjectSecurity.secured_obj_id,
 ObjectSecurity.secured_obj_type,
 ObjectSecurity.token,
 null,
 entity_id,
 ObjectTypes.type_name,
 ObjectTypes.sort_order,
 ObjectTypes.table_name,
 ObjectTypes.field_name
FROM ObjectTypes
 RIGHT JOIN ObjectSecurity
 ON ObjectTypes.object_type_id=ObjectSecurity.secured_obj_type
WHERE entity_type=2
~
CREATE VIEW vCalCalendar AS
SELECT
 CC.calendar_id,
 CC.child_id,
 CC.display_opts,
 CCP.name AS parent_name,
 CCC.Name AS child_name
FROM
 calcalendar CC
 INNER JOIN calendar CCP ON CCP.calendar_id=CC.calendar_id
 INNER JOIN calendar CCC ON CCC.calendar_id=CC.child_id
~
CREATE VIEW vResource AS
SELECT
 R.resource_id,
 R.resource_type_id,
 R.active,
 R.location_id,
 R.resource_name,
 R.resource_shared,
 R.description,
 R.attributes,
 RT.type_description,
 LOC.location_name,
 RT.is_location
FROM
 resources R
 INNER JOIN resourcetype RT ON RT.Resource_Type_id=R.Resource_Type_id
 LEFT OUTER JOIN location LOC on LOC.location_id=R.location_id
~
CREATE VIEW vCalItemResource AS
SELECT
 CIR.cal_item_id,
 CIR.resource_id,
 CIR.approved,
 RT.type_description,
 RT.is_location,
 R.resource_type_id,
 R.location_id,
 R.resource_name
FROM
 calitemresource CIR
 INNER JOIN resources R ON R.Resource_id=CIR.Resource_id
 INNER JOIN resourcetype RT ON RT.Resource_type_id=R.Resource_Type_id
~
CREATE VIEW vCalItem AS
SELECT
 CI.*,
 coalesce(U.Full_Name, U.User_Name) as owner_Name
From
 calitem CI
 LEFT OUTER JOIN users U
 ON CI.owner=U.user_id
~
CREATE VIEW vGroupUsers AS
SELECT
 GU.group_id,
 GU.user_id,
 G.group_name,
 U.user_name,
 U.full_name
FROM
 groupusers GU
 INNER JOIN groups G ON GU.group_id=G.group_id
 INNER JOIN users U ON GU.user_id=U.user_id
~
CREATE VIEW vObjectSecurity AS
SELECT
 OSEC.*,
 OT.type_name,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order
FROM
 objectsecurity OSEC
 INNER JOIN objecttypes OT
 ON OSEC.secured_obj_type=OT.object_type_id
 INNER JOIN candidatetokens CT
 ON OSEC.secured_obj_type=CT.object_type_id AND OSEC.token=CT.token
~
CREATE VIEW vCandidateTokens AS
SELECT
 CT.*,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order,
 OT.type_name
FROM
 candidatetokens CT
 INNER JOIN objecttypes OT
 ON CT.object_type_id=OT.object_type_id
~
CREATE VIEW vNotUserItem AS
select NUI.*,
 CI.description
from notuseritem NUI
 LEFT JOIN calitem CI
 ON NUI.cal_item_id=CI.cal_item_id
~
CREATE VIEW vResourceGroupResource AS
Select
 RGR.*,
 R.resource_name
from resourcegroupresource RGR
 INNER JOIN resources R
 ON R.Resource_ID=RGR.Resource_ID
~
CREATE VIEW vMimeTypes as
select
 mime_type,
 count(*) as ref_count
from attachments
group by mime_type
~
create view vCalGuestMap AS
select CGM.*,
 U.user_name
FROM
 calguestmap CGM
 INNER JOIN users U
 ON CGM.guest_user=U.user_id
~
CREATE VIEW vCalTabs as
select
 caltabs.xmldoc_id,
 caltabs.calendar_id,
 caltabs.tab_order,
 xmldocs.xml_doc
from caltabs
 INNER JOIN xmldocs
 ON xmldocs.xmldoc_id=caltabs.xmldoc_id
~
~
