DROP VIEW vNotUserItem
~
DROP VIEW vObjectSecurity
~
DROP VIEW vCandidateTokens
~
DROP VIEW vGroupUsers
~
DROP VIEW vCalItem
~
DROP VIEW vCalItemResource
~
DROP VIEW vResource
~
DROP VIEW vResourceGroupResource
~
DROP VIEW vCalCalendar
~
DROP VIEW vObjectUsers
~
DROP VIEW vMimeTypes
~
DROP VIEW vCalGuestMap
~
DROP VIEW vCalTabs
~
DROP TABLE itemstyles
~
CREATE SEQUENCE XmlDocs_seq
~
DROP SEQUENCE ItemStyles_seq
~
alter table calendar add default_type number(10) DEFAULT 0
~
update calendar set default_type=0 where default_type is null
~
alter table calitem add rinterval number(10) DEFAULT 0
~
update calitem set rinterval=0 where rinterval is null
~
alter table resourcetype add max_resources number(10) DEFAULT 0
~
update resourcetype set max_resources=0 where max_resources is null
~
alter table resources add descrmode number(10) DEFAULT 0
~
update resources set descrmode=0 where descrmode is null
~
alter table notuseritem add day_list CLOB NULL
~
alter table calitem add xml_data CLOB NULL
~
alter table users add user_prefs CLOB NULL
~
CREATE TABLE xmldocs (
 xmldoc_id number(10) NOT NULL PRIMARY KEY ,
 doc_type number(10) NOT NULL,
 name VARCHAR2(30),
 last_update TIMESTAMP NOT NULL,
 xml_doc CLOB NOT NULL
)
~
CREATE TABLE caltabs (
 xmldoc_id number(10) NOT NULL,
 calendar_id number(10) NOT NULL,
 tab_order number(10) NOT NULL,
 CONSTRAINT PK_CALTABS PRIMARY KEY (calendar_id,xmldoc_id),
 CONSTRAINT FK_CT_CAL FOREIGN KEY (calendar_id) REFERENCES calendar (calendar_id) ON DELETE CASCADE,
 CONSTRAINT FK_CT_XMLDOC FOREIGN KEY (xmldoc_id) REFERENCES xmldocs (xmldoc_id)
)
~
CREATE TABLE notification_others (
 n_user_id number(10) NOT NULL,
 type_id number(10) NOT NULL,
 entry_id number(10) NOT NULL,
 entity_type number(10) NOT NULL,
 entity_id number(10) NOT NULL,
 CONSTRAINT FK_NO_NU FOREIGN KEY (n_user_id) REFERENCES NotificationUser ON DELETE CASCADE,
 CONSTRAINT FK_NO_TI_OT FOREIGN KEY (type_id) REFERENCES ObjectTypes,
 CONSTRAINT FK_NO_ET_OT FOREIGN KEY (entity_type) REFERENCES ObjectTypes,
 CONSTRAINT PK_NO PRIMARY KEY (n_user_id,type_id,entry_id,entity_type,entity_id)
)
~
CREATE TABLE configuration (
 config_type number(10) NOT NULL,
 last_updt TIMESTAMP NOT NULL,
 config CLOB NOT NULL,
 CONSTRAINT PK_CFG PRIMARY KEY (config_type)
 )
~
CREATE TRIGGER XMLDOCS_TB_TRIGGER before insert on xmldocs
for each row
begin
 select xmldocs_seq.nextval into :new.xmldoc_id from dual;
end;
~
delete from candidatetokens where object_type_id=32776 and token='tok_View'
~
delete from objectsecurity where secured_obj_type=32776 and token='tok_View'
~
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32777,'Reminder',10,null,null)
~
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32778,'NotificationFilter',11,'NotificationFilter','filter_id')
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32775, 0, 'tok_EditPrefs', 6, 1)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32775, 0, 'tok_CreateReminders', 6, 1)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32777, 0, 'tok_AddOthersRem',8,0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32778, 0, 'tok_AddOthersFilt',9,0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32775, 0, 'tok_CustomFieldDef', 10, 0)
~
Insert into objectsecurity (entity_id,entity_type,secured_obj_type,secured_obj_id,token)
select groups.group_id,1,32775,-1,candidatetokens.Token
from groups,candidatetokens
where groups.Group_Name in ('Users','Everyone','Admins') AND
candidatetokens.instance=0 AND
candidatetokens.object_type_id=32775 AND
candidatetokens.is_default=1 AND
candidatetokens.token in ('tok_EditPrefs','tok_CreateReminders')
~
update cd_dbversion set version_str='3.3.0'
~
create view vObjectUsers as
SELECT ObjectSecurity.secured_obj_id,
 ObjectSecurity.secured_obj_type,
 ObjectSecurity.token,
 GU.group_id,
 GU.User_ID,
 ObjectTypes.type_name,
 ObjectTypes.sort_order,
 ObjectTypes.table_name,
 ObjectTypes.field_name
FROM ObjectTypes
 RIGHT JOIN (ObjectSecurity inner join GroupUsers GU ON GU.Group_ID=ObjectSecurity.Entity_ID)
 ON ObjectTypes.object_type_id=ObjectSecurity.secured_obj_type
WHERE entity_type=1
UNION ALL SELECT ObjectSecurity.secured_obj_id,
 ObjectSecurity.secured_obj_type,
 ObjectSecurity.token,
 null,
 entity_id,
 ObjectTypes.type_name,
 ObjectTypes.sort_order,
 ObjectTypes.table_name,
 ObjectTypes.field_name
FROM ObjectTypes
 RIGHT JOIN ObjectSecurity
 ON ObjectTypes.object_type_id=ObjectSecurity.secured_obj_type
WHERE entity_type=2
~
CREATE VIEW vCalCalendar AS
SELECT
 CC.calendar_id,
 CC.child_id,
 CC.display_opts,
 CCP.name AS parent_name,
 CCC.Name AS child_name
FROM
 calcalendar CC
 INNER JOIN calendar CCP ON CCP.calendar_id=CC.calendar_id
 INNER JOIN calendar CCC ON CCC.calendar_id=CC.child_id
~
CREATE VIEW vResource AS
SELECT
 R.resource_id,
 R.resource_type_id,
 R.active,
 R.location_id,
 R.resource_name,
 R.resource_shared,
 R.description,
 R.attributes,
 RT.type_description,
 LOC.location_name,
 RT.is_location
FROM
 resources R
 INNER JOIN resourcetype RT ON RT.Resource_Type_id=R.Resource_Type_id
 LEFT OUTER JOIN location LOC on LOC.location_id=R.location_id
~
CREATE VIEW vCalItemResource AS
SELECT
 CIR.cal_item_id,
 CIR.resource_id,
 CIR.approved,
 RT.type_description,
 RT.is_location,
 R.resource_type_id,
 R.location_id,
 R.resource_name
FROM
 calitemresource CIR
 INNER JOIN resources R ON R.Resource_id=CIR.Resource_id
 INNER JOIN resourcetype RT ON RT.Resource_type_id=R.Resource_Type_id
~
CREATE VIEW vCalItem AS
SELECT
 CI.*,
 coalesce(U.Full_Name, U.User_Name) as owner_Name
From
 calitem CI
 LEFT OUTER JOIN users U
 ON CI.owner=U.user_id
~
CREATE VIEW vGroupUsers AS
SELECT
 GU.group_id,
 GU.user_id,
 G.group_name,
 U.user_name,
 U.full_name
FROM
 groupusers GU
 INNER JOIN groups G ON GU.group_id=G.group_id
 INNER JOIN users U ON GU.user_id=U.user_id
~
CREATE VIEW vObjectSecurity AS
SELECT
 OSEC.*,
 OT.type_name,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order
FROM
 objectsecurity OSEC
 INNER JOIN objecttypes OT
 ON OSEC.secured_obj_type=OT.object_type_id
 INNER JOIN candidatetokens CT
 ON OSEC.secured_obj_type=CT.object_type_id AND OSEC.token=CT.token
~
CREATE VIEW vCandidateTokens AS
SELECT
 CT.*,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order,
 OT.type_name
FROM
 candidatetokens CT
 INNER JOIN objecttypes OT
 ON CT.object_type_id=OT.object_type_id
~
CREATE VIEW vNotUserItem AS
select NUI.*,
 CI.description
from notuseritem NUI
 LEFT JOIN calitem CI
 ON NUI.cal_item_id=CI.cal_item_id
~
CREATE VIEW vResourceGroupResource AS
Select
 RGR.*,
 R.resource_name
from resourcegroupresource RGR
 INNER JOIN resources R
 ON R.Resource_ID=RGR.Resource_ID
~
CREATE VIEW vMimeTypes as
select
 mime_type,
 count(*) as ref_count
from attachments
group by mime_type
~
create view vCalGuestMap AS
select CGM.*,
 U.user_name
FROM
 calguestmap CGM
 INNER JOIN users U
 ON CGM.guest_user=U.user_id
~
CREATE VIEW vCalTabs as
select
 caltabs.xmldoc_id,
 caltabs.calendar_id,
 caltabs.tab_order,
 xmldocs.xml_doc
from caltabs
 INNER JOIN xmldocs
 ON xmldocs.xmldoc_id=caltabs.xmldoc_id
~
~
