DROP VIEW vNotUserItem
~
DROP VIEW vObjectSecurity
~
DROP VIEW vCandidateTokens
~
DROP VIEW vGroupUsers
~
DROP VIEW vCalItem
~
DROP VIEW vCalItemResource
~
DROP VIEW vResource
~
DROP VIEW vResourceGroupResource
~
DROP VIEW vCalCalendar
~
DROP VIEW vObjectUsers
~
DROP VIEW vMimeTypes
~
DROP VIEW vCalGuestMap
~
DROP VIEW vCalTabs
~
CREATE SEQUENCE logentry_seq
~
CREATE SEQUENCE calimportlinks_seq
~
CREATE SEQUENCE undoinfo_seq
~
alter table resourcetype add is_location number(10) DEFAULT 0
~
update resourcetype set is_location=0 where is_location is null
~
UPDATE notuseritem set days_offset=0 where days_offset is null
~
ALTER TABLE notuseritem modify days_offset default 0
~
DROP TABLE undoinfo
~
CREATE TABLE calimportlinks (
 callink_id number(10) NOT NULL PRIMARY KEY ,
 calendar_id number(10) NOT NULL,
 refresh_interval number(10) NOT NULL,
 enabled number(10) DEFAULT 0 NOT NULL,
 last_executed TIMESTAMP NOT NULL,
 last_messages CLOB NULL,
 settings CLOB NULL,
 CONSTRAINT FK_CIL_CAL FOREIGN KEY (calendar_id) references calendar (calendar_id) ON DELETE CASCADE
 )
~
CREATE INDEX IX_CIL_CAL on calimportlinks (calendar_id)
~
CREATE TABLE logentry (
 entry_id number(10) NOT NULL PRIMARY KEY ,
 object_type number(10) NOT NULL,
 object_id number(10) NOT NULL,
 twhen TIMESTAMP NOT NULL,
 user_name varchar(80) NULL,
 message CLOB NULL
 )
~
CREATE INDEX IX_LE_OTOI ON logentry (object_type,object_id)
~
CREATE TABLE undoinfo (
 entry_id number(10) NOT NULL PRIMARY KEY ,
 user_id number(10) NOT NULL,
 object_type number(10) DEFAULT -1 NOT NULL,
 object_id number(10) DEFAULT -1 NOT NULL,
 import_type number(10) DEFAULT 0 NOT NULL,
 twhen TIMESTAMP NOT NULL,
 import_source CLOB NULL,
 insert_ranges CLOB NULL,
 undo_data CLOB NULL,
 CONSTRAINT FK_UI_U FOREIGN KEY (user_id) references users (user_id) ON DELETE CASCADE
 )
~
CREATE INDEX IX_UNDO_UID on undoinfo (user_id)
~
CREATE TRIGGER CALIMPORTLINKS_TB_TRIGGER before insert on calimportlinks
for each row
begin
 select calimportlinks_seq.nextval into :new.callink_id from dual;
end;
~
CREATE TRIGGER LOGENTRY_TB_TRIGGER before insert on logentry
for each row
begin
 select logentry_seq.nextval into :new.entry_id from dual;
end;
~
CREATE TRIGGER UNDOINFO_TB_TRIGGER before insert on undoinfo
for each row
begin
 select undoinfo_seq.nextval into :new.entry_id from dual;
end;
~
delete from objecttypes where object_type_id=32779
~
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32779,'NotificationUser',12,'NotificationUser','n_user_id')
~
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32780,'CalItem',13,'CalItem','cal_item_id')
~
update cd_dbversion set version_str='3.4.0'
~
create view vObjectUsers as
SELECT ObjectSecurity.secured_obj_id,
 ObjectSecurity.secured_obj_type,
 ObjectSecurity.token,
 GU.group_id,
 GU.User_ID,
 ObjectTypes.type_name,
 ObjectTypes.sort_order,
 ObjectTypes.table_name,
 ObjectTypes.field_name
FROM ObjectTypes
 RIGHT JOIN (ObjectSecurity inner join GroupUsers GU ON GU.Group_ID=ObjectSecurity.Entity_ID)
 ON ObjectTypes.object_type_id=ObjectSecurity.secured_obj_type
WHERE entity_type=1
UNION ALL SELECT ObjectSecurity.secured_obj_id,
 ObjectSecurity.secured_obj_type,
 ObjectSecurity.token,
 null,
 entity_id,
 ObjectTypes.type_name,
 ObjectTypes.sort_order,
 ObjectTypes.table_name,
 ObjectTypes.field_name
FROM ObjectTypes
 RIGHT JOIN ObjectSecurity
 ON ObjectTypes.object_type_id=ObjectSecurity.secured_obj_type
WHERE entity_type=2
~
CREATE VIEW vCalCalendar AS
SELECT
 CC.calendar_id,
 CC.child_id,
 CC.display_opts,
 CCP.name AS parent_name,
 CCC.Name AS child_name
FROM
 calcalendar CC
 INNER JOIN calendar CCP ON CCP.calendar_id=CC.calendar_id
 INNER JOIN calendar CCC ON CCC.calendar_id=CC.child_id
~
CREATE VIEW vResource AS
SELECT
 R.resource_id,
 R.resource_type_id,
 R.active,
 R.location_id,
 R.resource_name,
 R.resource_shared,
 R.description,
 R.attributes,
 RT.type_description,
 LOC.location_name,
 RT.is_location
FROM
 resources R
 INNER JOIN resourcetype RT ON RT.Resource_Type_id=R.Resource_Type_id
 LEFT OUTER JOIN location LOC on LOC.location_id=R.location_id
~
CREATE VIEW vCalItemResource AS
SELECT
 CIR.cal_item_id,
 CIR.resource_id,
 CIR.approved,
 RT.type_description,
 RT.is_location,
 R.resource_type_id,
 R.location_id,
 R.resource_name
FROM
 calitemresource CIR
 INNER JOIN resources R ON R.Resource_id=CIR.Resource_id
 INNER JOIN resourcetype RT ON RT.Resource_type_id=R.Resource_Type_id
~
CREATE VIEW vCalItem AS
SELECT
 CI.*,
 coalesce(U.Full_Name, U.User_Name) as owner_Name
From
 calitem CI
 LEFT OUTER JOIN users U
 ON CI.owner=U.user_id
~
CREATE VIEW vGroupUsers AS
SELECT
 GU.group_id,
 GU.user_id,
 G.group_name,
 U.user_name,
 U.full_name
FROM
 groupusers GU
 INNER JOIN groups G ON GU.group_id=G.group_id
 INNER JOIN users U ON GU.user_id=U.user_id
~
CREATE VIEW vObjectSecurity AS
SELECT
 OSEC.*,
 OT.type_name,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order
FROM
 objectsecurity OSEC
 INNER JOIN objecttypes OT
 ON OSEC.secured_obj_type=OT.object_type_id
 INNER JOIN candidatetokens CT
 ON OSEC.secured_obj_type=CT.object_type_id AND OSEC.token=CT.token
~
CREATE VIEW vCandidateTokens AS
SELECT
 CT.*,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order,
 OT.type_name
FROM
 candidatetokens CT
 INNER JOIN objecttypes OT
 ON CT.object_type_id=OT.object_type_id
~
CREATE VIEW vNotUserItem AS
select NUI.*,
 CI.description
from notuseritem NUI
 LEFT JOIN calitem CI
 ON NUI.cal_item_id=CI.cal_item_id
~
CREATE VIEW vResourceGroupResource AS
Select
 RGR.*,
 R.resource_name
from resourcegroupresource RGR
 INNER JOIN resources R
 ON R.Resource_ID=RGR.Resource_ID
~
CREATE VIEW vMimeTypes as
select
 mime_type,
 count(*) as ref_count
from attachments
group by mime_type
~
create view vCalGuestMap AS
select CGM.*,
 U.user_name
FROM
 calguestmap CGM
 INNER JOIN users U
 ON CGM.guest_user=U.user_id
~
CREATE VIEW vCalTabs as
select
 caltabs.xmldoc_id,
 caltabs.calendar_id,
 caltabs.tab_order,
 xmldocs.xml_doc
from caltabs
 INNER JOIN xmldocs
 ON xmldocs.xmldoc_id=caltabs.xmldoc_id
~
~
