DROP VIEW vNotUserItem
~
DROP VIEW vObjectSecurity
~
DROP VIEW vCandidateTokens
~
DROP VIEW vGroupUsers
~
DROP VIEW vCalItem
~
DROP VIEW vCalItemResource
~
DROP VIEW vResource
~
DROP VIEW vResourceGroupResource
~
DROP VIEW vCalCalendar
~
DROP VIEW vObjectUsers
~
DROP VIEW vMimeTypes
~
DROP VIEW vCalGuestMap
~
DROP VIEW vCalTabs
~
CREATE SEQUENCE location_seq
~
CREATE TABLE calitem_calendar (
 cal_item_id number(10) NOT NULL,
 calendar_id number(10) NOT NULL,
 approved_state number(10) DEFAULT 0 NOT NULL,
 approver number(10) NULL,
 approve_date TIMESTAMP NULL,
 CONSTRAINT FK_CICal_CI FOREIGN KEY (cal_item_id) REFERENCES calitem (cal_item_id) ON DELETE CASCADE,
 CONSTRAINT FK_CICal_Cal FOREIGN KEY (calendar_id) REFERENCES calendar (calendar_id) ON DELETE CASCADE,
 CONSTRAINT PK_CICal PRIMARY KEY (cal_item_id, calendar_id)
)
~
CREATE INDEX IX_CICAL_CI ON calitem_calendar (cal_item_id)
~
CREATE INDEX IX_CICAL_CALID ON calitem_calendar (calendar_id)
~
insert into calitem_calendar (cal_item_id,calendar_id,approved_state,approver,approve_date)
select cal_item_id,calendar_id,approved_state,approver,approve_date
from calitem_rollups
order by cal_item_id,calendar_id
~
drop table calitem_rollups
~
CREATE TABLE location (
 location_id number(10) NOT NULL PRIMARY KEY ,
 parent_location number(10) NULL,
 location_name VARCHAR2(128) NOT NULL,
 location_address VARCHAR2(255) NULL,
 latitude BINARY_DOUBLE NULL,
 longitude BINARY_DOUBLE NULL,
 flags number(10) DEFAULT 0 NOT NULL,
 location_comments CLOB NULL,
 CONSTRAINT FK_LOC_LOC FOREIGN KEY (parent_location) references location (location_id),
 CONSTRAINT UQ_LOC_NAME UNIQUE (location_name)
 )
~
insert into objecttypes (object_type_id,type_name,sort_order,table_name,field_name) values
 (32784,'Location',14,'location','location_id')
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 0, 'tok_Add', 1, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_Delete', 2, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_Edit', 3, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_ManageSecurity', 4, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_View', 5, 1)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_Use', 6, 1)
~
drop table notuseritem_schedule
~
alter table notuseritem add next_alarm TIMESTAMP NULL
~
alter table groups add ldap_equivs CLOB NULL
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32771, 1, 'tok_DefaultApproved', 6, 0)
~
update calendar set default_type=(select min(item_type_id) from calitemtypes) where default_type is null
~
update users set email_address=lower(email_address) where email_address is not null and email_address<>lower(email_address)
~
insert into objecttypes (object_type_id,type_name,sort_order,table_name,field_name) values
 (32782,'EMailMsg',14,null,null)
~
insert into objecttypes (object_type_id,type_name,sort_order,table_name,field_name) values
 (32781,'SMSMessage',15,null,null)
~
CREATE SEQUENCE mediaacct_seq
~
CREATE SEQUENCE mediapost_seq
~
drop table mediaaccttype
~
drop table mediaaccttype_posttypes
~
create table mediaacct (
 account_id number(10) NOT NULL PRIMARY KEY ,
 account_type number(10) NOT NULL,
 account_name VARCHAR2(80) NOT NULL,
 authenticated number(1) DEFAULT 0 NOT NULL,
 auth_data CLOB NULL,
 last_update TIMESTAMP DEFAULT SYSDATE NOT NULL,
 CONSTRAINT UQ_MA_AN UNIQUE (account_name)
 )
~
create index IX_MA_AT on mediaacct (account_type)
~
~
create table mediapost (
 mediapost_id number(10) NOT NULL PRIMARY KEY ,
 mediaaccount_id number(10) NOT NULL,
 cal_item_id number(10) NOT NULL,
 post_time TIMESTAMP NOT NULL,
 actually_posted TIMESTAMP NULL,
 process_flags number(5) DEFAULT 0 NOT NULL,
 post_type number(10) DEFAULT 0 NOT NULL,
 post_content CLOB NULL,
 post_metadata CLOB NULL,
 CONSTRAINT UQ_MP UNIQUE (mediaaccount_id,cal_item_id,post_time),
 CONSTRAINT FK_MAP_MA FOREIGN KEY (mediaaccount_id) REFERENCES mediaacct (account_id),
 CONSTRAINT FK_MAP_CI FOREIGN KEY (cal_item_id) REFERENCES calitem (cal_item_id)
 )
~
alter table mediapost drop column post_flags
~
alter table mediapost drop column post_url
~
alter table mediapost drop column post_subject
~
CREATE INDEX IX_MP_CI ON mediapost (cal_item_id)
~
CREATE INDEX IX_MP_MA ON mediapost (mediaaccount_id)
~
CREATE INDEX IX_MP_PROC ON mediapost (process_flags)
~
insert into objecttypes (object_type_id,type_name,sort_order,table_name,field_name) values
 (32783,'MediaAcct',16,'mediaacct','account_id')
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32783, 0, 'tok_Add', 1, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32783, 1, 'tok_Delete', 2, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32783, 1, 'tok_Edit', 3, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32783, 1, 'tok_ManageSecurity', 4, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32783, 1, 'tok_Use', 6, 1)
~
alter table calitem add location_id number(10) NULL
~
alter table resources add location_id number(10) NULL
~
alter table resources add attributes CLOB NULL
~
alter table resources add constraint FK_RES_LOC FOREIGN KEY (location_id) references location
~
alter table resourcetype add parent_type number(10) NULL
~
alter table resourcetype add attributes CLOB NULL
~
alter table resourcetype add constraint FK_RT_RT FOREIGN KEY (parent_type) references resourcetype
~
alter table users add sms_number VARCHAR2(64) NULL
~
alter table notificationuser add sms_number VARCHAR2(64) NULL
~
drop table notuserqueue
~
CREATE TABLE notuserqueue (
 queueentry_id number(10) NOT NULL,
 n_user_id number(10) NOT NULL,
 effective_date number(10) NOT NULL,
 processed number(10) DEFAULT 0 NOT NULL,
 inprocess number(10) DEFAULT 0 NOT NULL,
 processresult number(10) DEFAULT 0 NOT NULL,
 ref_type number(10) DEFAULT 0 NOT NULL,
 ref_id number(10) NULL,
 metadata CLOB NULL,
 CONSTRAINT FK_NUQ_NQ FOREIGN KEY (queueentry_id) REFERENCES notificationqueue (queueentry_id) ON DELETE CASCADE,
 CONSTRAINT FK_NUQ_NU FOREIGN KEY (n_user_id) REFERENCES notificationuser (n_user_id) ON DELETE CASCADE,
 CONSTRAINT PK_NUQ PRIMARY KEY (QueueEntry_ID,N_User_ID)
 )
~
CREATE INDEX IX_R_LOC ON resources (location_id)
~
CREATE INDEX CI_LOC ON calitem (location_id)
~
alter table resources add active number(1) DEFAULT 1
~
update resources set active=1 WHERE active is null
~
alter table calitem add seq_value number(10) DEFAULT 0
~
update calitem set seq_value=1 where seq_value is null
~
alter table calitem add cancelled number(1) DEFAULT 0
~
update calitem set cancelled=0 where cancelled is null
~
CREATE TRIGGER LOCATION_TB_TRIGGER before insert on location
for each row
begin
 if :new.location_id is null then
 select location_seq.nextval into :new.location_id from dual;
 end if;
end;
~
CREATE TRIGGER MEDIAACCT_TB_TRIGGER before insert on mediaacct
for each row
begin
 if :new.account_id is null then
 select mediaacct_seq.nextval into :new.account_id from dual;
 end if;
end;
~
CREATE TRIGGER MEDIAPOST_TB_TRIGGER before insert on mediapost
for each row
begin
 if :new.mediapost_id is null then
 select mediapost_seq.nextval into :new.mediapost_id from dual;
 end if;
end;
~
Insert into objectsecurity (entity_id, entity_type, secured_obj_type, secured_obj_id, token)
 select groups.group_id, 1, candidatetokens.object_type_id, -1, candidatetokens.token
 from groups, candidatetokens
 where groups.group_id in (
 select distinct entity_id
 from objectsecurity
 where entity_type=1 AND
 secured_obj_type=32775 and
 secured_obj_id=-1 AND
 token='tok_EditConfig'
 ) AND
 candidatetokens.Instance=0 and
 candidatetokens.object_type_id in (32781,32782,32783,32784)
~
update objectsecurity set secured_obj_id=-1 where secured_obj_id=0
~
update cd_dbversion set version_str='4.0.0'
~
create view vObjectUsers as
SELECT ObjectSecurity.secured_obj_id,
 ObjectSecurity.secured_obj_type,
 ObjectSecurity.token,
 GU.group_id,
 GU.User_ID,
 ObjectTypes.type_name,
 ObjectTypes.sort_order,
 ObjectTypes.table_name,
 ObjectTypes.field_name
FROM ObjectTypes
 RIGHT JOIN (ObjectSecurity inner join GroupUsers GU ON GU.Group_ID=ObjectSecurity.Entity_ID)
 ON ObjectTypes.object_type_id=ObjectSecurity.secured_obj_type
WHERE entity_type=1
UNION ALL SELECT ObjectSecurity.secured_obj_id,
 ObjectSecurity.secured_obj_type,
 ObjectSecurity.token,
 null,
 entity_id,
 ObjectTypes.type_name,
 ObjectTypes.sort_order,
 ObjectTypes.table_name,
 ObjectTypes.field_name
FROM ObjectTypes
 RIGHT JOIN ObjectSecurity
 ON ObjectTypes.object_type_id=ObjectSecurity.secured_obj_type
WHERE entity_type=2
~
CREATE VIEW vCalCalendar AS
SELECT
 CC.calendar_id,
 CC.child_id,
 CC.display_opts,
 CCP.name AS parent_name,
 CCC.Name AS child_name
FROM
 calcalendar CC
 INNER JOIN calendar CCP ON CCP.calendar_id=CC.calendar_id
 INNER JOIN calendar CCC ON CCC.calendar_id=CC.child_id
~
CREATE VIEW vResource AS
SELECT
 R.resource_id,
 R.resource_type_id,
 R.active,
 R.location_id,
 R.resource_name,
 R.resource_shared,
 R.description,
 R.attributes,
 RT.type_description,
 LOC.location_name,
 RT.is_location
FROM
 resources R
 INNER JOIN resourcetype RT ON RT.Resource_Type_id=R.Resource_Type_id
 LEFT OUTER JOIN location LOC on LOC.location_id=R.location_id
~
CREATE VIEW vCalItemResource AS
SELECT
 CIR.cal_item_id,
 CIR.resource_id,
 CIR.approved,
 RT.type_description,
 RT.is_location,
 R.resource_type_id,
 R.location_id,
 R.resource_name
FROM
 calitemresource CIR
 INNER JOIN resources R ON R.Resource_id=CIR.Resource_id
 INNER JOIN resourcetype RT ON RT.Resource_type_id=R.Resource_Type_id
~
CREATE VIEW vCalItem AS
SELECT
 CI.*,
 coalesce(U.Full_Name, U.User_Name) as owner_Name
From
 calitem CI
 LEFT OUTER JOIN users U
 ON CI.owner=U.user_id
~
CREATE VIEW vGroupUsers AS
SELECT
 GU.group_id,
 GU.user_id,
 G.group_name,
 U.user_name,
 U.full_name
FROM
 groupusers GU
 INNER JOIN groups G ON GU.group_id=G.group_id
 INNER JOIN users U ON GU.user_id=U.user_id
~
CREATE VIEW vObjectSecurity AS
SELECT
 OSEC.*,
 OT.type_name,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order
FROM
 objectsecurity OSEC
 INNER JOIN objecttypes OT
 ON OSEC.secured_obj_type=OT.object_type_id
 INNER JOIN candidatetokens CT
 ON OSEC.secured_obj_type=CT.object_type_id AND OSEC.token=CT.token
~
CREATE VIEW vCandidateTokens AS
SELECT
 CT.*,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order,
 OT.type_name
FROM
 candidatetokens CT
 INNER JOIN objecttypes OT
 ON CT.object_type_id=OT.object_type_id
~
CREATE VIEW vNotUserItem AS
select NUI.*,
 CI.description
from notuseritem NUI
 LEFT JOIN calitem CI
 ON NUI.cal_item_id=CI.cal_item_id
~
CREATE VIEW vResourceGroupResource AS
Select
 RGR.*,
 R.resource_name
from resourcegroupresource RGR
 INNER JOIN resources R
 ON R.Resource_ID=RGR.Resource_ID
~
CREATE VIEW vMimeTypes as
select
 mime_type,
 count(*) as ref_count
from attachments
group by mime_type
~
create view vCalGuestMap AS
select CGM.*,
 U.user_name
FROM
 calguestmap CGM
 INNER JOIN users U
 ON CGM.guest_user=U.user_id
~
CREATE VIEW vCalTabs as
select
 caltabs.xmldoc_id,
 caltabs.calendar_id,
 caltabs.tab_order,
 xmldocs.xml_doc
from caltabs
 INNER JOIN xmldocs
 ON xmldocs.xmldoc_id=caltabs.xmldoc_id
~
~
