DROP VIEW vNotUserItem;
DROP VIEW vObjectSecurity;
DROP VIEW vCandidateTokens;
DROP VIEW vGroupUsers;
DROP VIEW vCalItem;
DROP VIEW vCalItemResource;
DROP VIEW vResource;
DROP VIEW vResourceGroupResource;
DROP VIEW vCalCalendar;
DROP VIEW vObjectUsers;
DROP VIEW vMimeTypes;
DROP VIEW vCalGuestMap;
DROP VIEW vCalTabs;
DROP TABLE configuration;
DROP TABLE notification_others;
DROP TABLE notuserqueue;
DROP TABLE notificationqueue;
DROP TABLE notuseritem;
DROP TABLE notificationfilterset;
DROP TABLE notificationfilter;
DROP TABLE notificationuser;
DROP TABLE mediapost;
DROP TABLE mediaacct;
DROP TABLE calitemresource;
DROP TABLE calitemattachments;
DROP TABLE attachments;
DROP TABLE resourcegroupresource;
DROP TABLE resourcegroup;
DROP TABLE resources;
DROP TABLE resourcetype;
DROP TABLE caltabs;
DROP TABLE xmldocs;
DROP TABLE calguestmap;
DROP TABLE calitem_calendar;
DROP TABLE calitem;
DROP TABLE calitemtypes;
DROP TABLE location;
DROP TABLE candidatetokens;
DROP TABLE objectsecurity;
DROP TABLE objecttypes;
DROP TABLE groupusers;
DROP TABLE groups;
DROP TABLE calcalendar;
DROP TABLE calimportlinks;
DROP TABLE undoinfo;
DROP TABLE calendar;
DROP TABLE users;
DROP TABLE logentry;
DROP TABLE cd_dbversion;
DROP SEQUENCE groups_seq;
DROP SEQUENCE resources_seq;
DROP SEQUENCE resourcegroup_seq;
DROP SEQUENCE RESOURCEType_seq;
DROP SEQUENCE Attachments_seq;
DROP SEQUENCE calItem_seq;
DROP SEQUENCE CalItemTypes_seq;
DROP SEQUENCE calguestmap_seq;
DROP SEQUENCE calendar_seq;
DROP SEQUENCE calimportlinks_seq;
DROP SEQUENCE location_seq;
DROP SEQUENCE users_seq;
DROP SEQUENCE mediaacct_seq;
DROP SEQUENCE mediapost_seq;
DROP SEQUENCE notificationuser_seq;
DROP SEQUENCE notificationqueue_seq;
DROP SEQUENCE notificationfilter_seq;
DROP SEQUENCE XmlDocs_seq;
DROP SEQUENCE logentry_seq;
DROP SEQUENCE undoinfo_seq;
CREATE SEQUENCE Attachments_seq;
CREATE SEQUENCE groups_seq;
CREATE SEQUENCE users_seq;
CREATE SEQUENCE calendar_seq;
CREATE SEQUENCE calimportlinks_seq;
CREATE SEQUENCE calguestmap_seq;
CREATE SEQUENCE CalItemTypes_seq;
CREATE SEQUENCE CalItem_seq;
CREATE SEQUENCE location_seq;
CREATE SEQUENCE RESOURCEType_seq;
CREATE SEQUENCE Resources_seq;
CREATE SEQUENCE ResourceGroup_Seq;
CREATE SEQUENCE mediaacct_seq;
CREATE SEQUENCE mediapost_seq;
CREATE SEQUENCE notificationuser_seq;
CREATE SEQUENCE notificationqueue_seq;
CREATE SEQUENCE notificationfilter_seq;
CREATE SEQUENCE XmlDocs_seq;
CREATE SEQUENCE logentry_seq;
CREATE SEQUENCE undoinfo_seq;
create table cd_dbversion (
 version_str VARCHAR2(16) NOT NULL PRIMARY KEY
 );
CREATE TABLE groups (
 group_id number(10) NOT NULL PRIMARY KEY ,
 group_name VARCHAR2(64) NOT NULL,
 descr CLOB NULL,
 ldap_equivs CLOB NULL,
 CONSTRAINT UQ_G_GN UNIQUE (group_name)
 );
CREATE TABLE users (
 user_id number(10) NOT NULL PRIMARY KEY ,
 user_name VARCHAR2(64) NOT NULL,
 password VARCHAR2(64) NOT NULL,
 full_name VARCHAR2(64),
 email_address VARCHAR2(128),
 sms_number VARCHAR2(64) NULL,
 enabled number(10) DEFAULT 1 NOT NULL,
 last_signin TIMESTAMP NULL,
 default_calendar number(10) NULL,
 last_ip_address VARCHAR2(128),
 last_browser VARCHAR2(80),
 blogincount number(10) DEFAULT 0 NOT NULL,
 lastblogin TIMESTAMP NULL,
 pwchangedate TIMESTAMP DEFAULT SYSDATE NOT NULL,
 pwhistory CLOB NULL,
 user_prefs CLOB NULL,
 prefs_flag number(10) DEFAULT 16655,
 grlogrem number(10) DEFAULT 3,
 tz_string VARCHAR2(64) NULL,
 locales VARCHAR2(80) NULL,
 plannerstart VARCHAR2(32) NULL,
 plannerend VARCHAR2(32) NULL,
 CONSTRAINT UQ_User_UserName UNIQUE (User_Name)
 );
CREATE TABLE groupusers (
 group_id number(10) NOT NULL,
 user_id number(10) NOT NULL,
 CONSTRAINT PK_GroupUsers PRIMARY KEY (group_id, user_id),
 CONSTRAINT FK_GU_G FOREIGN KEY (group_id) References groups (group_id) ON DELETE CASCADE,
 CONSTRAINT FK_GU_U FOREIGN KEY (user_id) References users (user_id) ON DELETE CASCADE
 );
CREATE TABLE objecttypes (
 object_type_id number(10) NOT NULL PRIMARY KEY,
 type_name VARCHAR2(32) NOT NULL,
 sort_order int NOT NULL,
 table_name VARCHAR2(32) NULL,
 field_name VARCHAR2(32) NULL,
 CONSTRAINT UQ_OT_TN UNIQUE (type_name)
 );
CREATE TABLE objectsecurity (
 entity_id number(10) NOT NULL,
 entity_type number(10) NOT NULL,
 secured_obj_type number(10) NOT NULL,
 secured_obj_id number(10) DEFAULT 0 NOT NULL,
 token VARCHAR2(64) NOT NULL,
 CONSTRAINT PK_ObjSec PRIMARY KEY (entity_id, entity_type, secured_obj_type, secured_obj_id, token),
 CONSTRAINT FK_OS_OT FOREIGN KEY (secured_obj_type) References objecttypes (object_type_id)
 );
CREATE INDEX IX_OS_SO_EI ON objectsecurity (secured_obj_id, secured_obj_type, entity_id, entity_type);
CREATE TABLE candidatetokens (
 object_type_id number(10) NOT NULL,
 instance number(10) DEFAULT 0 NOT NULL ,
 token VARCHAR2(64) NOT NULL,
 sort_order number(10) NOT NULL,
 is_default number(10) DEFAULT 0 NOT NULL,
 creator_default number(10) DEFAULT 1 NOT NULL,
 CONSTRAINT FK_CT_OT FOREIGN KEY (object_type_id) References objecttypes (object_type_id),
 CONSTRAINT PK_CT PRIMARY KEY (object_type_id, token)
 );
CREATE TABLE calendar (
 calendar_id number(10) NOT NULL PRIMARY KEY ,
 name VARCHAR2(64) NOT NULL,
 short_name VARCHAR2(12) NULL,
 default_style number(10) DEFAULT 0 NOT NULL,
 default_type number(10) DEFAULT 0 NOT NULL,
 def_privacy number(10) DEFAULT 0 NOT NULL,
 style_sheet VARCHAR2(128) NULL,
 image_name VARCHAR2(64) NULL,
 prefs number(10) DEFAULT 0 NOT NULL,
 header_file VARCHAR2(128) NULL,
 footer_file VARCHAR2(128) NULL,
 last_edited TIMESTAMP NULL,
 last_edit_by VARCHAR2(64) NULL,
 long_description CLOB NULL,
 CONSTRAINT UQ_Calendar_Name UNIQUE (name)
 );
CREATE TABLE calguestmap (
 mapentry_id number(10) NOT NULL PRIMARY KEY ,
 strexpr VARCHAR2(128) NOT NULL,
 guest_user number(10) NOT NULL,
 CONSTRAINT FK_CGM_U FOREIGN KEY (guest_user) references users (user_id)
 );
CREATE TABLE calimportlinks (
 callink_id number(10) NOT NULL PRIMARY KEY ,
 calendar_id number(10) NOT NULL,
 refresh_interval number(10) NOT NULL,
 enabled number(10) DEFAULT 0 NOT NULL,
 last_executed TIMESTAMP NOT NULL,
 last_messages CLOB NULL,
 settings CLOB NULL,
 CONSTRAINT FK_CIL_CAL FOREIGN KEY (calendar_id) references calendar (calendar_id) ON DELETE CASCADE
 );
CREATE TABLE calitemtypes (
 item_type_id number(10) NOT NULL PRIMARY KEY ,
 description VARCHAR2(64) NOT NULL,
 CONSTRAINT UQ_CalItemTypes_Desc UNIQUE (Description)
 );
CREATE TABLE location (
 location_id number(10) NOT NULL PRIMARY KEY ,
 parent_location number(10) NULL,
 location_name VARCHAR2(128) NOT NULL,
 location_address VARCHAR2(255) NULL,
 latitude BINARY_DOUBLE NULL,
 longitude BINARY_DOUBLE NULL,
 flags number(10) DEFAULT 0 NOT NULL,
 location_comments CLOB NULL,
 CONSTRAINT FK_LOC_LOC FOREIGN KEY (parent_location) references location (location_id),
 CONSTRAINT UQ_LOC_NAME UNIQUE (location_name)
 );
CREATE TABLE calitem (
 cal_item_id number(10) NOT NULL PRIMARY KEY ,
 calendar_id number(10) NOT NULL,
 item_type_id number(10) NOT NULL,
 cancelled number(1) DEFAULT 0 NOT NULL,
 month number(10) DEFAULT 0 NOT NULL ,
 day number(10) DEFAULT 0 NOT NULL,
 dow number(10) DEFAULT 0 NOT NULL,
 recurs number(10) DEFAULT 0 NOT NULL,
 duration number(5) DEFAULT 0 NOT NULL,
 rinterval number(5) DEFAULT 0 NOT NULL,
 starting_date number(10) NULL,
 ending_date number(10) NULL,
 style_id number(10) DEFAULT 0 NOT NULL,
 parent_item number(10) DEFAULT 0 NOT NULL,
 link_type number(10) DEFAULT 0 NOT NULL,
 owner number(10) NULL,
 privacy_opts number(10) DEFAULT 0 NOT NULL,
 approved number(10) DEFAULT 0 NOT NULL,
 starting_time VARCHAR2(12),
 ending_time VARCHAR2(12),
 rec_type number(5) DEFAULT 0 NOT NULL,
 location_id number(10) NULL,
 description VARCHAR2(80) NOT NULL,
 contact_name VARCHAR2(128),
 contact_info VARCHAR2(128),
 add_info_url VARCHAR2(128),
 itemguid VARCHAR2(128) NOT NULL,
 seq_value number(10) DEFAULT 0 NOT NULL,
 tz_string VARCHAR2(64) NULL,
 last_update TIMESTAMP NOT NULL,
 exceptions CLOB NULL,
 long_description CLOB NULL,
 xml_data CLOB NULL,
 CONSTRAINT FK_CalItem_Calendar FOREIGN KEY (Calendar_id) References calendar (calendar_id) ON DELETE CASCADE,
 CONSTRAINT FK_CalItem_CalItemType FOREIGN KEY (Item_Type_id) References calitemtypes (item_type_id),
 CONSTRAINT FK_CI_LOC FOREIGN KEY (location_id) references location (location_id),
 CONSTRAINT FK_CalItem_Owner FOREIGN KEY (owner) REFERENCES users (user_id),
 CONSTRAINT CK_CalItem_Duration CHECK (duration >= 0)
 );
CREATE Index CI_RecType on calitem (rec_type);
CREATE INDEX CI_Calendar ON calitem (calendar_id);
CREATE INDEX CI_LOC ON calitem (location_id);
CREATE TABLE calitem_calendar (
 cal_item_id number(10) NOT NULL,
 calendar_id number(10) NOT NULL,
 approved_state number(10) DEFAULT 0 NOT NULL,
 approver number(10) NULL,
 approve_date TIMESTAMP NULL,
 CONSTRAINT FK_CICal_CI FOREIGN KEY (cal_item_id) REFERENCES calitem (cal_item_id) ON DELETE CASCADE,
 CONSTRAINT FK_CICal_Cal FOREIGN KEY (calendar_id) REFERENCES calendar (calendar_id) ON DELETE CASCADE,
 CONSTRAINT PK_CICal PRIMARY KEY (cal_item_id, calendar_id)
);
CREATE INDEX IX_CICAL_CI ON calitem_calendar (cal_item_id);
CREATE INDEX IX_CICAL_CALID ON calitem_calendar (calendar_id);
create table mediaacct (
 account_id number(10) NOT NULL PRIMARY KEY ,
 account_type number(10) NOT NULL,
 account_name VARCHAR2(80) NOT NULL,
 authenticated number(1) DEFAULT 0 NOT NULL,
 auth_data CLOB NULL,
 last_update TIMESTAMP DEFAULT SYSDATE NOT NULL,
 CONSTRAINT UQ_MA_AN UNIQUE (account_name)
 );
create index IX_MA_AT on mediaacct (account_type);
create table mediapost (
 mediapost_id number(10) NOT NULL PRIMARY KEY ,
 mediaaccount_id number(10) NOT NULL,
 cal_item_id number(10) NOT NULL,
 post_time TIMESTAMP NOT NULL,
 actually_posted TIMESTAMP NULL,
 process_flags number(5) DEFAULT 0 NOT NULL,
 post_type number(10) DEFAULT 0 NOT NULL,
 post_content CLOB NULL,
 post_metadata CLOB NULL,
 CONSTRAINT UQ_MP UNIQUE (mediaaccount_id,cal_item_id,post_time),
 CONSTRAINT FK_MAP_MA FOREIGN KEY (mediaaccount_id) REFERENCES mediaacct (account_id),
 CONSTRAINT FK_MAP_CI FOREIGN KEY (cal_item_id) REFERENCES calitem (cal_item_id)
 );
CREATE INDEX IX_MP_CI ON mediapost (cal_item_id);
CREATE INDEX IX_MP_MA ON mediapost (mediaaccount_id);
CREATE INDEX IX_MP_PROC ON mediapost (process_flags);
CREATE TABLE xmldocs (
 xmldoc_id number(10) NOT NULL PRIMARY KEY ,
 doc_type number(10) NOT NULL,
 name VARCHAR2(30),
 last_update TIMESTAMP NOT NULL,
 xml_doc CLOB NOT NULL
 );
CREATE TABLE caltabs (
 xmldoc_id number(10) NOT NULL,
 calendar_id number(10) NOT NULL,
 tab_order number(10) NOT NULL,
 CONSTRAINT PK_CALTABS PRIMARY KEY (calendar_id,xmldoc_id),
 CONSTRAINT FK_CT_CAL FOREIGN KEY (calendar_id) REFERENCES calendar (calendar_id) ON DELETE CASCADE,
 CONSTRAINT FK_CT_XMLDOC FOREIGN KEY (xmldoc_id) REFERENCES xmldocs (xmldoc_id)
 );
CREATE TABLE calcalendar (
 calendar_id number(10) NOT NULL,
 child_id number(10) NOT NULL,
 display_opts number(10) DEFAULT 0 NOT NULL,
 CONSTRAINT PK_CC PRIMARY KEY (calendar_id, child_id),
 CONSTRAINT FK_CC_C FOREIGN KEY (calendar_id) REFERENCES calendar (calendar_id) ON DELETE CASCADE
 ,CONSTRAINT FK_CC_CC FOREIGN KEY (child_id) REFERENCES calendar (calendar_id) ON DELETE CASCADE
 );
CREATE TABLE resourcetype (
 resource_type_id number(10) NOT NULL PRIMARY KEY ,
 parent_type number(10) NULL,
 type_description VARCHAR2(64) NOT NULL,
 attributes CLOB NULL,
 is_location number(10) DEFAULT 0 NOT NULL,
 max_resources number(10) DEFAULT 0 NOT NULL,
 CONSTRAINT FK_RT_RT FOREIGN KEY (parent_type) REFERENCES resourcetype (resource_type_id),
 CONSTRAINT UQ_ResourceType_Desc UNIQUE (Type_Description)
 );
CREATE TABLE resources (
 resource_id number(10) NOT NULL PRIMARY KEY ,
 active number(1) DEFAULT 1 NOT NULL,
 resource_type_id number(10) NOT NULL,
 location_id number(10) NULL,
 resource_shared number(10) DEFAULT 0 NOT NULL,
 resource_name VARCHAR2(64) NOT NULL,
 descrmode number(10) DEFAULT 0 NOT NULL,
 description CLOB NULL,
 attributes CLOB NULL,
 CONSTRAINT FK_RES_LOC FOREIGN KEY (location_id) REFERENCES location (location_id),
 CONSTRAINT FK_Resource_Type FOREIGN KEY (resource_type_id) references resourcetype (resource_type_id),
 CONSTRAINT UQ_Resources_Name UNIQUE (resource_name)
 );
CREATE INDEX IX_R_LOC ON resources (location_id);
CREATE TABLE resourcegroup (
 resourcegroup_id number(10) NOT NULL PRIMARY KEY ,
 group_name VARCHAR2(64) NOT NULL,
 CONSTRAINT UQ_RG_GN UNIQUE (group_name)
 );
CREATE TABLE resourcegroupresource (
 resourcegroup_id number(10) NOT NULL,
 resource_id number(10) NOT NULL,
 CONSTRAINT PK_RGR PRIMARY KEY (resourcegroup_id,resource_id),
 CONSTRAINT FK_RGR_RES FOREIGN KEY (resource_id) references resources (resource_id) ON DELETE CASCADE,
 CONSTRAINT FK_RGR_RG FOREIGN KEY (resourcegroup_id) references resourcegroup (resourcegroup_id) ON DELETE CASCADE
 );
CREATE TABLE calitemresource (
 cal_item_id number(10) NOT NULL,
 resource_id number(10) NOT NULL,
 approved number(10) DEFAULT 0 NOT NULL,
 CONSTRAINT PK_CalItemResource PRIMARY KEY (Cal_Item_id, Resource_id),
 CONSTRAINT FK_CIR_CalItem_id FOREIGN KEY (Cal_Item_id) References calitem (cal_item_id) ON DELETE CASCADE,
 CONSTRAINT FK_CIR_Resource_id FOREIGN KEY (Resource_id) References resources (resource_id)
 );
CREATE TABLE attachments (
 attachment_id number(10) NOT NULL PRIMARY KEY ,
 file_size number(10) DEFAULT 0 NOT NULL,
 file_name VARCHAR2(200) NOT NULL,
 def_description CLOB NULL,
 mime_type VARCHAR2(64) NULL,
 md5sum VARCHAR2(32) NULL,
 date_uploaded TIMESTAMP DEFAULT SYSDATE NOT NULL,
 CONSTRAINT CK_ATT_SIZE CHECK (file_size>=0)
 );
CREATE INDEX IX_ATT_FNAME on attachments (file_name);
CREATE INDEX IX_ATT_MIMEFNAME on attachments (mime_type,file_name);
CREATE TABLE calitemattachments (
 cal_item_id number(10) NOT NULL,
 attachment_id number(10) NOT NULL,
 file_name VARCHAR2(200) NOT NULL,
 description CLOB NULL,
 CONSTRAINT PK_CIA PRIMARY KEY (cal_item_id,attachment_id),
 CONSTRAINT FK_CIA_CI FOREIGN KEY (cal_item_id) references calitem (cal_item_id) ON DELETE CASCADE,
 CONSTRAINT FK_CIA_AT FOREIGN KEY (attachment_id) references attachments (attachment_id)
 );
CREATE TABLE notificationuser (
 n_user_id number(10) NOT NULL PRIMARY KEY ,
 user_id number(10) NULL,
 password VARCHAR2(64) NULL,
 cookie VARCHAR2(64) NULL,
 last_accessdate TIMESTAMP DEFAULT SYSDATE NOT NULL,
 confirmed number(5) DEFAULT 0 NOT NULL,
 email_address VARCHAR2(128) NULL,
 sms_number VARCHAR2(64) NULL,
 reconfirmby number(10) NULL,
 locales VARCHAR2(64) NULL,
 timezone VARCHAR2(64) NULL,
 failurecount number(10) DEFAULT 0 NOT NULL,
 lastfailure TIMESTAMP NULL,
 lastsuccess TIMESTAMP NULL,
 CONSTRAINT FK_NU_UI FOREIGN KEY (User_ID) references users (user_id) ON DELETE CASCADE
 );
CREATE INDEX IX_NU_UI ON notificationuser (user_id);
CREATE TABLE notificationqueue (
 queueentry_id number(10) NOT NULL PRIMARY KEY ,
 cal_item_id number(10) NOT NULL,
 operator_id number(10) NOT NULL,
 entry_time TIMESTAMP DEFAULT SYSDATE NOT NULL,
 create_time TIMESTAMP DEFAULT SYSDATE NOT NULL,
 entry_type number(10) DEFAULT 0 NOT NULL,
 send_now number(10) DEFAULT 0 NOT NULL,
 entry_date number(10) NOT NULL,
 description VARCHAR2(128) NOT NULL,
 in_process number(10) DEFAULT 0 NOT NULL,
 list_built number(10) DEFAULT 0 NOT NULL,
 op_notes CLOB NULL,
 CONSTRAINT FK_NQ_OP FOREIGN KEY (operator_id) REFERENCES users (user_id)
 );
CREATE INDEX IX_NQ_CI ON notificationqueue (cal_item_id);
CREATE TABLE notuserqueue (
 queueentry_id number(10) NOT NULL,
 n_user_id number(10) NOT NULL,
 effective_date number(10) NOT NULL,
 processed number(10) DEFAULT 0 NOT NULL,
 inprocess number(10) DEFAULT 0 NOT NULL,
 processresult number(10) DEFAULT 0 NOT NULL,
 ref_type number(10) DEFAULT 0 NOT NULL,
 ref_id number(10) NULL,
 metadata CLOB NULL,
 CONSTRAINT FK_NUQ_NQ FOREIGN KEY (queueentry_id) REFERENCES notificationqueue (queueentry_id) ON DELETE CASCADE,
 CONSTRAINT FK_NUQ_NU FOREIGN KEY (n_user_id) REFERENCES notificationuser (n_user_id) ON DELETE CASCADE,
 CONSTRAINT PK_NUQ PRIMARY KEY (QueueEntry_ID,N_User_ID)
 );
CREATE TABLE notuseritem (
 n_user_id number(10) NOT NULL,
 cal_item_id number(10) NOT NULL,
 notificationflags number(10) DEFAULT 255 NOT NULL,
 days_offset number(10) DEFAULT 0 NOT NULL,
 date_added TIMESTAMP DEFAULT SYSDATE NOT NULL,
 next_alarm TIMESTAMP NULL,
 day_list CLOB NULL,
 CONSTRAINT FK_NUI_NU FOREIGN KEY (n_user_id) REFERENCES notificationuser (n_user_id) ON DELETE CASCADE,
 CONSTRAINT PK_NUI PRIMARY KEY (n_user_id,cal_item_id),
 CONSTRAINT CK_NUI_DO CHECK (days_offset>=0 and days_offset<=30)
 );
CREATE TABLE notificationfilter (
 filter_id number(10) NOT NULL PRIMARY KEY ,
 n_user_id number(10) NOT NULL,
 filtername VARCHAR2(128) NOT NULL,
 searchfields number(10) DEFAULT 2 NOT NULL,
 requirewords number(10) DEFAULT 2 NOT NULL,
 filtersettype number(10) DEFAULT 1 NOT NULL,
 includemerge number(10) DEFAULT 0 NOT NULL,
 obj_type_id number(10) NOT NULL,
 wordlist CLOB NULL,
 CONSTRAINT FK_NF_NU FOREIGN KEY (n_user_id) references notificationuser (n_user_id) ON DELETE CASCADE,
 CONSTRAINT FK_NF_OT FOREIGN KEY (obj_type_id) REFERENCES objecttypes (object_type_id)
 );
CREATE INDEX IX_NF_UI ON notificationfilter (n_user_id,filtersettype);
CREATE TABLE notificationfilterset (
 filter_id number(10) NOT NULL,
 obj_type_id number(10) NOT NULL,
 obj_id number(10) NOT NULL,
 CONSTRAINT PK_NFS PRIMARY KEY (filter_id,obj_type_id,obj_id),
 CONSTRAINT FK_NFS_NF FOREIGN KEY (filter_id) REFERENCES notificationfilter (filter_id) ON DELETE CASCADE,
 CONSTRAINT FK_NFS_OT FOREIGN KEY (obj_type_id) REFERENCES objecttypes (object_type_id) ON DELETE CASCADE
 );
CREATE TABLE notification_others (
 n_user_id number(10) NOT NULL,
 type_id number(10) NOT NULL,
 entry_id number(10) NOT NULL,
 entity_type number(10) NOT NULL,
 entity_id number(10) NOT NULL,
 CONSTRAINT FK_NO_NU FOREIGN KEY (n_user_id) REFERENCES notificationuser (n_user_id) ON DELETE CASCADE,
 CONSTRAINT FK_NO_TI_OT FOREIGN KEY (type_id) REFERENCES objecttypes (object_type_id),
 CONSTRAINT FK_NO_ET_OT FOREIGN KEY (entity_type) REFERENCES objecttypes (object_type_id),
 CONSTRAINT PK_NO PRIMARY KEY (n_user_id,type_id,entry_id,entity_type,entity_id)
 );
CREATE TABLE configuration (
 config_type number(10) NOT NULL,
 last_updt TIMESTAMP NOT NULL,
 config CLOB NOT NULL,
 CONSTRAINT PK_CFG PRIMARY KEY (config_type)
 );
CREATE TABLE logentry (
 entry_id number(10) NOT NULL PRIMARY KEY ,
 object_type number(10) NOT NULL,
 object_id number(10) NOT NULL,
 twhen TIMESTAMP NOT NULL,
 user_name varchar(80),
 message CLOB NULL
 );
CREATE INDEX IX_LE_OTOI ON logentry (object_type,object_id);
CREATE TABLE undoinfo (
 entry_id number(10) NOT NULL PRIMARY KEY ,
 user_id number(10) NOT NULL,
 object_type number(10) DEFAULT -1 NOT NULL,
 object_id number(10) DEFAULT -1 NOT NULL,
 import_type number(10) DEFAULT 0 NOT NULL,
 twhen TIMESTAMP NOT NULL,
 import_source CLOB NULL,
 insert_ranges CLOB NULL,
 undo_data CLOB NULL,
 CONSTRAINT FK_UI_U FOREIGN KEY (user_id) references users (user_id) ON DELETE CASCADE
 );
create view vObjectUsers as
SELECT ObjectSecurity.secured_obj_id,
 ObjectSecurity.secured_obj_type,
 ObjectSecurity.token,
 GU.group_id,
 GU.User_ID,
 ObjectTypes.type_name,
 ObjectTypes.sort_order,
 ObjectTypes.table_name,
 ObjectTypes.field_name
FROM ObjectTypes
 RIGHT JOIN (ObjectSecurity inner join GroupUsers GU ON GU.Group_ID=ObjectSecurity.Entity_ID)
 ON ObjectTypes.object_type_id=ObjectSecurity.secured_obj_type
WHERE entity_type=1
UNION ALL SELECT ObjectSecurity.secured_obj_id,
 ObjectSecurity.secured_obj_type,
 ObjectSecurity.token,
 null,
 entity_id,
 ObjectTypes.type_name,
 ObjectTypes.sort_order,
 ObjectTypes.table_name,
 ObjectTypes.field_name
FROM ObjectTypes
 RIGHT JOIN ObjectSecurity
 ON ObjectTypes.object_type_id=ObjectSecurity.secured_obj_type
WHERE entity_type=2;
CREATE VIEW vCalCalendar AS
SELECT
 CC.calendar_id,
 CC.child_id,
 CC.display_opts,
 CCP.name AS parent_name,
 CCC.Name AS child_name
FROM
 calcalendar CC
 INNER JOIN calendar CCP ON CCP.calendar_id=CC.calendar_id
 INNER JOIN calendar CCC ON CCC.calendar_id=CC.child_id;
CREATE VIEW vResource AS
SELECT
 R.resource_id,
 R.resource_type_id,
 R.active,
 R.location_id,
 R.resource_name,
 R.resource_shared,
 R.description,
 R.attributes,
 RT.type_description,
 LOC.location_name,
 RT.is_location
FROM
 resources R
 INNER JOIN resourcetype RT ON RT.Resource_Type_id=R.Resource_Type_id
 LEFT OUTER JOIN location LOC on LOC.location_id=R.location_id;
CREATE VIEW vCalItemResource AS
SELECT
 CIR.cal_item_id,
 CIR.resource_id,
 CIR.approved,
 RT.type_description,
 RT.is_location,
 R.resource_type_id,
 R.location_id,
 R.resource_name
FROM
 calitemresource CIR
 INNER JOIN resources R ON R.Resource_id=CIR.Resource_id
 INNER JOIN resourcetype RT ON RT.Resource_type_id=R.Resource_Type_id;
CREATE VIEW vCalItem AS
SELECT
 CI.*,
 coalesce(U.Full_Name, U.User_Name) as owner_Name
From
 calitem CI
 LEFT OUTER JOIN users U
 ON CI.owner=U.user_id;
CREATE VIEW vGroupUsers AS
SELECT
 GU.group_id,
 GU.user_id,
 G.group_name,
 U.user_name,
 U.full_name
FROM
 groupusers GU
 INNER JOIN groups G ON GU.group_id=G.group_id
 INNER JOIN users U ON GU.user_id=U.user_id;
CREATE VIEW vObjectSecurity AS
SELECT
 OSEC.*,
 OT.type_name,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order
FROM
 objectsecurity OSEC
 INNER JOIN objecttypes OT
 ON OSEC.secured_obj_type=OT.object_type_id
 INNER JOIN candidatetokens CT
 ON OSEC.secured_obj_type=CT.object_type_id AND OSEC.token=CT.token;
CREATE VIEW vCandidateTokens AS
SELECT
 CT.*,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order,
 OT.type_name
FROM
 candidatetokens CT
 INNER JOIN objecttypes OT
 ON CT.object_type_id=OT.object_type_id;
CREATE VIEW vNotUserItem AS
select NUI.*,
 CI.description
from notuseritem NUI
 LEFT JOIN calitem CI
 ON NUI.cal_item_id=CI.cal_item_id;
CREATE VIEW vResourceGroupResource AS
Select
 RGR.*,
 R.resource_name
from resourcegroupresource RGR
 INNER JOIN resources R
 ON R.Resource_ID=RGR.Resource_ID;
CREATE VIEW vMimeTypes as
select
 mime_type,
 count(*) as ref_count
from attachments
group by mime_type;
create view vCalGuestMap AS
select CGM.*,
 U.user_name
FROM
 calguestmap CGM
 INNER JOIN users U
 ON CGM.guest_user=U.user_id;
CREATE VIEW vCalTabs as
select
 caltabs.xmldoc_id,
 caltabs.calendar_id,
 caltabs.tab_order,
 xmldocs.xml_doc
from caltabs
 INNER JOIN xmldocs
 ON xmldocs.xmldoc_id=caltabs.xmldoc_id;
CREATE TRIGGER Groups_TB_TRIGGER before insert on Groups
for each row
begin
 if :new.group_id is null then
 select Groups_seq.nextval into :new.group_id from dual;
 end if;
end;
/
CREATE TRIGGER Users_TB_TRIGGER before insert on Users
for each row
begin
 if :new.user_id is null then
 select users_seq.nextval into :new.user_id from dual;
 end if;
end;
/
CREATE TRIGGER Calendar_TB_TRIGGER before insert on Calendar
for each row
begin
 if :new.calendar_id is null then
 select calendar_seq.nextval into :new.calendar_id from dual;
 end if;
end;
/
CREATE TRIGGER CalItemTypes_TB_TRIGGER before insert on CalItemTypes
for each row
begin
 if :new.item_type_id is null then
 select calitemtypes_seq.nextval into :new.item_type_id from dual;
 end if;
end;
/
CREATE TRIGGER CalItem_TB_TRIGGER before insert on CalItem
for each row
begin
 if :new.cal_item_id is null then
 select calitem_seq.nextval into :new.cal_item_id from dual;
 end if;
end;
/
CREATE TRIGGER ResourceType_TB_TRIGGER before insert on ResourceType
for each row
begin
 if :new.resource_type_id is null then
 select ResourceType_seq.nextval into :new.resource_type_id from dual;
 end if;
end;
/
CREATE TRIGGER Resources_TB_TRIGGER before insert on Resources
for each row
begin
 if :new.resource_id is null then
 select resources_seq.nextval into :new.resource_id from dual;
 end if;
end;
/
CREATE TRIGGER ResourcesGroup_TB_TRIGGER before insert on ResourceGroup
for each row
begin
 if :new.resourcegroup_id is null then
 select resourcegroup_seq.nextval into :new.resourcegroup_id from dual;
 end if;
end;
/
CREATE TRIGGER NQ_TB_TRIGGER before insert on NotificationQueue
for each row
begin
 if :new.queueentry_id is null then
 select notificationqueue_seq.nextval into :new.queueentry_id from dual;
 end if;
end;
/
CREATE TRIGGER NF_TB_TRIGGER before insert on NotificationFilter
for each row
begin
 if :new.filter_id is null then
 select notificationfilter_seq.nextval into :new.filter_id from dual;
 end if;
end;
/
CREATE TRIGGER NU_TB_TRIGGER before insert on NotificationUser
for each row
begin
 if :new.n_user_id is null then
 select notificationuser_seq.nextval into :new.n_user_id from dual;
 end if;
end;
/
CREATE TRIGGER ATT_TB_TRIGGER before insert on Attachments
for each row
begin
 if :new.attachment_id is null then
 select attachments_seq.nextval into :new.attachment_id from dual;
 end if;
end;
/
CREATE TRIGGER CGM_ME_TRIGGER before insert on CalGuestMap
for each row
begin
 if :new.mapentry_id is null then
 select calguestmap_seq.nextval into :new.mapentry_id from dual;
 end if;
end;
/
CREATE TRIGGER IS_XMLDOC_TRIGGER before insert on xmldocs
for each row
begin
 if :new.xmldoc_id is null then
 select xmldocs_seq.nextval into :new.xmldoc_id from dual;
 end if;
end;
/
CREATE TRIGGER CALIMPORTLINKS_TB_TRIGGER before insert on calimportlinks
for each row
begin
 if :new.callink_id is null then
 select calimportlinks_seq.nextval into :new.callink_id from dual;
 end if;
end;
/
CREATE TRIGGER LOGENTRY_TB_TRIGGER before insert on logentry
for each row
begin
 if :new.entry_id is null then
 select logentry_seq.nextval into :new.entry_id from dual;
 end if;
end;
/
CREATE TRIGGER UNDOINFO_TB_TRIGGER before insert on undoinfo
for each row
begin
 if :new.entry_id is null then
 select undoinfo_seq.nextval into :new.entry_id from dual;
 end if;
end;
/
CREATE TRIGGER LOCATION_TB_TRIGGER before insert on location
for each row
begin
 if :new.location_id is null then
 select location_seq.nextval into :new.location_id from dual;
 end if;
end;
/
CREATE TRIGGER MEDIAACCT_TB_TRIGGER before insert on mediaacct
for each row
begin
 if :new.account_id is null then
 select mediaacct_seq.nextval into :new.account_id from dual;
 end if;
end;
/
CREATE TRIGGER MATPOST_TB_TRIGGER before insert on mediaaccttype_posttypes
for each row
begin
 if :new.posttype_id is null then
 select posttype_seq.nextval into :new.posttype_id from dual;
 end if;
end;
/
CREATE TRIGGER MEDIAPOST_TB_TRIGGER before insert on mediapost
for each row
begin
 if :new.mediapost_id is null then
 select mediapost_seq.nextval into :new.mediapost_id from dual;
 end if;
end;
/
insert into cd_dbversion (version_str) values ('4.0.0');
INSERT INTO calitemtypes (Description) VALUES ('Concert');
INSERT INTO calitemtypes (Description) VALUES ('Meeting');
INSERT INTO calitemtypes (Description) VALUES ('Lecture');
INSERT INTO calitemtypes (Description) VALUES ('Class');
INSERT INTO calitemtypes (Description) VALUES ('Holiday');
INSERT INTO resourcetype (type_Description) VALUES ('A/V Equipment');
INSERT INTO resourcetype (type_Description,is_location) VALUES ('Facility',1);
INSERT INTO resources (Resource_Type_ID,Resource_Name,descrmode) values (2,'Conference Room',0);
INSERT INTO resourcetype (type_Description) VALUES ('Vehicle');
INSERT INTO calendar (Name) values ('Holidays');
INSERT INTO calendar (Name) values ('Events Calendar');
INSERT INTO calcalendar (calendar_id,child_id) values (2,1);
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32768, 'Calendar', 1, 'Calendar', 'calendar_id');
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32770, 'ResourceType', 3, 'ResourceType', 'resource_type_id');
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32771, 'Resources', 4, 'Resources', 'resource_id');
INSERT INTO objecttypes (object_type_id,type_name,sort_order,table_name,field_name)
 VALUES (32776,'ResourceGroup',5,'ResourceGroup','resourcegroup_id');
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32772, 'CalItemTypes', 6, 'CalItemTypes', 'item_type_id');
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32773, 'Users', 7, 'Users', 'user_id');
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32774, 'Groups', 8, 'Groups', 'group_id');
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32775, 'System', 9, null, null);
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32777,'Reminder',10,null,null);
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32778,'NotificationFilter',11,'NotificationFilter','filter_id');
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32779,'NotificationUser',12,'NotificationUser','n_user_id');
INSERT INTO objecttypes (object_type_id, type_name, sort_order, table_name, field_name)
 VALUES (32780,'CalItem',13,'CalItem','cal_item_id');
insert into objecttypes (object_type_id,type_name,sort_order,table_name,field_name) values
 (32782,'EMailMsg',14,null,null);
insert into objecttypes (object_type_id,type_name,sort_order,table_name,field_name) values
 (32784,'Location',2,'location','location_id');
insert into objecttypes (object_type_id,type_name,sort_order,table_name,field_name) values
 (32781,'SMSMessage',15,null,null);
insert into objecttypes (object_type_id,type_name,sort_order,table_name,field_name) values
 (32783,'MediaAcct',16,'mediaacct','account_id');
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32768, 0, 'tok_Add', 1,0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default,creator_default)
 VALUES (32768, 1, 'tok_Approve', 2,0,0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32768, 1, 'tok_AssignItemStyle', 3,0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32768, 1, 'tok_DefaultApproved', 4, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32768, 1, 'tok_Delete', 5, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32768, 1, 'tok_Edit', 6, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32768, 1, 'tok_EditOthersItems', 7, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default,creator_default)
 VALUES (32768, 1, 'tok_MailOnAdd', 8, 0, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default,creator_default)
 VALUES (32768, 1, 'tok_MailOnEdit', 9, 0, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32768, 1, 'tok_ManageSecurity', 10, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default,creator_default)
 VALUES (32768, 1, 'tok_RevokeOnEdit', 11, 0,0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32768, 1, 'tok_Use', 12, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32768, 1, 'tok_View', 12, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default,creator_default)
 VALUES (32768, 1, 'tok_Include', 13, 0, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default,creator_default)
 VALUES (32768, 1, 'tok_OwnApproved', 14, 0, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32770, 0, 'tok_Add', 1, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32770, 1, 'tok_Delete', 2, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32770, 1, 'tok_Edit', 3, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32770, 1, 'tok_ManageSecurity', 4, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32770, 1, 'tok_View', 5, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32770, 1, 'tok_Use', 6, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32771, 0, 'tok_Add', 1, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32771, 1, 'tok_View', 1, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32771, 1, 'tok_Use', 2, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32771, 1, 'tok_DefaultApproved', 3, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default,creator_default)
 VALUES (32771, 1, 'tok_Approve', 4, 0, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32771, 1, 'tok_Edit', 5, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32771, 1, 'tok_ManageSecurity', 5, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32771, 1, 'tok_Delete', 6, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32772, 0, 'tok_Add', 1, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32772, 1, 'tok_View', 2, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32772, 1, 'tok_Use', 3, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32772, 1, 'tok_Edit', 4, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32772, 1, 'tok_ManageSecurity', 5, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32772, 1, 'tok_Delete', 6, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32773, 0, 'tok_Add', 1, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32773, 0, 'tok_Delete', 2, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32773, 0, 'tok_Edit', 3, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,creator_default)
 VALUES (32773, 1, 'tok_ManageSecurity', 4, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32774, 0, 'tok_Add', 1, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32774, 0, 'tok_Delete', 2, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32774, 0, 'tok_Edit', 3, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,creator_default)
 VALUES (32774, 1, 'tok_ManageSecurity', 4, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32775, 0, 'tok_BulkException', 1, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32775, 0, 'tok_EditConfig', 2, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32775, 0, 'tok_HolidayAdd', 3, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32775, 0, 'tok_ManageItemStyles', 4, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32775, 0, 'tok_PurgeDB', 5, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32775, 0, 'tok_EditPrefs', 6, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32775, 0, 'tok_CreateReminders', 7, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32775, 0, 'tok_PermissionFixup', 8, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32775, 0, 'tok_ManageReminders', 9, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32775, 0, 'tok_CustomFieldDef', 10, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32777, 0, 'tok_AddOthersRem',1,0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32778, 0, 'tok_AddOthersFilt',1,0);
INSERT INTO candidatetokens (Object_Type_ID, instance, token, sort_order,is_default,creator_default)
 VALUES (32776,0,'tok_Add',1,0,0);
INSERT INTO candidatetokens (Object_Type_ID, instance, token, sort_order,is_default,creator_default)
 VALUES (32776,1,'tok_Edit',1,0,1);
INSERT INTO candidatetokens (Object_Type_ID, instance, token, sort_order,is_default,creator_default)
 VALUES (32776,1,'tok_Delete',2,0,1);
INSERT INTO candidatetokens (Object_Type_ID, instance, token, sort_order,is_default,creator_default)
 VALUES (32776,1,'tok_Use',3,1,1);
INSERT INTO candidatetokens (Object_Type_ID, instance, token, sort_order,is_default,creator_default)
 VALUES (32776,1,'tok_ManageSecurity',4,0,1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 0, 'tok_Add', 1, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_Delete', 2, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_Edit', 3, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_ManageSecurity', 4, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_View', 5, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_Use', 6, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order, is_default)
 VALUES(32783, 0, 'tok_Add', 1, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order, is_default)
 VALUES(32783, 1, 'tok_Edit', 1, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order, is_default)
 VALUES(32783, 1, 'tok_Use', 2, 1);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order, is_default)
 VALUES(32783, 1, 'tok_Delete', 3, 0);
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order, is_default)
 VALUES(32783, 1, 'tok_ManageSecurity', 4, 0);
INSERT INTO users (User_Name, Password, Full_Name, enabled) VALUES ('Admin', 'e3afed0047b08059d0fada10f400c1e5', 'Administrative User',1);
insert into users (User_Name, Password, Full_Name, Enabled, Default_Calendar, PlannerStart, PlannerEnd) values ('GUEST', 'DISABLED',' Guest User for Public Calendars', 0, 2, '9:00 AM', '5:00 PM');
INSERT INTO users ( User_Name, Password, Full_Name, enabled, Default_Calendar, PlannerStart, PlannerEnd) VALUES ('customer', 'e3afed0047b08059d0fada10f400c1e5', 'Customer Administrative Account', 1, 2, '9:00 AM', '5:00 PM');
insert into groups (Group_Name,Descr) values ('Users','Normal Users');
insert into groups (Group_Name,Descr) values ('Admins','Users with Administrative Powers');
insert into groupusers (Group_ID,User_ID)
 select groups.Group_ID,users.User_ID
 from users, groups
 Where groups.Group_Name='Users' and users.user_name<>'GUEST';
insert into groupusers (Group_ID,User_ID)
 select groups.Group_ID,users.User_ID
 from users,groups
 Where groups.Group_Name='Admins' AND users.user_name in ('Admin','customer');
Insert into objectsecurity (entity_id, entity_type, secured_obj_type, secured_obj_id, token)
 select groups.group_id, 1, candidatetokens.object_type_id, -1, candidatetokens.token
 from groups, candidatetokens
 where groups.Group_Name='Admins' AND
 candidatetokens.Instance=0;
Insert into objectsecurity (entity_id, entity_type, secured_obj_type, secured_obj_id, token)
 select groups.Group_ID, 1, candidatetokens.object_type_id, calitemtypes.item_type_id, candidatetokens.token
 from groups,calitemtypes, candidatetokens
 where groups.Group_Name='Admins' AND
 candidatetokens.Instance=1 AND
 candidatetokens.Object_Type_ID=32772 AND
 candidatetokens.creator_default=1;
Insert into objectsecurity (entity_id, entity_type, secured_obj_type, secured_obj_id, token)
 select groups.Group_ID, 1, candidatetokens.object_type_id, resourcetype.Resource_Type_ID, candidatetokens.token
 from groups,resourcetype, candidatetokens
 where groups.Group_Name='Admins' AND
 candidatetokens.Instance=1 AND
 candidatetokens.Object_Type_ID=32770 AND
 candidatetokens.creator_default=1;
Insert into objectsecurity (entity_id, entity_type, secured_obj_type, secured_obj_id, token)
 select groups.Group_ID, 1, 32771, resources.Resource_ID, candidatetokens.Token
 from groups,resources,candidatetokens
 where groups.Group_Name='Admins' AND
 candidatetokens.instance=1 AND
 candidatetokens.object_type_id=32771 AND
 candidatetokens.creator_default=1;
Insert into objectsecurity (entity_id, entity_type, secured_obj_type, secured_obj_id, token)
 select groups.Group_ID, 1, 32768, calendar.Calendar_ID, candidatetokens.Token
 from groups,calendar,candidatetokens
 where groups.Group_Name='Admins' AND
 candidatetokens.instance=1 AND
 candidatetokens.object_type_id=32768 AND
 candidatetokens.creator_default=1;
Insert into objectsecurity (entity_id, entity_type, secured_obj_type, secured_obj_id, token)
 select groups.Group_ID, 1, candidatetokens.object_type_id, calitemtypes.item_type_id, candidatetokens.token
 from groups,calitemtypes, candidatetokens
 where groups.Group_Name='Users' AND
 candidatetokens.Instance=1 AND
 candidatetokens.Object_Type_ID=32772 AND
 candidatetokens.is_default=1;
Insert into objectsecurity (entity_id, entity_type, secured_obj_type, secured_obj_id, token)
 select groups.Group_ID, 1, candidatetokens.object_type_id, resourcetype.Resource_Type_ID, candidatetokens.token
 from groups,resourcetype, candidatetokens
 where groups.Group_Name='Users' AND
 candidatetokens.Instance=1 AND
 candidatetokens.Object_Type_ID=32770 AND
 candidatetokens.is_default=1;
Insert into objectsecurity (entity_id, entity_type, secured_obj_type, secured_obj_id, token)
 select groups.Group_ID, 1, 32771, resources.Resource_ID, candidatetokens.Token
 from groups,resources,candidatetokens
 where groups.Group_Name='Users' AND
 candidatetokens.instance=1 AND
 candidatetokens.object_type_id=32771 AND
 candidatetokens.is_default=1;
Insert into objectsecurity (entity_id, entity_type, secured_obj_type, secured_obj_id, token)
 select groups.Group_ID, 1, 32768, calendar.Calendar_ID, candidatetokens.Token
 from groups,calendar,candidatetokens
 where groups.Group_Name='Users' AND
 candidatetokens.instance=1 AND
 candidatetokens.object_type_id=32768 AND
 candidatetokens.is_default=1 AND
 calendar.calendar_id=2;
Insert into objectsecurity (entity_id, entity_type, secured_obj_type, secured_obj_id, token)
 select groups.group_id, 1, 32775, -1, candidatetokens.Token
 from groups,candidatetokens
 where groups.Group_Name='Users' AND
 candidatetokens.instance=0 AND
 candidatetokens.object_type_id=32775 AND
 candidatetokens.is_default=1;
Insert into objectsecurity (entity_id, entity_type, secured_obj_type, secured_obj_id, token)
 select 2, 2, secured_obj_type, secured_obj_id,token
 from objectsecurity, groups
 where entity_id=groups.group_id AND
 entity_type=1 AND
 groups.group_name='Users';
delete from objectsecurity
 where entity_id=2 AND
 entity_type=2 AND
 secured_obj_type=32768 AND
 token = 'tok_Use';
COMMIT WORK;
create or replace function passOneElimination(
 pRecType number,
 pStartDate number,
 pEndDate number,
 pRangeStart number,
 pRangeEnd number)
return number
as
iResult number;
iStartDate number;
iEndDate number;
Begin
 iResult:=0;
 iStartDate:= nvl(pStartDate, -2147483648);
 iEndDate:= nvl(pEndDate, 2147483647);
 if (iStartDate<pRangeStart) then
 if (pRangeStart<=iEndDate) then
 iResult:=1;
 end if;
 else
 if (iStartDate=pRangeStart OR iStartDate<=pRangeEnd) then
 iResult:=1;
 end if;
 end if;
return iResult;
end;
COMMIT WORK;
