DROP VIEW vNotUserItem
~
DROP VIEW vObjectSecurity
~
DROP VIEW vCandidateTokens
~
DROP VIEW vGroupUsers
~
DROP VIEW vCalItem
~
DROP VIEW vCalItemResource
~
DROP VIEW vResource
~
DROP VIEW vResourceGroupResource
~
DROP VIEW vCalCalendar
~
DROP VIEW vObjectUsers
~
DROP VIEW vMimeTypes
~
DROP VIEW vCalGuestMap
~
DROP VIEW vCalTabs
~
CREATE SEQUENCE location_seq
~
CREATE TABLE calitem_calendar (
 cal_item_id int NOT NULL,
 calendar_id int NOT NULL,
 approved_state int DEFAULT 0 NOT NULL,
 approver int NULL,
 approve_date timestamp NULL,
 CONSTRAINT FK_CICal_CI FOREIGN KEY (cal_item_id) REFERENCES calitem (cal_item_id) ON DELETE CASCADE,
 CONSTRAINT FK_CICal_Cal FOREIGN KEY (calendar_id) REFERENCES calendar (calendar_id) ON DELETE CASCADE,
 CONSTRAINT PK_CICal PRIMARY KEY (cal_item_id, calendar_id)
)
~
CREATE INDEX IX_CICAL_CI ON calitem_calendar (cal_item_id)
~
CREATE INDEX IX_CICAL_CALID ON calitem_calendar (calendar_id)
~
insert into calitem_calendar (cal_item_id,calendar_id,approved_state,approver,approve_date)
select cal_item_id,calendar_id,approved_state,approver,approve_date
from calitem_rollups
order by cal_item_id,calendar_id
~
drop table calitem_rollups
~
CREATE TABLE location (
 location_id int NOT NULL PRIMARY KEY DEFAULT NEXTVAL('location_seq'),
 parent_location int NULL,
 location_name VARCHAR(128) NOT NULL,
 location_address VARCHAR(255) NULL,
 latitude double precision NULL,
 longitude double precision NULL,
 flags int DEFAULT 0 NOT NULL,
 location_comments TEXT NULL,
 CONSTRAINT FK_LOC_LOC FOREIGN KEY (parent_location) references location (location_id),
 CONSTRAINT UQ_LOC_NAME UNIQUE (location_name)
 )
~
insert into objecttypes (object_type_id,type_name,sort_order,table_name,field_name) values
 (32784,'Location',14,'location','location_id')
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 0, 'tok_Add', 1, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_Delete', 2, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_Edit', 3, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_ManageSecurity', 4, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_View', 5, 1)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32784, 1, 'tok_Use', 6, 1)
~
drop table notuseritem_schedule
~
alter table notuseritem add next_alarm timestamp NULL
~
alter table groups add ldap_equivs TEXT NULL
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32771, 1, 'tok_DefaultApproved', 6, 0)
~
update calendar set default_type=(select min(item_type_id) from calitemtypes) where default_type is null
~
update users set email_address=lower(email_address) where email_address is not null and email_address<>lower(email_address)
~
insert into objecttypes (object_type_id,type_name,sort_order,table_name,field_name) values
 (32782,'EMailMsg',14,null,null)
~
insert into objecttypes (object_type_id,type_name,sort_order,table_name,field_name) values
 (32781,'SMSMessage',15,null,null)
~
CREATE SEQUENCE mediaacct_seq
~
CREATE SEQUENCE mediapost_seq
~
drop table mediaaccttype
~
drop table mediaaccttype_posttypes
~
create table mediaacct (
 account_id int NOT NULL PRIMARY KEY DEFAULT NEXTVAL('mediaacct_seq'),
 account_type int NOT NULL,
 account_name VARCHAR(80) NOT NULL,
 authenticated boolean DEFAULT false NOT NULL,
 auth_data TEXT NULL,
 last_update timestamp DEFAULT now() NOT NULL,
 CONSTRAINT UQ_MA_AN UNIQUE (account_name)
 )
~
create index IX_MA_AT on mediaacct (account_type)
~
~
create table mediapost (
 mediapost_id int NOT NULL PRIMARY KEY DEFAULT NEXTVAL('mediapost_seq'),
 mediaaccount_id int NOT NULL,
 cal_item_id int NOT NULL,
 post_time timestamp NOT NULL,
 actually_posted timestamp NULL,
 process_flags smallint DEFAULT 0 NOT NULL,
 post_type int DEFAULT 0 NOT NULL,
 post_content TEXT NULL,
 post_metadata TEXT NULL,
 CONSTRAINT UQ_MP UNIQUE (mediaaccount_id,cal_item_id,post_time),
 CONSTRAINT FK_MAP_MA FOREIGN KEY (mediaaccount_id) REFERENCES mediaacct (account_id),
 CONSTRAINT FK_MAP_CI FOREIGN KEY (cal_item_id) REFERENCES calitem (cal_item_id)
 )
~
alter table mediapost drop column post_flags
~
alter table mediapost drop column post_url
~
alter table mediapost drop column post_subject
~
CREATE INDEX IX_MP_CI ON mediapost (cal_item_id)
~
CREATE INDEX IX_MP_MA ON mediapost (mediaaccount_id)
~
CREATE INDEX IX_MP_PROC ON mediapost (process_flags)
~
insert into objecttypes (object_type_id,type_name,sort_order,table_name,field_name) values
 (32783,'MediaAcct',16,'mediaacct','account_id')
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32783, 0, 'tok_Add', 1, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32783, 1, 'tok_Delete', 2, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32783, 1, 'tok_Edit', 3, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32783, 1, 'tok_ManageSecurity', 4, 0)
~
INSERT INTO candidatetokens (object_type_id, instance, token, sort_order,is_default)
 VALUES (32783, 1, 'tok_Use', 6, 1)
~
alter table calitem add location_id int NULL
~
alter table resources add location_id int NULL
~
alter table resources add attributes TEXT NULL
~
alter table resources add constraint FK_RES_LOC FOREIGN KEY (location_id) references location
~
alter table resourcetype add parent_type int NULL
~
alter table resourcetype add attributes TEXT NULL
~
alter table resourcetype add constraint FK_RT_RT FOREIGN KEY (parent_type) references resourcetype
~
alter table users add sms_number VARCHAR(64) NULL
~
alter table notificationuser add sms_number VARCHAR(64) NULL
~
drop table notuserqueue
~
CREATE TABLE notuserqueue (
 queueentry_id int NOT NULL,
 n_user_id int NOT NULL,
 effective_date int NOT NULL,
 processed int DEFAULT 0 NOT NULL,
 inprocess int DEFAULT 0 NOT NULL,
 processresult int DEFAULT 0 NOT NULL,
 ref_type int DEFAULT 0 NOT NULL,
 ref_id int NULL,
 metadata TEXT NULL,
 CONSTRAINT FK_NUQ_NQ FOREIGN KEY (queueentry_id) REFERENCES notificationqueue (queueentry_id) ON DELETE CASCADE,
 CONSTRAINT FK_NUQ_NU FOREIGN KEY (n_user_id) REFERENCES notificationuser (n_user_id) ON DELETE CASCADE,
 CONSTRAINT PK_NUQ PRIMARY KEY (QueueEntry_ID,N_User_ID)
 )
~
CREATE INDEX IX_R_LOC ON resources (location_id)
~
CREATE INDEX CI_LOC ON calitem (location_id)
~
update calitem set itemguid=itemguid || '-' || to_hex(cal_item_id)
where itemguid in (select itemguid from calitem group by itemguid having count(*) > 1)
~
alter table resources add active boolean
~
update resources set active=true
~
alter table resources alter active set default true
~
alter table resources alter active set not null
~
alter table calitem add seq_value int
~
update calitem set seq_value=1 where seq_value is null
~
alter table calitem alter seq_value set default 0
~
alter table calitem alter seq_value set not null
~
alter table calitem add cancelled boolean
~
update calitem set cancelled=false where cancelled is null
~
alter table calitem alter cancelled set default false
~
alter table calitem alter cancelled set not null
~
vacuum full
~
Insert into objectsecurity (entity_id, entity_type, secured_obj_type, secured_obj_id, token)
 select groups.group_id, 1, candidatetokens.object_type_id, -1, candidatetokens.token
 from groups, candidatetokens
 where groups.group_id in (
 select distinct entity_id
 from objectsecurity
 where entity_type=1 AND
 secured_obj_type=32775 and
 secured_obj_id=-1 AND
 token='tok_EditConfig'
 ) AND
 candidatetokens.Instance=0 and
 candidatetokens.object_type_id in (32781,32782,32783,32784)
~
update objectsecurity set secured_obj_id=-1 where secured_obj_id=0
~
update cd_dbversion set version_str='4.0.0'
~
CREATE VIEW vObjectUsers AS
SELECT
 secured_obj_id,
 secured_obj_type,
 token,
 GU.group_id,
 CASE WHEN entity_type=2 THEN entity_id ELSE user_id END AS user_id,
 OT.type_name,
 OT.sort_order,
 OT.table_name,
 OT.field_name
FROM
 objectsecurity
 LEFT OUTER JOIN groupusers GU
 ON objectsecurity.entity_type=1 AND GU.group_id=objectsecurity.entity_id
 INNER JOIN objecttypes OT
 ON objectsecurity.secured_obj_type=OT.object_type_id
~
CREATE VIEW vCalCalendar AS
SELECT
 CC.calendar_id,
 CC.child_id,
 CC.display_opts,
 CCP.name AS parent_name,
 CCC.Name AS child_name
FROM
 calcalendar CC
 INNER JOIN calendar CCP ON CCP.calendar_id=CC.calendar_id
 INNER JOIN calendar CCC ON CCC.calendar_id=CC.child_id
~
CREATE VIEW vResource AS
SELECT
 R.resource_id,
 R.resource_type_id,
 R.active,
 R.location_id,
 R.resource_name,
 R.resource_shared,
 R.description,
 R.attributes,
 RT.type_description,
 LOC.location_name,
 RT.is_location
FROM
 resources R
 INNER JOIN resourcetype RT ON RT.Resource_Type_id=R.Resource_Type_id
 LEFT OUTER JOIN location LOC on LOC.location_id=R.location_id
~
CREATE VIEW vCalItemResource AS
SELECT
 CIR.cal_item_id,
 CIR.resource_id,
 CIR.approved,
 RT.type_description,
 RT.is_location,
 R.resource_type_id,
 R.location_id,
 R.resource_name
FROM
 calitemresource CIR
 INNER JOIN resources R ON R.Resource_id=CIR.Resource_id
 INNER JOIN resourcetype RT ON RT.Resource_type_id=R.Resource_Type_id
~
CREATE VIEW vCalItem AS
SELECT
 CI.*,
 coalesce(U.Full_Name, U.User_Name) as owner_Name
From
 calitem CI
 LEFT OUTER JOIN users U
 ON CI.owner=U.user_id
~
CREATE VIEW vGroupUsers AS
SELECT
 GU.group_id,
 GU.user_id,
 G.group_name,
 U.user_name,
 U.full_name
FROM
 groupusers GU
 INNER JOIN groups G ON GU.group_id=G.group_id
 INNER JOIN users U ON GU.user_id=U.user_id
~
CREATE VIEW vObjectSecurity AS
SELECT
 OSEC.*,
 OT.type_name,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order
FROM
 objectsecurity OSEC
 INNER JOIN objecttypes OT
 ON OSEC.secured_obj_type=OT.object_type_id
 INNER JOIN candidatetokens CT
 ON OSEC.secured_obj_type=CT.object_type_id AND OSEC.token=CT.token
~
CREATE VIEW vCandidateTokens AS
SELECT
 CT.*,
 OT.sort_order AS type_sort_order,
 CT.sort_order AS token_sort_order,
 OT.type_name
FROM
 candidatetokens CT
 INNER JOIN objecttypes OT
 ON CT.object_type_id=OT.object_type_id
~
CREATE VIEW vNotUserItem AS
select NUI.*,
 CI.description
from notuseritem NUI
 LEFT JOIN calitem CI
 ON NUI.cal_item_id=CI.cal_item_id
~
CREATE VIEW vResourceGroupResource AS
Select
 RGR.*,
 R.resource_name
from resourcegroupresource RGR
 INNER JOIN resources R
 ON R.Resource_ID=RGR.Resource_ID
~
CREATE VIEW vMimeTypes as
select
 mime_type,
 count(*) as ref_count
from attachments
group by mime_type
~
create view vCalGuestMap AS
select CGM.*,
 U.user_name
FROM
 calguestmap CGM
 INNER JOIN users U
 ON CGM.guest_user=U.user_id
~
CREATE VIEW vCalTabs as
select
 caltabs.xmldoc_id,
 caltabs.calendar_id,
 caltabs.tab_order,
 xmldocs.xml_doc
from caltabs
 INNER JOIN xmldocs
 ON xmldocs.xmldoc_id=caltabs.xmldoc_id
~
~
