#!/bin/sh
#
#	Upgrade script to update the schema for Connect Daily.
#
if [ -f /etc/sysconfig/tomcat ]; then
	. /etc/sysconfig/tomcat
	PATHLIST="/home/gsexton/cdaily/AddlJars $CATALINA_HOME/common/lib $CATALINA_BASE/shared/lib"
else
	PATHLIST=""
	if [ -z $PATHLIST ]; then
		echo "PATHLIST is not defined. Edit this script and set the path to tomcat."
		echo "PATHLIST should be a space delimited directory list where necessary"
		echo "jar files are stored."
		exit 1
	fi
fi

CPATH="../classes"
for THISPATH in $PATHLIST; do
	if [ ! -d $THISPATH ]; then
		echo JAR DIRECTORY $THISPATH not found. Check PATHLIST and re-run!
		exit 1;
	fi
	echo $THISPATH
	JARLIST=`find $THISPATH -type f -iname "*.jar"`
	for THISJAR in $JARLIST; do
	   CPATH=$CPATH:$THISJAR
	done
done
export CLASSPATH=$CPATH
echo Using Classpath $CLASSPATH
#
#  The actual command to run.
#
java -cp $CLASSPATH com.mhsoftware.cdaily.support.db.Schema340 ../configuration.properties ../style.properties
