/*
    Connect Daily Web Calendar Software

    Copyright 2013, MH Software, Inc. All Rights Reserved
    5023 W 120th Ave, #311, Broomfield CO 80020	
    +1 303 438 9585

    Last Edit By: "$Author: gsexton $"
    Last Checkin: "$Date: 2014/09/22 21:28:49 $"
    Revision #  : "$Revision: 1.8 $"

    This is a customized layer build profile for dojo 1.10.x that's used
    to build combined .js files that contain the elements that we're using.

    Because Dojo is modular, pulling up a page might involve DOZENS of 
    requests to load the various .js files. The Dojo build system creates
    a combined file so there's only one request.

    To Build:

     prep: see DOJO-NOTES.txt

     1) Change to the $DOJO_SRC directory. Run the command:

    util/buildscripts/build.sh --profile /path/to/CDaily.profile.js

     2) If the build succeeds, erase $BUILDDIR/build-report.txt
 
     3) Copy the entire releaseDir /cdaily/scripts directory.

     Refer also to the instructions in cdaily/scripts/DOJO-NOTES.txt

*/

var profile = {
    releaseDir: "/home/gsexton/dojoBuildDir",
    basePath: "",
    action: "release",
    cssOptimize: "comments",
    mini: true,
    optimize: "closure",
    layerOptimize: "closure",
    stripConsole: "all",
    selectorEngine: "acme",
    packages:[{
            name: "dojo",
            location: "dojo"
        },{
            name: "dijit",
            location: "dijit"
        },{
            name: "dojox",
            location: "dojox"
        }
        ],
    layers : {
	"dojox/MHSmobile" : {
	    "resourceName": "cdaily.mobilelayer",
	    "include": [
		"dijit/registry",
		"dijit/_base/manager",
		"dojo/_base/window",
		"dojo/dom-construct",
                "dojo/ready",
		"dojo/parser",
                "dojo/require",
		"dojo/fx",
		"dojo/fx/Toggler",
		"dojox/fx",
        "dojox/mobile",
		"dojox/mobile/_compat",
		"dojox/mobile/compat",
		"dojox/mobile/deviceTheme",
		"dojox/mobile/Badge",
		"dojox/mobile/Button",
		"dojox/mobile/CheckBox",
		"dojox/mobile/ComboBox",
		"dojox/mobile/Heading",
		"dojox/mobile/IconContainer",
		"dojox/mobile/Icon",
		"dojox/mobile/parser",
		"dojox/mobile/RadioButton",
		"dojox/mobile/ScrollableView",
		"dojox/mobile/SimpleDialog",
		"dojox/mobile/Switch",
		"dojox/mobile/ToolBarButton",
		"dojox/mobile/View"
		]
	},
        "dijit/MHSdijit" : {
            "resourceName": "cdaily.stdlayer",
            "include": [
                "dojo/parser",
                "dojo/ready",
                "dojo/i18n",
                "dojo/cldr/nls/gregorian",
                "dojo/cldr/nls/number",
                "dojo/data/ItemFileReadStore",
                "dojo/date/locale",
                "dijit/registry",
                "dijit/_base",
                "dijit/form/ComboBox",
                "dijit/form/ComboButton",
                "dijit/Dialog",
                "dijit/form/NumberSpinner",
                "dijit/form/DateTextBox",
                "dijit/form/FilteringSelect",
                "dijit/form/TimeTextBox",
                "dijit/form/ToggleButton",
                "dijit/MenuBar",
                "dijit/MenuBarItem",
                "dijit/PopupMenuBarItem",
                "dijit/Menu",
                "dijit/MenuItem",
                "dijit/CheckedMenuItem",
                "dijit/MenuSeparator",
                "dijit/PopupMenuItem",
                "dijit/Tooltip",
                "dijit/TooltipDialog",
                "dijit/Tree",
                "dijit/WidgetSet"
            ]
        },
        "dijit/MHSdijitEdit" :  {
            "layerDependencies": [
                                 "dijit/MHSdijit.js"
                                 ],
            "include": [
                       "dijit/Editor",
                       "dijit/_editor/plugins/AlwaysShowToolbar",
                       "dijit/_editor/plugins/FontChoice",
                       "dijit/_editor/plugins/TextColor",
                       "dijit/_editor/plugins/LinkDialog",
                       "dijit/_editor/plugins/NewPage",
                       "dijit/_editor/plugins/ViewSource",
                       "dojox/editor/plugins/AutoUrlLink",
		       "dojox/editor/plugins/LocalImage",
                       "dojox/editor/plugins/PasteFromWord"
                       ]
        }
    },
    resourceTags: {
        amd: function (filename, mid) {
            return /\.js$/.test(filename);
        }
    }
};
