function isWhite(c)
{
    return ((c == '\t') || (c == ' '));
}


function trim(s)
{
    var i, j = s.length;

    for (i = 0; isWhite(s.charAt(i)) && (i < j); i++)
        ;
    if (i == j) return ""; //whole string is white
    for (; isWhite(s.charAt(j-1)); j--)
        ;
    return s.substring(i, j);
}


/*
 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
 * Digest Algorithm, as defined in RFC 1321.
 * Version 2.1 Copyright (C) Paul Johnston 1999 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for more info.
 */

/*
 * Configurable variables. You may need to tweak these to be compatible with
 * the server-side, but the defaults work in most cases.
 */
var hexcase = 0;  /* hex output format. 0 - lowercase; 1 - uppercase        */
var b64pad  = ""; /* base-64 pad character. "=" for strict RFC compliance   */
var chrsz   = 8;  /* bits per input character. 8 - ASCII; 16 - Unicode      */

/*
 * These are the functions you'll usually want to call
 * They take string arguments and return either hex or base-64 encoded strings
 */
function hex_md5(s){ return binl2hex(core_md5(str2binl(s), s.length * chrsz));}
function b64_md5(s){ return binl2b64(core_md5(str2binl(s), s.length * chrsz));}
function str_md5(s){ return binl2str(core_md5(str2binl(s), s.length * chrsz));}
function hex_hmac_md5(key, data) { return binl2hex(core_hmac_md5(key, data)); }
function b64_hmac_md5(key, data) { return binl2b64(core_hmac_md5(key, data)); }
function str_hmac_md5(key, data) { return binl2str(core_hmac_md5(key, data)); }

/*
 * Perform a simple self-test to see if the VM is working
 */
function md5_vm_test()
{
  return hex_md5("abc") == "900150983cd24fb0d6963f7d28e17f72";
}

/*
 * Calculate the MD5 of an array of little-endian words, and a bit length
 */
function core_md5(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << ((len) % 32);
  x[(((len + 64) >>> 9) << 4) + 14] = len;

  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;

    a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
    d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
    c = md5_ff(c, d, a, b, x[i+ 2], 17,  606105819);
    b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
    a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
    d = md5_ff(d, a, b, c, x[i+ 5], 12,  1200080426);
    c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
    b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
    a = md5_ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
    d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
    c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
    b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
    a = md5_ff(a, b, c, d, x[i+12], 7 ,  1804603682);
    d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
    c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
    b = md5_ff(b, c, d, a, x[i+15], 22,  1236535329);

    a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
    d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
    c = md5_gg(c, d, a, b, x[i+11], 14,  643717713);
    b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
    a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
    d = md5_gg(d, a, b, c, x[i+10], 9 ,  38016083);
    c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
    b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
    a = md5_gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
    d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
    c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
    b = md5_gg(b, c, d, a, x[i+ 8], 20,  1163531501);
    a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
    d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
    c = md5_gg(c, d, a, b, x[i+ 7], 14,  1735328473);
    b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);

    a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
    d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
    c = md5_hh(c, d, a, b, x[i+11], 16,  1839030562);
    b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
    a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
    d = md5_hh(d, a, b, c, x[i+ 4], 11,  1272893353);
    c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
    b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
    a = md5_hh(a, b, c, d, x[i+13], 4 ,  681279174);
    d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
    c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
    b = md5_hh(b, c, d, a, x[i+ 6], 23,  76029189);
    a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
    d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
    c = md5_hh(c, d, a, b, x[i+15], 16,  530742520);
    b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);

    a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
    d = md5_ii(d, a, b, c, x[i+ 7], 10,  1126891415);
    c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
    b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
    a = md5_ii(a, b, c, d, x[i+12], 6 ,  1700485571);
    d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
    c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
    b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
    a = md5_ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
    d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
    c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
    b = md5_ii(b, c, d, a, x[i+13], 21,  1309151649);
    a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
    d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
    c = md5_ii(c, d, a, b, x[i+ 2], 15,  718787259);
    b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
  }
  return Array(a, b, c, d);

}

/*
 * These functions implement the four basic operations the algorithm uses.
 */
function md5_cmn(q, a, b, x, s, t)
{
  return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
}
function md5_ff(a, b, c, d, x, s, t)
{
  return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
}
function md5_gg(a, b, c, d, x, s, t)
{
  return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
}
function md5_hh(a, b, c, d, x, s, t)
{
  return md5_cmn(b ^ c ^ d, a, b, x, s, t);
}
function md5_ii(a, b, c, d, x, s, t)
{
  return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
}

/*
 * Calculate the HMAC-MD5, of a key and some data
 */
function core_hmac_md5(key, data)
{
  var bkey = str2binl(key);
  if(bkey.length > 16) bkey = core_md5(bkey, key.length * chrsz);

  var ipad = Array(16), opad = Array(16);
  for(var i = 0; i < 16; i++)
  {
    ipad[i] = bkey[i] ^ 0x36363636;
    opad[i] = bkey[i] ^ 0x5C5C5C5C;
  }

  var hash = core_md5(ipad.concat(str2binl(data)), 512 + data.length * chrsz);
  return core_md5(opad.concat(hash), 512 + 128);
}

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function bit_rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

/*
 * Convert a string to an array of little-endian words
 * If chrsz is ASCII, characters >255 have their hi-byte silently ignored.
 */
function str2binl(str)
{
  var bin = Array();
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < str.length * chrsz; i += chrsz)
    bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (i%32);
  return bin;
}

/*
 * Convert an array of little-endian words to a string
 */
function binl2str(bin)
{
  var str = "";
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < bin.length * 32; i += chrsz)
    str += String.fromCharCode((bin[i>>5] >>> (i % 32)) & mask);
  return str;
}

/*
 * Convert an array of little-endian words to a hex string.
 */
function binl2hex(binarray)
{
  var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i++)
  {
    str += hex_tab.charAt((binarray[i>>2] >> ((i%4)*8+4)) & 0xF) +
           hex_tab.charAt((binarray[i>>2] >> ((i%4)*8  )) & 0xF);
  }
  return str;
}

/*
 * Convert an array of little-endian words to a base-64 string
 */
function binl2b64(binarray)
{
  var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i += 3)
  {
    var triplet = (((binarray[i   >> 2] >> 8 * ( i   %4)) & 0xFF) << 16)
                | (((binarray[i+1 >> 2] >> 8 * ((i+1)%4)) & 0xFF) << 8 )
                |  ((binarray[i+2 >> 2] >> 8 * ((i+2)%4)) & 0xFF);
    for(var j = 0; j < 4; j++)
    {
      if(i * 8 + j * 6 > binarray.length * 32) str += b64pad;
      else str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
    }
  }
  return str;
}
/* 
	This file contains javascript methods used by Connect Daily for Mobile
	operations.

	Connect Daily Web Calendar Software

	Copyright 2011-2014, MH Software, Inc. All Rights Reserved
	5023 W 120th Ave #311, Broomfield CO 80020
	+1 303 438 9585

	Last Edit By: "$Author: gsexton $"
	Last Checkin: "$Date: 2014/09/16 22:16:58 $"
	Revision #  : "$Revision: 1.6 $"
*/

function bookmarkPage()
	{
	var href=window.location.href;
	var stitle=document.title;
	if(window.sidebar)	// firefox
		{
		window.sidebar.addPanel(stitle, href, "");
		} else if(window.opera && window.print)	// opera
		{
		var elem = document.createElement('a');
		elem.setAttribute('href',href);
		elem.setAttribute('title',stitle);
		elem.setAttribute('rel','sidebar');
		elem.click();
		} else if(document.all)// ie
		{
		window.external.AddFavorite(href, stitle);
		} else
		{
		alert("Browser doesn't support this.");

		}

	}

/** 
 * Function to set div content. 
*/
function setContentDivText2(params) {
	oCache.addEntry(params.url,params.result);

	document.getElementById("ContentDiv").innerHTML=params.result;

	var tbl=document.getElementById('IDEventList');
	if(tbl!=null) {
		var sTitle=tbl.getAttribute("data-title");
		if(sTitle!=null) {
			document.title=sTitle;
		}
	}

	if(params.enableSwipe) {
		addSwipeNavigation();
	}

	require(["dijit/registry"],function(registry){
			var d=registry.byId("ViewContainer");
			d.scrollTo({x:0,y:0});
		});
}

Date.prototype.getLocalTime=function()
	{
	/**
		* Our current time is UTC time + offset
		*/
	return this.getTime()+(this.getTimezoneOffset()*60000);
	};
/*
				iJulianDate,integral, and criteria are external.
*/
var oCache=null;

function updateDisplay(sURL,enableSwipe) {
	if(oCache==null) {
		oCache=new AjaxCache();
	}
	var params=new RemoteRequestParam(sURL);
	var sValue=oCache.fetchValueFromCache(sURL);
	if(enableSwipe!=undefined)
		{
		params.enableSwipe=enableSwipe;
		}
	if(sValue==null) {
		params.fCallback=setContentDivText2;
		getRemoteText2(params); 
	} else {
		params.result=sValue;
		setContentDivText2(params);
	}
}

function setDetailsContent(content) {
	var div=document.getElementById('eventDetailsSection');
	div.innerHTML=content;
	console.log("setDetailsContent(content="+content+"\n);");
	require(["dijit/registry"],function(registry){
		var d=registry.byId('ViewContainer');
		d.performTransition('eventDetails',1,"slide");
		/*
			This is necessary because say you scroll a really long event. When
			you view a shorter one, nothing is visible.
		*/
		d=registry.byId('eventDetails');
		d.scrollTo({x:0,y:0});
	});
}

function setRemindersContent(content) {
	var div=document.getElementById('eventRemindersSection');
	div.innerHTML=content;
	console.log("setRemindersContent(content="+content+"\n);");
	require(["dijit/registry"],function(registry){
		var d=registry.byId('ViewContainer');
		d.performTransition('eventReminders',1,"slide");
		/*
			This is necessary because say you scroll a really long event. When
			you view a shorter one, nothing is visible.
		*/
		d=registry.byId('eventReminders');
		d.scrollTo({x:0,y:0});
	});
}

function displayEvent(sURL)
	{
	if(oCache==null) {
		oCache=new AjaxCache();
	}
	var params=new RemoteRequestParam(sURL);
	var sValue=oCache.fetchValueFromCache(sURL);

	if(sValue==null) {
		params.fCallback=function(params) {
				oCache.addEntry(sURL,params.result)
				setDetailsContent(params.result);
			};
		getRemoteText2(params); 
	} else {
		setDetailsContent(sValue);
	}
}

function setDefaultJulianDate() {
	var d=new SimpleDate();
	iJulianDate=d.getJulian();
}

function advanceDisplay(direction) {

	if(iJulianDate==null || iJulianDate==undefined) {
		setDefaultJulianDate();
	}

	if(isDayMode()) {
		// We're on day view.
		advanceDay(direction);
	} else {
		advanceMonth(direction);
	}
}

function advanceDay(direction) {
	
	if(iJulianDate==null || iJulianDate==undefined) {
		setDefaultJulianDate();
	}
	var rng=getJulianRange();
	if(direction==1) {
		
		if(rng.end==Number.MIN_VALUE) {
			iJulianDate++;
		} else {
			iJulianDate=rng.end;
		}
	} else if(direction==-1) {
		if(rng.start==Number.MAX_VALUE) {
			iJulianDate--;
		} else {
			iJulianDate=rng.start;
		}
		
	}

	if(criteria==null) {
		setCriteria();
	}

	var sURL="ViewMobile.html?date="+iJulianDate+
	(criteria==null ? "" : "&"+criteria)+
	"&action=render&dir="+direction;

	updateDisplay(sURL,true);
}


function elementExists(elementName)
	{
	var el=document.getElementById(elementName);
	return el!=null;
	}
function setMode(dayMode) {
	var lnk=document.getElementById('MonthView');
	lnk.style.display=dayMode ? 'block' : 'none';
	lnk=document.getElementById('DayView');
	lnk.style.display=dayMode ? 'none' : 'block';
}

function isDayMode(){
	// kind of non-intuitive. DayView is not visible if we're in day mode. MonthView is.
	return document.getElementById('DayView').style.display=='none';
}

function setCriteria()
	{
	criteria=getCookies()["criteria"];
	if(criteria!=null && ((typeof criteria)=='string') && criteria.indexOf('"')==0)
		{
		// this is a quoted value.
		criteria=criteria.substring(1,criteria.length-1);
		}

	}

function getJulianRange(){
	var res={"start": Number.MAX_VALUE, "end": Number.MIN_VALUE};
	require(["dojo/query","dojo/dom-attr"],function(query,domAttr){
		var a=query('.NextJulianDay');
		for(var i=0; i < a.length; i++) {
			var iThis=parseInt(domAttr.get(a[i],"data-end-value"),10);
			if(iThis>res.end) {
				res.end=iThis
			}
			iThis=parseInt(domAttr.get(a[i],"data-start-value"),10);
			if(iThis<res.start) {
				res.start=iThis;
			}
		}
	});
	console.log("getJulianRange() returns start="+res.start+" end="+res.end);
	return res;
}

function handleAction(verb,additional) {
	console.log("handleAction(verb="+verb+", addtional="+additional+");");
	var sURL;

	if(typeof criteria==='undefined' || criteria==null) {
		setCriteria();
	}

	if(document.body.cancelSwipeListener) {
		document.body.cancelSwipeListener();
	}
	if (verb=='scroll-up' && isDayMode()) {
		var rng=getJulianRange();
		if(rng.start==Number.MAX_VALUE) {
			advanceDisplay(-1)
		} else {
			require(["dojo/dom","dijit/registry"],function(dom,registry){
				var d=dom.byId("ContentDiv");
				var iCurrentHeight=additional
				sURL="ViewMobile.html?date="+(rng.start-1)+(criteria==null ? "" : "&"+criteria)+"&action=render&dir=-1";

				var sValue=oCache.fetchValueFromCache(sURL);

				if(sValue==null) {
					var params=new RemoteRequestParam(sURL);
					params.fCallback=function(params){
						if(params.result.length>0) {
							d.innerHTML=params.result+d.innerHTML;
							d=registry.byId("ViewContainer");
							var dim=d.getDim();
							d.scrollTo({x: 0, y: -1*(dim.c.h-additional)+dim.d.h});
						}
					};
					getRemoteText2(params); 
				} else {
					d.innerHTML=sValue+d.innerHTML;
				}
			});
		}
		
	} else if (verb=='scroll-down' && isDayMode()) {
		require(["dojo/dom"],function(dom){
			/*
				OK, we have the maximum current value. get the data.
			*/
			var rng=getJulianRange()
			sURL="ViewMobile.html?date="+(rng.end+1)+(criteria==null ? "" : "&"+criteria)+"&action=render&dir=1";
			
			var sValue=oCache.fetchValueFromCache(sURL);
			if(sValue==null) {
				var params=new RemoteRequestParam(sURL);
				params.fCallback=function(params){
					if(params.result.length>0) {
						dom.byId("ContentDiv").innerHTML+=params.result;
					}
				};
				getRemoteText2(params); 
			} else {
				dom.byId("ContentDiv").innerHTML+=sValue;
			}
			
		});
	} else if(verb=='next') {
		advanceDisplay(1);
	} else if(verb=='previous') {
		advanceDisplay(-1)
	} else if(verb=='null') {
		pageNullOp();
	}  else if(verb=='today') {
		var dToday=new SimpleDate();
		iJulianDate=dToday.getJulian();
		oCache.clearCache();
		setMode(true);
		advanceDisplay(0);
	} else if(verb=='item') {
		sURL="ViewMobile.html?integral="+integral+"&action=item&cal_item_id="+additional+"&date="+iJulianDate;
		displayEvent(sURL);
	} else if(verb=='MonthView') {
		setMode(false);
		require(["dijit/registry"],function(registry){
			var d=registry.byId("ViewContainer");
			d.scrollTo({x:0, y:0});
		});
		advanceDisplay(0);
	} else if(verb=='DayView') {
		setMode(true);
		iJulianDate=new SimpleDate().getJulian();
		advanceDisplay(0);
	} else if (verb=='EditReminders') {
		var sURL='EditReminder.html?mobile=1&integral=1&cal_item_id='+additional;
		window.open(sURL);
	}
}

function toggleElements(eleA,eleB,eleC,eleD,eleE,eleF,eleG,eleH)
	{

	for(var i=0; i < arguments.length; i++)
		{
		var obj=document.getElementById(arguments[i]);
		if(obj!=null)
			{
			if(obj.style.display=='none')
				{
				obj.style.display='block';
				} else
				{
				obj.style.display='none';
				}
			}
		}

	}

function setCookie(c_name,value,exdays)
	{
	var exdate=new Date();
	exdate.setDate(exdate.getDate() + exdays);
	var c_value=escape(value) + ((exdays==null) ? "" : "; expires="+exdate.toUTCString());
	document.cookie=c_name + "=" + c_value;
	}

function getCookies()
	{
	var cookies={};
	var all=document.cookie;
	if(all===null || all==='')
		{
		return cookies;
		}
	var list=all.split('; ');
	for(var i=0; i < list.length; i++)
		{
		var cookie=list[i], p=cookie.indexOf("="),
		name=cookie.substring(0,p),
		value=cookie.substring(p+1);
		value=decodeURIComponent(value);
		cookies[name]=value;
		}
	return cookies;
	}


function saveOptionsForm()
	{
	console.log("saveOptionsForm()");
	var chkBox=document.getElementById("IDUseBDT");
	if(chkBox==null) { 
		console.log("UseBDT Not found on Form.")
	} else {
		var chkUseBDT=chkBox.value;
		setCookie("UseBDT",
		("on"==chkUseBDT) ? "1" : "0",
		("on"==chkUseBDT) ? 365 : 0
		);
		console.log("UseBDT="+chkUseBDT);
	}
	
	var ddViewBy=document.getElementById("IDViewBy");
	var ddView=document.getElementById("IDView");
	criteria=ddViewBy.options[ddViewBy.selectedIndex].value+"="+
	ddView.options[ddView.selectedIndex].value;
	setCookie("criteria",'"'+criteria+'"',365);
	console.log("criteria="+criteria);
	document.title=ddView.options[ddView.selectedIndex].text;
	var ddTZ=document.getElementById('IDtimezone');
	if(ddTZ!=null) {
		var sTZ=ddTZ.options[ddTZ.selectedIndex].text;
		setCookie("timezone",sTZ,365);
		console.log("timezone="+sTZ);
	}


	if(!(document.frmOptions["show_resources"]===undefined)) {
		var chkShowResources=document.frmOptions.show_resources.value;
		if(chkShowResources!=undefined) {
			setCookie("show_resources", "on"==chkShowResources ? "1" : "0", 365);
		}
		console.log("chkShowResources="+chkShowResources);
	}

	if(oCache!=null) {
		oCache.clearCache();
	}

	handleAction('null');

	console.log("exiting saveOptionsForm()");
}

function isIE()
	{
	return navigator.userAgent.toLowerCase().indexOf("msie")>0 ||
	navigator.userAgent.toLowerCase().indexOf("trident")>0;
	}

function actualRefreshViewDropdown(params)
	{
	var json=params.result;
	var bIE=isIE();
	var dd=document.getElementById('IDView');
	dd.options.length=0;
	for(var i=0; i<json.items.length; i++)
		{
		if(bIE)
			{
			dd.add(new Option(json.items[i].name,json.items[i].object_id));
			} else
			{
			dd.add(new Option(json.items[i].name,json.items[i].object_id,false,false),null);
			}
		}
	dd.focus();
	
	}

function refreshViewDropdown() {
	var ddViewBy=document.getElementById('IDViewBy');
	var params=new RemoteRequestParam("json/objects.js?request_number=2&integral"+integral+"&"+
	ddViewBy.options[ddViewBy.selectedIndex].value+"=-1");
	params.fCallback=actualRefreshViewDropdown;
	params.handleAsJSON=true;
	getRemoteText2(params);
	
}

function hideURLBar() {
	if((navigator.userAgent.indexOf('iPad')>0)||
		(navigator.userAgent.indexOf('iPod')>0)||
		(navigator.userAgent.indexOf('iPhone')>0)
		) {
		window.scrollTo(0,1);
	}
}

function hideElement(elementID) {
	var ele=document.getElementById(elementID);
	if(ele==null) {
		alert('Element '+elementID+' not found in document!');
	} else {
		ele.style.display='none';
	}
}



/**
	* This is a simple javascript date class.
	* 
	* @author gsexton (7/9/2011)
	* 
	* @param year 
	* @param month 1-12
	* @param day Day of month (1-31)
	*/
function SimpleDate(year,month,day)
	{
	if(arguments.length==0)
		{
		var dTemp=new Date();
		this.year=dTemp.getFullYear();
		this.month=dTemp.getMonth()+1;
		this.day=dTemp.getDate();
		} else
		{
		if(month==null||month==undefined||month<1||month>12)
			{
			throw "InvalidMonth in SimpleDate Constructor - month="+month;
			}
		if(day<1||day>daysMonth(year,month))
			{
			throw "SimpleDate Constructor. Invalid Date - Year="+year+' month='+month+' day='+day;
			}
		this.year=year;
		if(this.year<100)
			{
			this.year+=2000;
			}
		this.month=month;
		this.day=day;
		}
	}

/**
	* Parse a date string and return a new SimpleDate object. 
	*  
	* @param sInput - The input string. If the string is 
	* DDDD-DD-DD, it's interpreted as YYYY-MM-DD, otherwise 
	* it's parsed using the Javascript Date() object. 
	*/
SimpleDate.parse=function(sInput)
	{
	if(sInput==null || sInput.length==0) {
		return new SimpleDate();
	} else if(sInput.match(/\d{4}-\d{2}-\d{2}/)) {
			return new SimpleDate(
					parseInt(sInput.substring(0,4),10),
					parseInt(sInput.substring(5,2),10),
					parseInt(sInput.substring(8,2),10)
				);
	} else {
		var dTemp;
		try
		{
			dTemp=new Date(sInput)
		} catch (ex)
			{
			dTemp=new Date();
			}
		return new SimpleDate(dTemp.getFullYear(),dTemp.getMonth()+1,dTemp.getDay());
	}
}
/**
* Return true if the object represents a date that is in a
* leap year. 
*  
* @param iYear - the year to test. 
*  
*/
function leapYear(iYear)
	{
	var result=false;
	if((iYear%4)==0)
		{
		if((iYear%100)==0)
			{
			if((iYear%400)==0)
				{
				result=true;
				}
			} else
			{
			result=true;
			}
		}
	return result;

	}
function daysMonth(iYear,iMonth)
	{
	switch(iMonth)
		{
		case 2:
			if(leapYear(iYear))
				{
				return 29;
				} else
				{
				return 28;
				}
			break;
		case 4:
		case 6:
		case 9:
		case 11:
			return 30;
			break;
		default:
			return 31;
			break;
		}
	}

/** Return true if the object represents a date that is in a
	*  leap year.
	*/
SimpleDate.prototype.isLeapYear = function()
	{
	return leapYear(this.year)
	}


/** Return the number of days in the current month for this
	*  date object.
	*/
SimpleDate.prototype.daysPerMonth = function()
	{
	return daysMonth(this.year,this.month);
	}

SimpleDate.prototype.getJulian=function()
	{
	var dTemp=new Date(this.year,this.month-1,this.day);
	return Math.floor((dTemp / 86400000) -
	(dTemp.getTimezoneOffset()/1440) + 2440588);
	}

SimpleDate.prototype.setDate=function(iDate)
	{
	var dTemp=new Date(1970,0,1);
	/*
					The logic is
		
					Subtract EPOCH_START days from the parameter.
		
					Multiple that by MillisPerDay
		
					That gives us the Seconds (GMT) for that date.
					When we convert that value to a date, we'll have the GMT date.
		
					We need to add in our TimeZone Offset in Millis to shift the date
					to our time zone.
	*/
	var lMinutes=(iDate-2440587)*1440+dTemp.getTimezoneOffset();
	dTemp=new Date(lMinutes*60000);
	this.year=dTemp.getFullYear();
	this.month=dTemp.getMonth()+1;
	this.day=dTemp.getDay();
	}
/**
	* Increment the date by one day.
	*/
SimpleDate.prototype.increment = function()
	{
	this.day++;
	if(this.day>this.daysPerMonth())
		{
		this.day=1;
		this.goMonth(1);
		}
	}

/**
	* Decrement the date by one day.
	*/
SimpleDate.prototype.decrement = function()
	{
	this.day--;
	if(this.day==0)
		{
		this.month--;
		if(this.month==0)
			{
			this.month=12;
			this.year--;
			}
		this.day=this.daysPerMonth();
		}
	}

/**
	* Increment (or decrement) the month by the specified number of 
	* months. Similar to the FoxPro function. 
	*  
	* @note: If the day is greater than the number of days in the 
	*      target month, then the day value is set to the ending
	*      date. For example, date: 2011-01-31 is incremented by 1
	*      month, the new value is 2011-02-28.
	*  
	* @Param offset - # Months to offset date by. Can be negative. 
	*  
	*  
	*/
SimpleDate.prototype.goMonth=function(offset)
	{
	if(offset>0)
		{
		for(var iIncrMonth=offset; iIncrMonth>0; iIncrMonth--)
			{
			this.month++;
			if(this.month>12)
				{
				this.month=1;
				this.year++;
				}
			}
		} else
		{
		for(var iDecrMonth=offset; iDecrMonth < 0; iDecrMonth++)
			{
			this.month--;
			if(this.month==0)
				{
				this.month=12;
				this.year--;
				}
			}
		}
	if(this.day>this.daysPerMonth())
		{
		this.day=this.daysPerMonth();
		}
	}

/**
	* Get the day of week where 0=Sunday, and 6=Saturday.
	*/
SimpleDate.prototype.getDOW=function()
	{

	var t=[0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4];
	var iYear=this.year;
	if(this.month<3)
		{
		iYear--;
		}
	return(iYear+Math.floor(iYear/4)-Math.floor(iYear/100)+Math.floor(iYear/400)+t[this.month-1]+this.day)%7;
	/* 
	Sakamoto's algorithm. 
	int dow(int y, int m, int d) {
					static int t[] = [0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4];
					y -= m < 3;
					return (y + y/4 - y/100 + y/400 + t[m-1] + d) % 7;
	}
	*/
	
	}

/** 
	* This is a static method to parse a date value using a 
	* specified format and return a new SimpleDate object. 
*/
SimpleDate.parseDate=function(sValue,sFormat)
	{
	function parseParts(sInput)
		{
		/**
			* So, given something like yyyy-mm-dd we get yyyy,mm,dd.
			*/
		var aResult=new Array(3), iPos=0, s='',i,c;
		for(i=0; i < sInput.length; i++)
			{
			c=sInput.charAt(i);
			if((c>='0' && c<='9') || (c=='d'||c=='D'||c=='m'||c=='M'||c=='y'||c=='Y'))
				{
				s+=c;
				} else
				{
				if(s.length>0)
					{
					aResult[iPos++]=s;
					s='';
					}
				}
			}
		if(s.length>0)
			{
			aResult[iPos]=s;
			}
		return aResult;
		}
	function reorderElements(aDateParts,aFormatParts)
		{
		var aResult=new Array(3),i;
		for(i=0; i < 3; i++)
			{
			var c=aFormatParts[i].toLowerCase().charAt(0);
			switch(c)
				{
				case 'd':
					aResult[2]=parseInt(aDateParts[i],10);
					break;
				case 'm':
					aResult[1]=parseInt(aDateParts[i],10);
					break;
				case 'y':
					aResult[0]=parseInt(aDateParts[i],10);
					break;
				}
			}
		return aResult;
		}
	var aValue,aFormat;
	try
	{
		aValue=parseParts(sValue);
		aFormat=parseParts(sFormat);
		aValue=reorderElements(aValue,aFormat);
		// alert('sValue='+sValue+' sFormat='+sFormat+'\n\n0='+aValue[0]+' 1='+aValue[1]+' 2='+aValue[2]);
		
	} catch (exError)
		{
		// alert(exError);
		return null;
		}
	return new SimpleDate(aValue[0],aValue[1],aValue[2]);
	}

/** Return the value of this date object in YYYY-MM-DD
	*  format.
	*/
SimpleDate.prototype.toString=function()
	{
	var s=this.year+'-';
	if(this.month<10)
		{
		s=s+'0';
		}
	s=s+this.month+'-';
	if(this.day<10)
		{
		s=s+'0';
		}
	s=s+this.day;
	return s;
	}

/** Return true if two date objects are equal (same date).  */
SimpleDate.prototype.equals=function(d)
	{
	return(this.year==d.year && this.month==d.month && this.day==d.day);
	}

Calendar.defaultLocaleInfo={
	/** The format for dates.  */
	"format" : "mm/dd/yyyy",
	/** The character months of the year. */
	"months" : ["unused","January","February","March","April","May","June","July","August","September","October","November","December"],
	/** The starting day of week, where 0=Sunday. */
	"startdow" : 0,
	/** Abbeviations for the short days of the week. */
	"shortdays" : ["Su","M","T","W","Th","F","Sa"],
	"cancelLabel" : "Cancel"
};
/**
	* Constructor for the Calendar class.
	*/
function Calendar()
	{
	/** String Buffer to hold rendered output.  */
	this.buffer='';
	/** The Name of the HTML Select Element to render. */
	this.selectName='selDate';
	/** Function to invoke when the select is changed.   */
	this.onSelectChanged=calendarSelectChangeFunc;
	/** Date Variable for rendering.  */
	this.d=new SimpleDate();
	this.d.day=1;
	/** A "Today" object. Used for highlighting the current date. */
	this.dToday=new SimpleDate();
	/** The CSS Class Name for the rendered calendar. */
	this.CSSClass='';
	/** The days of the month that should be emphasized because
		*  there are events on them.
		*/
	this.selecteddays='';
	/** The callback function to be used when someone selects a
		*  date.
		*/
	this.daySelectCallback='daySelect';
	/** The Locale Information for rendering.   */
	this.localeInfo= Calendar.defaultLocaleInfo;
	/** Function to advance or decrement month */
	this.advanceFunction=null;
	/** Draw a cancel button underneath the table
		*  The cancel function invokes daySelectCallback with -1,-1,-1
		*/
	this.drawCancel=false;
	}

/**
	* Set the CSS Class Name(s) for the rendered table.
	*/
Calendar.prototype.setClass=function(classname)
	{
	this.CSSClass=classname;
	}

/**
	* Helper function to append to a string buffer.
	*/
Calendar.prototype.write=function(str)
	{
	this.buffer+=str;
	}

/**
	* Set the String for the days that should be "highlighted" 
	* because there are events on that date. 
	*/
Calendar.prototype.setSelectedDays=function(sSelected)
	{
	this.selecteddays=sSelected;
	}

/**
	* Retrieve the HTML that was rendered.
	*/
Calendar.prototype.getHTML=function()
	{
	return this.buffer;
	}

/**
	* Reset the current date object to the first day of the week.
	*/
Calendar.prototype.resetToStartDOW=function()
	{
	
	while(this.d.getDOW()!=this.localeInfo.startdow)
		{
		
		this.d.decrement();
		}
	
	}

/**
	* Set the Locale Info. Elements of a Locale Info object 
	* are 
	*  
	* String months[] , character names for the months of the year. 
	* Values. Should start at element 1. 
	*  
	* startdow - The starting dow for the locale. 0=Sunday. 
	*  
	* shortdays - The abbreviations for the short days of the week. 
	* E.G. Su,M,T,W,Th,F,Sa 
	*/
Calendar.prototype.setLocaleInfo=function(info)
	{
	this.localeInfo=info;
	}

/**
	* Render one week of the calendar. 
	*  
	* @param iCurrentMonth the month we're targeting for calendar 
	*                      display. 
	*  
	*/
Calendar.prototype.renderWeek=function(iCurrentMonth)
	{

	this.write("<tr>");
	var sClass='';
	var sCell;
	var bSelecting=(this.selecteddays!=null && this.selecteddays.length>0);
	var bSelected;
	for(var i=0; i < 7; i++)
		{
		sCell='<td';
		sClass='';
		bSelected=false;
		if(this.dToday.equals(this.d))
			{
			sClass='Today ';
			}
		if(this.d.month==iCurrentMonth)
			{
			if(bSelecting && (this.selecteddays.charAt(this.d.day-1)=='1'))
				{
				bSelected=true;
				sClass+='SelectedDay';
				}
			} else
			{
			sClass+='OffDay';
			}
		if(sClass.length>0)
			{
			sCell=sCell+" class=\""+sClass+"\"";
			}
		sCell=sCell+" onclick=\""+this.daySelectCallback+"("+this.d.year+","+this.d.month+","+this.d.day+");\">"+this.d.day+"</td>";
		this.write(sCell);
		this.d.increment();
		}
	this.write("</tr>\n");
	}

/**
	* Render th HTML Select element for quick navigation.
	*/
Calendar.prototype.renderSelect=function(iYear,iMonth)
	{
	if(this.selectName==null)
		{
		return;
		}
	var dTemp=new SimpleDate(this.d.year,this.d.month,1);
	dTemp.goMonth(-36);
	this.write("<tr><td id=SelectCell COLSPAN=7><select name=\""+this.selectName+"\" ID=\"ID"+this.selectName+"\">");
	for(var iOption=0; iOption < 96; iOption++)
		{
		if(dTemp.month==1 || iOption==0)
			{
			this.write("\n<optgroup label='"+dTemp.year+"'>");
			}
		this.write("<option "+((dTemp.year==iYear&&dTemp.month==iMonth) ? "selected " : "")+"value=\""+dTemp.year+"-"+dTemp.month+"\">"+this.localeInfo.months[dTemp.month]+' '+dTemp.year);
		if(dTemp.month==12)
			{
			this.write("</optgroup>");
			}
		dTemp.goMonth(1);

		}
	this.write("</select></td></tr>\n");
	}

/**
	* Render the headings for the days of the week.
	*/
Calendar.prototype.renderWeekHeading=function()
	{
	this.write("<tr class=WeekHead>");
	var iDay=this.localeInfo.startdow;
	for(var iDow=0; iDow<7; iDow++)
		{
		this.write("<th>"+this.localeInfo.shortdays[iDay++]+"</th>");
		if(iDay>6)
			{
			iDay=0;
			}
		}
	this.write("</tr>\n");
	}
Calendar.prototype.renderPickerHeading=function(yr,mo)
	{
	if(this.advanceFunction==null)
		{
		this.write("<tr><td class=MonthTitle colspan=7>"+
		this.localeInfo.months[mo]+' '+yr+
		"</td></tr>")
		} else
		{
		this.write("<TR><TD ID=Previous Class=advanceCell>");
		this.write("<A HREF='javascript:"+this.advanceFunction+"("+yr+","+mo+",-1);'>&lt;</A>");
		this.write("</TD><TD COLSPAN=5 Class=MonthTitle>"+this.localeInfo.months[mo]+' '+yr+"</TD>");
		this.write("<TD ID=Next Class=advanceCell>"+
		"<A HREF='javascript:"+this.advanceFunction+"("+yr+","+mo+",1);'>&gt;</A>"+
		"</TD></TR>");
		}

	}
/** 
	* Render the HTML Calendar. The output is retrieved by calling 
	* .getHTML() 
*/
Calendar.prototype.render=function(year,month)
	{
	this.d=new SimpleDate(year,month,1);
	this.resetToStartDOW();
	this.buffer='';
	this.write("<form>");
	this.write("<table class=\""+this.CSSClass+"\">\n<THEAD>\n");
	if(this.selectName==null)
		{
		this.renderPickerHeading(year,month);
		} else
		{
		this.renderSelect(year,month);
		}
	this.renderWeekHeading();
	this.write("</thead><tbody>");
	do
		{
		this.renderWeek(month);
		} while(this.d.month==month);
	this.write("</TBODY>\n</TABLE>\n");
	if(this.drawCancel)
		{
		this.write("<BUTTON ID=DatePickerCancel TYPE=BUTTON onclick='"+this.daySelectCallback+"(-1,-1,-1);'>"+this.localeInfo.cancelLabel+"</BUTTON>")
		}
	this.write("</FORM>");
	}

/** Actually do the render. */
function drawCalendar(yr,mo,cssClass)
	{
	if(arguments.length==0)
		{
		var dTemp=new Date();
		yr=dTemp.getFullYear();
		mo=dTemp.getMonth()+1;
		}
	var cal=new Calendar();					// Instantiate the class.
	if(cssClass!=null)
		{
		cal.setClass(cssClass);					// Set the CSS Class for the table.
		}
	cal.render(yr,mo);										// Render the calendar.
	var myDiv=document.getElementById(calContentDivName);			// Get the Div where the content goes.
	myDiv.innerHTML=cal.getHTML();																										// Set the HTML onto the object.
	if(cal.selectName!=null)
		{
		var mySelect=document.getElementById('IDselDate');						// Get the Date Selection input device.
		mySelect.onchange=cal.onSelectChanged;
		}
	}


/**
* Function called when the Select element changes. 
* Assumes the default element name of selDate. 
*/
function calendarSelectChangeFunc()
	{
	//  Get the select element.
	var sel=document.getElementById('IDselDate');
	//  Get the Value in format YYYY-M[M].
	var sValue=sel.options[sel.selectedIndex].value;
	iYear=parseInt(sValue.substring(0,4),10);
	iMonth=parseInt(sValue.substr(5),10);
	var dTemp=new SimpleDate(iYear,iMonth,1);
	iJulianDate=dTemp.getJulian();
	//  Draw the new calendar.
	drawCalendar(iYear,iMonth);
	}


function daySelect(yr,mo,da)
	{
	if(arguments.length==0)
		{
		var dTemp=new SimpleDate();
		yr=dTemp.year; mo=dTemp.month; da=dTemp.day;
		}
	setMode(true);
	iJulianDate=new SimpleDate(yr,mo,da).getJulian();
	advanceDisplay(0);
	}

// calendarYear, calendarMonth are external.
function advanceMonth(direction) {
	console.log("advanceMonth(direction="+direction+");")
	console.log("iJulianDate="+iJulianDate);
	var dTemp=new SimpleDate();
	dTemp.setDate(iJulianDate);
	dTemp.goMonth(direction);
	iJulianDate=dTemp.getJulian();
	console.log("dTemp.year="+dTemp.year+"\ndTemp.month="+dTemp.month);
	drawCalDelayed(dTemp.year,dTemp.month);

	}

function drawCal(yr,mo)
	{
	calendarYear=yr;
	calendarMonth=mo;
	var cal=new Calendar();					// Instantiate the class.
	cal.setSelectedDays(dayInfo);
	cal.setClass("MobileMonth");					// Set the CSS Class for the table.
	if(typeof(locInfo)!="undefined")
		{
		cal.localeInfo=locInfo;
		}
	cal.render(yr,mo);										// Render the calendar.
	var myDiv=document.getElementById(calContentDivName);			// Get the Div where the content goes.
	myDiv.innerHTML=cal.getHTML();																										// Set the HTML onto the object.
	var mySelect=document.getElementById('IDselDate');						// Get the Date Selection input device.
	if(mySelect!=null)
		{
		mySelect.onchange=onSelectChangeFunction;
		}
	}

function drawCalDelayed(yr,mo) {
	if(criteria==null) {
		setCriteria();
	}
	calendarYear=yr;
	calendarMonth=mo;

	var dTemp=new SimpleDate(calendarYear,calendarMonth,1);
	var params=new RemoteRequestParam('json/getText.txt?request_number=3&date='+
		dTemp.getJulian()+
		(criteria==null ? "" : '&'+criteria)+
		'&integral='+integral);
	if(oCache==null) {
		oCache=new AjaxCache();
	}
	// params.enableSwipe=true;
	var sValue=oCache.fetchValueFromCache(params.url);
	if(sValue==null) {
		params.fCallback=drawCalCallback;
		getRemoteText2(params);
	} else {
		params.result=sValue;
		drawCalCallback(params);
	}
	
}

function drawCalCallback(reqParams)
	{
	try {
		oCache.addEntry(reqParams.url,reqParams.result);
		dayInfo=reqParams.result;
		drawCal(calendarYear,calendarMonth);
		if(reqParams.enableSwipe)
			{
			addSwipeNavigation();
			}
	} catch (err)
		{
		alert('An error happened. The message was: '+err.message+'\ndayInfo='+dayInfo+'\ncalendarYear='+calendarYear+'\ncalendarMonth='+calendarMonth);
		}
	}

function onSelectChangeFunction()
	{
	var sel=document.getElementById('IDselDate');
	var sValue=sel.options[sel.selectedIndex].value;
	iYear=parseInt(sValue.substring(0,4),10);
	iMonth=parseInt(sValue.substr(5),10);
	iJulianDate=new SimpleDate(iYear,iMonth,1).getJulian();
	drawCalDelayed(iYear,iMonth);
	}

/** This simple helper class represents a cached Key/Value
	*  pair with an entry time.
	*/
function CacheItem(Key, Value)
	{
	this.key=Key;
	this.value=Value;
	this.entry_time=new Date();
	}

/** The maximum number of items to keep in the cache.  */
AjaxCache.CACHE_SIZE=64;
/** The number of seconds before a cache entry will be
	*  considered stale and re-fetched, or purged.
	*/
AjaxCache.CACHE_SECONDS=300;

/**
	* This class implements a caching system for AJAX calls. It's 
	* nice that the calls we make are really lightweight, but if 
	* the user is going back and forth, we're making the same calls 
	* over and over. This cache addresses that issue. 
	*  
	* The cache size is AjaxCache.CACHE_SIZE, and the lifespan of 
	* a cached value is AjaxCache.CACHE_SECONDS. 
	* 
	* @author gsexton (7/17/2011)
	*/
function AjaxCache()
	{
	this.aCache=new Array(AjaxCache.CACHE_SIZE);
	for(var i=0; i < this.aCache.length; i++)
		{
		this.aCache[i]=null;
		}
	}
/**
	* Add a Key/Value pair to the cache. 
	*  
	* If the Key already exists in the cachee, it's replaced with 
	* the new value. 
	*/
AjaxCache.prototype.addEntry = function(Key,Value)
	{
	var objNew=new CacheItem(Key,Value);
	var lOldest=objNew.entry_time.getTime();
	var iOldest=0,iNullPos=-1;
	var objCurrent;
	for(var i=0; i < this.aCache.length; i++)
		{
		objCurrent=this.aCache[i];
		if(objCurrent==null)
			{
			if(iNullPos==-1)
				{
				iNullPos=i;
				}
			} else
			{
			if(objCurrent.key==Key)
				{
				this.aCache[i]=objNew;
				return;
				} else if(iNullPos==-1 && objCurrent.entry_time.getTime()<lOldest)
				{
				lOldest=objCurrent.entry_time.getTime();
				iOldest=i;
				}
			}
		}
	if(iNullPos>=0)
		{
		this.aCache[iNullPos]=objNew;
		} else
		{
		this.aCache[iOldest]=objNew;
		if(lOldest<(objNew.entry_time.getTime()+AjaxCache.CACHE_SECONDS*1000))
			{
			// The oldest one we've found is actually outside the cache age.
			// Since there are probably others, purge the cache.
			this.purgeCache();
			}
		}
	}

/**
	* Fetch a value from cache. If Key is not found in the cache, 
	* null is returned. 
	*  
	* Additionally, if the found entry is older than CACHE_SECONDS, 
	* null is returned. 
	*/
AjaxCache.prototype.fetchValueFromCache=function(Key)
	{
	var oItem;
	for(var i=0; i < this.aCache.length; i++)
		{
		oItem=this.aCache[i];
		if(oItem!=null && oItem.key==Key)
			{
			if(oItem.entry_time.getTime()>=(new Date().getTime()-AjaxCache.CACHE_SECONDS*1000))
				{
				return oItem.value;
				} else
				{
				this.aCache[i]=null;
				return null;
				}
			}
		}
	return null;
	}

/**
	* Purge the cache object of any entries older than the current 
	* time-CACHE_SECONDS. 
	*/
AjaxCache.prototype.purgeCache=function()
	{
	var lCutoff=new Date().getTime()-AjaxCache.CACHE_SECONDS*1000;
	var aCopy=new Array(this.aCache.length);
	var iCopied=0;
	for(var i=0; i < this.aCache.length; i++)
		{
		if(this.aCache[i]!=null && this.aCache[i].entry_time.getTime()>=lCutoff)
			{
			aCopy[iCopied++]=this.aCache[i];
			}
		}
	// Null out the rest;
	while(iCopied<aCopy.length)
		{
		aCopy[iCopied++]=null;
		}
	this.aCache=aCopy;
	}

/**
	* Clear the cache object.
	*/
AjaxCache.prototype.clearCache=function()
	{
	var a=this.aCache
	for(var i=0; i < a.length; i++)
		{
		a[i]=null;
		}
	}

function setRecurrenceOptions(parentDivID,iValue)
	{
	function hideList(aList)
		{
		for(var i=0; i < aList.length; i++)
			{
			var ele=document.getElementById(aList[i]);
			if(ele==null)
				{
				alert('Element ID '+aList[i]+' not found in setRecurrenceOptions.');
				} else
				{
				ele.style.display='none';
				}
			}
		}
	function copyValueIfDestNull(idFrom,idTo)
		{
		var oFrom=document.getElementById(idFrom), oTo=document.getElementById(idTo);
		if((oTo.value==null || oTo.value.length==0) && (oFrom.value!=null && oFrom.value.length>0))
			{
			oTo.value=oFrom.value;
			}
		}

	var myDiv=document.getElementById(parentDivID);
	if(myDiv===null)
		{
		alert('Div ID ['+parentDivID+'] not found in setRecurrenceOptions. myDiv="'+myDiv+' Aborting...');
		return;
		}
	if(iValue==4)
		{
		// Specific Dates
		copyValueIfDestNull('IDstarting_date','IDSpecificDates');
		} else if(iValue==3)
		{
		// One Time
		} else
		{
		// Some kind of recurrence.
		copyValueIfDestNull('IDstarting_date','IDRecurrenceStart');
		copyValueIfDestNull('IDending_date','IDRecurrenceEnd');
		}

	var aList=new Array('IDDivRecurrenceDateRange','IDDivWeekRepeat','IDDivMonths','IDDivMonthlyRepeat','IDDivMonthRInterval','IDDivDuration','ExceptionsOuter',
	'IDDivMonthRInterval','IDSpecificDatesDiv','IDDivDayRepeat','IDstarting_date','IDending_date','IDlblIDending_date','IDlblIDstarting_date');
	hideList(aList);

	// Now, set the things to be visible.
	var aVis=null,aMinus=null;
	switch(iValue)
		{
		case 0:
			// weekly
			aVis=new Array('IDDivRecurrenceDateRange','IDDivWeekRepeat','ExceptionsOuter','IDRecurrenceDiv');
			break;
		case 1:
			aVis=new Array('IDDivRecurrenceDateRange','IDDivMonthlyRepeat','IDDivMonthRInterval','IDDivDuration','ExceptionsOuter','IDRecurrenceDiv');
			// monthly
			break;
		case 2: 
			//  annual
			aVis=new Array('IDDivRecurrenceDateRange','IDDivMonthlyRepeat','IDDivDuration','IDDivMonths','ExceptionsOuter','IDRecurrenceDiv');
			aMinus=new Array('IDDivMonthRInterval');
			break;
		case 3:
			// one time
			aVis=new Array('IDstarting_date','IDending_date','IDlblIDending_date','IDlblIDstarting_date');
			aMinus=new Array('IDRecurrenceDiv');
			break;
		case 4:
			// specific dates.
			aVis=new Array('IDSpecificDatesDiv','IDRecurrenceDiv');
			break;
		case 5:
			// daily.
			aVis=new Array('IDDivRecurrenceDateRange','IDDivDayRepeat','IDDivDuration','ExceptionsOuter','IDRecurrenceDiv');
			break;
		}
	if(aVis!=null)
		{
		var displayElement;
		for(var i=0; i < aVis.length; i++)
			{
			displayElement=document.getElementById(aVis[i]);
			if(displayElement==null)
				{
				alert('Element ['+aVis[i]+'] not found on DOM in setRecurrenceOptions!');
				} else
				{
				// alert(aVis[i]+ 'classname='+displayElement.className);
				if(displayElement.nodeName=='DIV')
					{
					displayElement.style.display='block';
					} else
					{
					displayElement.style.display='inline';
					}
				
				}
			}
		}
	if(aMinus!=null)
		{
		hideList(aMinus);
		}
	}

function setDropdownValue(dd,val)
	{
	if(dd!=null)
		{
		if(dd.options)
			{
			for(i=0; i < dd.options.length; i++)
				{
				o=dd.options[i];
				if(o.value==val)
					{
					o.selected=true;
					dd.selectedIndex=i;
					break;
					}
				}
			} else
			{
			dd.value=val;
			}
		}
	}
/*
				This function does an AJAX query to the calendar and updates
				fields that are dependent upon the selected calendar.
*/
function refreshCalendarDependents(ddCalendar)
	{
	var reqParams=new RemoteRequestParam("json/Approval"+new Date().getTime()+
	".js?request_number=1&calendar_id="+
	ddCalendar.options[ddCalendar.selectedIndex].value);
	reqParams.fCallback=refreshCalendarCallback;
	reqParams.handleAsJSON=true;
	getRemoteText2(reqParams);
	}

function refreshCalendarCallback(reqParams)
	{
	
	var res=reqParams.result;
	
	var rgYes=document.getElementById('IDApprovedYes'),
	rgNo=document.getElementById('IDApprovedNo'),
	approvalDiv=document.getElementById('IDApprovalDiv');

	if(res.approvers_exist)
		{
		rgYes.checked=true;
		if(res.guest_user)
			{
			approvalDiv.style.display='none';
			} else
			{
			approvalDiv.style.display='block'
			}
		if(res.default_approved==1)
			{
			rgYes.checked=true;
			} else
			{
			rgNo.checked=true;
			}
		} else
		{
		approvalDiv.style.display='none';
		rgYes.checked=true;
		}
	if(res.item_style!=undefined)
		{
		var is=document.getElementById('idstyle_id');
		if(is!=null)
			{
			setDropdownValue(is,res.item_style);
			if(res.can_change_style)
				{
				is.disabled=false;
				} else
				{
				is.disabled=true;
				}
			}
		var styleDiv=document.getElementById('IDItemStyleDiv');
		styleDiv.style.display=(res.can_change_style ? 'block' : 'none');
		}
	var dd=document.getElementById('IDitem_type_id');
	setDropdownValue(dd,res.default_type);
	dd=document.getElementById('IDprivacy_opts');
	setDropdownValue(dd,res.default_privacy);
	var cust=document.getElementById('IDcustom_tabs');
	if(cust!=null)
		{
		// This code looks at the custom tabs that have been drawn,
		// and if the new calendar has a different set of custom tabs,
		// it forces a refresh.
		if(!(res.custom_tabs===cust.value))
			{
			document.getElementById('IDrefresh_form').value='1';
			document.getElementById('IDFrmEditItem').submit();
			}
		}

	} 

function setupFormFieldsForSave()
	{

	var iRecType=parseInt(document.frmEditItem.rec_type.value,10);
	if(iRecType==3)
		{
		// One Time
		} else if(iRecType==4)
		{
		// Specific Dates
		document.frmEditItem.starting_date.value='';
		document.frmEditItem.ending_date.value='';
		document.frmEditItem.exceptions.value=document.frmEditItem.specificdates_edit.value;
		} else
		{
		// Recurrence.
		document.frmEditItem.exceptions.value=document.frmEditItem.exceptions_edit.value;
		document.frmEditItem.starting_date.value=document.frmEditItem.recurrence_start.value;
		document.frmEditItem.ending_date.value=document.frmEditItem.recurrence_end.value;
		switch(iRecType)
			{
			case 0:
				// weekly
				document.frmEditItem.rinterval.value=document.frmEditItem.rinterval_weekly.value;
				break;
			case 1:
				// monthly
				document.frmEditItem.rinterval.value=document.frmEditItem.rinterval_monthly.value;
				break;
			case 2: 
				//  annual
				break;
			case 5:
				// daily.
				document.frmEditItem.rinterval.value=document.frmEditItem.rinterval_daily.value;
				break;
			}
		}
	var i,selSelected=document.getElementById('IDSelectedResources');
	if(selSelected!=null)
		{
		/*
						We have resources.
		*/
		var sResult='';
		var selAvailableResources=document.getElementById('IDResourceCandidates');
		if(selAvailableResources==null)
			{
			// This is a multi-select, only one Select present form. Copy only options that are marked.
			for(i=0; i < selSelected.options.length; i++)
				{
				if(selSelected.options[i].selected)
					{
					sResult=sResult+selSelected.options[i].value+',';
					}
				}
			} else
			{
			// This is a two Select present form. Copy all options from selSelected.
			for(i=0; i < selSelected.options.length; i++)
				{
				sResult=sResult+selSelected.options[i].value+',';
				}
			}
		if(sResult.length>0)
			{
			document.frmEditItem.resource_list.value=sResult.substring(0,sResult.length-1);
			}
		}
	return true;
	}

function popInstanceOrSeries(iItemID,iDay) {
	var sURL;
	if(iDay==0) {
		sURL='MobileEditItem.html?cal_item_id='+iItemID;
		window.location.href=sURL;
		return;
	} else {

		sURL='InstanceOrSeriesDialog.html?DialogName=InstanceOrSeries&Title=EditInstanceOrSeries&mode=AsText&html=5&callback=InstanceOrSeriesResult'

		var reqParams=new RemoteRequestParam(sURL);
		reqParams.fCallback=function(params){
			var dlg=displayDialog(params.result,"DivInstanceOrSeries");
			require(["dojo/dom-attr","dojox/mobile/SimpleDialog"],function(domAttr){
				domAttr.set(dlg.domNode,"data-itemid",iItemID);
				domAttr.set(dlg.domNode,"data-instance",iDay);
			});
		};
		
		getRemoteText2(reqParams);

	}
}

/**
	* This is the callback to accept the dialog result. 
	*  
	* iResult will be: 
	*  
	* 1 - Edit Instance 
	* 2 - This and Future
	* 3 - Edit Series 
	* 4 - Cancel
	*/
function InstanceOrSeriesResult(iResult)
	{
	var dlg=document.getElementById('DivInstanceOrSeries');
	var ItemID=dlg.getAttribute('data-itemid'),Instance=dlg.getAttribute('data-instance');

	closeDialog('DivInstanceOrSeries')

	if(iResult!=4)
		{
		sURL='MobileEditItem.html?cal_item_id='+ItemID+'&editseries='+iResult+'&instance='+Instance;
		window.location.href=sURL;
		}
	}

function popConfirmDelete() {

	if(document.frmEditItem.delete_confirmed.value=='1') {
		return true;
		}
	genericDojoDialog('DeleteDialog.html?DialogName=DeleteConfirmMsg&callback=deleteConfirmed&mode=AsText','IDDivDelete');
	return false;
	}



function genericDojoDialog(url,divID) {
	var reqParams=new RemoteRequestParam(url);
	reqParams.div_id=divID;
	reqParams.fCallback=function(params) {
		displayDialog(params.result,divID);
	};
	getRemoteText2(reqParams);
}

function displayDialog(content,divID) {
	var dlg;
	require([
	"dojo/_base/window",
	"dojo/dom-construct",
	"dojox/mobile/SimpleDialog",
	"dojox/mobile/Button"
	], function(win, domConstruct, SimpleDialog, ProgressIndicator, Button){
			dlg = new SimpleDialog({"id": divID});
			win.body().appendChild(dlg.domNode);
			var msgBox = domConstruct.create("div",{
					"class": "mblSimpleDialogText",
					"innerHTML": content
			
				},
				dlg.domNode);
			dlg.show();
			
		});
	return dlg;
}

function alertDialog(sMsgText, sButtonLabel,sCallback) {
	if (sCallback==null){
		sCallback="closeDialog";
	}

	var divID='AlertDiv', sText=sMsgText+"<br><br><form><button "+
		"onclick='"+sCallback+'("'+divID+'");'+"'>"+sButtonLabel+"</button></form>";

	displayDialog(sText,divID);
}


function deleteConfirmed(iResult){
	closeDialog('IDDivDelete');
	if (iResult==1){
		document.frmEditItem.delete_confirmed.value='1';
		var btn=document.getElementById('IDbtnSubmitDelete');
		btn.click();
	}
}
	/*
		Close a Dojo Dialog
	*/
	function closeDialog(dialogID){
		require(["dijit/registry","dojox/mobile/SimpleDialog"],function(registry){ 
			var dlg=registry.byId(dialogID);
			dlg.hide();
			dlg.destroy();
			// todo remove the node.
		});
	}

/**
	* This gets our current login/logout status and sets the 
	* HREF/icons appropriately. 
	*  
	* @param loginIcon - The ID of the login HREF. 
	* @param logoutIcon - the ID of the logout HREF. 
	*/
function setLoginIcons(loginIcon,logoutIcon,addIcon){
	var reqParams=new RemoteRequestParam("json/sessionstatus.txt?request_number=4");

	reqParams.handleAsJSON=true;
	reqParams.fCallback=toggleIcons;
	reqParams.LoginIcon=loginIcon;
	reqParams.LogoutIcon=logoutIcon;
	reqParams.AddEventIcon=addIcon;
	
	getRemoteText2(reqParams);

}

function toggleIcons(CallParams){
	var objResult=CallParams.result;
	var lnkLogin=document.getElementById(CallParams.LoginIcon)

	lnkLogout=document.getElementById(CallParams.LogoutIcon);
	integral=objResult.logged_in ? 1 : 0;

	if (lnkLogin!=null){
		lnkLogin.style.display=objResult.logged_in ? "none" : "block";
		lnkLogout.style.display=objResult.logged_in ? "block" : "none";
	}

	var lnkAdd=document.getElementById(CallParams.AddEventIcon);

	if (lnkAdd!=null){
		lnkAdd.style.display=objResult.add_event ? "block" : "none";
	}
}

/**
	* Initiate a Logout request via JSON.
	*/
	function initiateLogout(){
	var params=new RemoteRequestParam("json/logout.txt?request_number=5");
	params.fCallback=processLogout;
	params.handleAsJSON=true;
	getRemoteText2(params);
	}
/**
	* Actually process the logout. Change integral, toggle the 
	* login/logout icons, and advance the display to the current ID 
	* for refresh. 
	*/
function processLogout(objParams){
	//  Clear any cached Pages.
	oCache.clearCache();
	var res=objParams.result;
	
	if (res.public_view){
		//
		// If public view is supported, view that calendar.
		//
		integral=0;
		//
		// Set the new calendar to view, and window title.
		//
		criteria='calendar_id='+res.calendar_id;
		document.title=res.calendar_title;
		var lnkLogin=document.getElementById('Login')
		lnkLogout=document.getElementById('Logout');
		if (lnkLogin!=null){
			//
			//  Reset the login/logout icons.
			//
			lnkLogin.style.display="block";
			lnkLogout.style.display="none";
		}
		// Set the add event icon appropriately.
		var lnkAdd=document.getElementById('NewEvent');
		lnkAdd.style.display=res.add_event ? "block" : "none";
		advanceDisplay(0);
	}else{
		// No public view. Send the user to the login page.
		window.location.href='MobileLogin.html';
	}
}

/**
	* A parameter object for getRemoteRequest2(). 
	*  
	* Properties: 
	*  
	* url - The URL for the request. 
	*  
    * preventCache - True to disable browser caching. Done by 
    * adding a random variable to the URL. Default True. 
	*  
    * fCallBack - The Callback Function to invoke. 
    * fError - The error callback to invoke. 
	*  
	* handleAsJSON - true or false
	*  
	* result - The result of the call. If handleAsJSON is true, the 
	* JSON object. Otherwise, the text returned by the function. 
	*  
	* resultCode - The HTTP result code. 
	*  
	* loadingIndictorTimeout - Timeout (in millis) before loading 
	* indicator is displayed. Default 1000ms. Set to 0 to disable 
	* loading  
	*  
	* You can add your own user defined properties to this object 
	*  
	*/
	function RemoteRequestParam(sURL){
	this.url=sURL;
	this.preventCache=true;
	this.fCallback=null;	// Callback function on success
	this.fError=null;		// Callback function on failure. A default is provided.
	this.handleAsJSON=false;
	this.handleAs="text";
	this.sync=false;
	this.timeout=20000;
	this.result='';
	this.method='GET';

	this.loadingIndicatorTimeout=1000;
	/** We need to be able to detect if we've been redirected,
		*  and the XMLHttpRequest object by spec doesn't permit this.
		*  The best thing I can come up with is to look at the result
		*  and if it matches, redirect to a known URL.
		*  
		*  if you want, you can set this to null and implement your own
		*  redirect detection.
		*  
		*  Don't forget to add mode=AsText if you're calling a Connect
		*  Daily dialog box function, otherwise it will match.
		*  
		*/
	this.redirectMatch=/<body/i;
	this.redirectURL='MobileLogin.html';
	}

var CDaily = {
	"currentRemoteRequest" : null
};

/** 
* This function is a wrapper around an xml http request object.
*  
* @param objParams - a RemoteRequestParam. 
*  
* This parameter is passed to the callback function. 
*  
* @return the result text (or object) from the call. 
*  
* @see RemoteRequestParam
*/ 
function getRemoteText2(objParams){

	function displayLoadingDiv2(){
		var loadingDiv=null;
		loadingDiv=document.createElement('div');
		loadingDiv.setAttribute("id","idLoadingDiv");
		loadingDiv.style.cssText='width: 100%; height: 80px; position: absolute;';
		loadingDiv.innerHTML='<IMG SRC="images/loading.gif" STYLE="display: block; height: 64px; width: 64px; margin: auto auto auto auto; border: 0px none;" ALT="loading">';
		document.getElementsByTagName('body')[0].appendChild(loadingDiv);
		loadingDiv.style.top= Math.floor(window.pageYOffset + (window.innerHeight-80)/2) + 'px';
		loadingDiv.style.display='block';
	}
	function clearLoadingDiv(objParams){
		if (objParams.timeoutID){
			window.clearTimeout(objParams.timeoutID);
		}
		var loadingDiv=document.getElementById('idLoadingDiv');
		if (loadingDiv!=null){
			loadingDiv.style.display='none';
			document.getElementsByTagName('body')[0].removeChild(loadingDiv);
		}
	}

	function defaultErrorHandler(err){
		alertDialog(err.message,'OK');
	}

	console.log("getRemoteText2() url="+objParams.url);

	if(CDaily.currentRemoteRequest!=null) {
		
		console.log("Aborting out of getRemoteText2() because their is a request running for URL: "+CDaily.currentRemoteRequest.url);
		return null;
	}
	CDaily.currentRemoteRequest=objParams;
	if(document.getElementById('idLoadingDiv')!=null) {
		console.log("Aborting out of getRemoteText2() because the loading div is already displayed.")
		return false;
	}

	if(objParams.fError===null) {
		objParams.fError=defaultErrorHandler;
	}
	
	if (objParams.loadingIndicatorTimeout>0){
		objParams.timeoutID=window.setTimeout(displayLoadingDiv2,objParams.loadingIndicatorTimeout);
	}

	objParams.handleAs="text";

	require(["dojo/request/xhr"],function(xhr){
		xhr(objParams.url,objParams).then(function(data){
			CDaily.currentRemoteRequest=null;
			clearLoadingDiv(objParams);
			
			if (objParams.redirectMatch!=null && 
					objParams.redirectURL!=null &&
					data.match(objParams.redirectMatch)){
				window.location.href=objParams.redirectURL;
				return;
			}
			if (JSON.parse) {
				objParams.result=objParams.handleAsJSON ? JSON.parse(data) : data;
			} else {
			objParams.result=objParams.handleAsJSON ? eval("("+data+")") : data;
			}
			if(objParams.fCallback) {
				objParams.fCallback(objParams);
			}
		},
		function(err){
			CDaily.currentRemoteRequest=null;
			 clearLoadingDiv(objParams);
			 objParams.fError(err);
				// TODO: How are redirects handled.
			 });
		
	});

	CDaily.currentRemoteRequest=null;

	return objParams.result;
}


/**
	* This class represents the time locale info we need to render 
	* the picker. 
	* 
	* @author gsexton (7/28/2011)
	*/
	function TimeLocaleInfo(){
	this.am="AM";
	this.pm="PM";
	this.timeSep=":";
	this.hourLabel="Hour";
	this.minuteLabel="Minute";
	this.AMPMLabel="AM/PM";
	this.submitLabel="OK";
	this.cancelLabel="Cancel";
	}

	TimePicker.instance=null;
/**
	* This method implements a singleton using the 
	* TimePicker.instance property. 
	* 
	* @author gsexton (7/28/2011)
	* 
	* @param sTime - The initial time for the time picker.
	* @param lc - The TimeLocaleInfo to use.
	* @param onSubmit - The character name of the submit function.
	*/
	TimePicker.getInstance=function(sTime,lc,onSubmit){
	if (TimePicker.instance==null){
	TimePicker.instance=new TimePicker(sTime,lc,onSubmit);
	}else{
	if (lc!=null){
	tp.localeInfo=lc;
	}
	tp.parseTime(sTime);
	}
	return TimePicker.instance;
	};

/**
	* Constructor for a TimePicker.
	* 
	* @author gsexton (7/28/2011) 
	*  
	* @see TimePicker.getInstance()
	*/
	function TimePicker(sInput,lc,onSubmit){
	this.charTime=sInput;
	this.hour=0;
	this.minute=0;
	this.buf='';
	this.submitFunction=onSubmit;
	this.localeInfo=null;
	this.caption=null;
	if (lc==null){
	this.localeInfo=new TimeLocaleInfo();
	}else{
	this.localeInfo=lc;
	}
	this.parseTime(sInput);
	}

/**
	* Convert the current hour/minute values to a string and store 
	* on charTime. 
	*/
	TimePicker.prototype.formatTime=function(){
	var b24=(this.localeInfo.am==null);
	var s='';

	if (b24){
	s+=padL(this.hour,2);
	}else{
	if (this.hour>12){
	s+=(this.hour-12);
	}else{
	s+=this.hour;
	}
	}
	if (this.localeInfo.timeSep!=null){
	s+=this.localeInfo.timeSep;
	}
	s+=padL(this.minute,2);
	if (!b24){
	s+=' '+(this.hour>=12 ? this.localeInfo.pm : this.localeInfo.am);
	}
	this.charTime=s;
	}
/**
	* This function updates the fields of the parameter time picker 
	* object using values from the form. 
	*  
	* @param tp The TimePicker instance to update. 
	*/
	TimePicker.update=function(tp){
	tp.hour=parseInt(document.frmTimePicker.tpHour.value,10);
	tp.minute=parseInt(document.frmTimePicker.tpMinute.value,10);
	if (tp.localeInfo.am!=null){
	var selAMPM=document.getElementById('IDAMPMPicker');
	if (selAMPM.value=='1'){
	tp.hour+=12;
	}
	}

	tp.formatTime()
	};

/**
	* Render the picker and return the HTML as a string.
	* 
	* @author gsexton (7/28/2011)
	*/
	TimePicker.prototype.render=function(){
	this.buf='';
	if (this.caption!=null){
	this.write(this.caption)
	}
	this.write("<FORM STYLE='margin-top: 1em;' NAME=frmTimePicker>");
	this.write("<INPUT TYPE=HIDDEN NAME=cancelled VALUE='0'>");
	this.renderLabels();
	this.write("<BR>");
	this.renderHourPicker();
	this.renderMinutePicker();
	if (this.localeInfo.am!=null){
	this.renderAMPMPicker();
	}
	this.write("<BR>");
	this.renderButton();
	this.write("</FORM>");
	return this.buf;
	};

	TimePicker.prototype.renderLabels=function(){
	this.write("\n<LABEL STYLE='display: none;' FOR=IDHourPicker>"+this.localeInfo.hourLabel+"</LABEL>");
	this.write("\n<LABEL STYLE='display: none;' FOR=IDMinutePicker>"+this.localeInfo.minuteLabel+"</LABEL>");
	this.write("\n<LABEL STYLE='display: none;' FOR=IDAMPMPicker>"+this.localeInfo.AMPMLabel+"</LABEL>");
	};

	TimePicker.prototype.renderButton=function(){
	this.write("<BR><BR>")
	this.write("<BUTTON ID=IDTPButtonOK TYPE=BUTTON onclick=\""+this.submitFunction+"\">"+this.localeInfo.submitLabel+"</BUTTON>");
	this.write("<BUTTON ID=IDTPButtonCancel TYPE=BUTTON onclick=\"new function() { document.frmTimePicker.cancelled.value='1'; "+this.submitFunction+" return true;}\">"+this.localeInfo.cancelLabel+"</BUTTON>");
	};

	function padL(num,digits){
	var s=''+num;
	while (s.length<digits){
	s='0'+s;
	}
	return s;
	}

	TimePicker.prototype.renderHourPicker=function(){
	var iUseHour=this.hour,i,sHour;
	if (this.charTime==null){
	iUseHour=(this.localeInfo.am==null ? 12 : 6);
	}else if (this.localeInfo.am!=null && iUseHour>12){
	iUseHour-=12;
	}
	this.write("\n<SELECT ID=IDHourPicker NAME=tpHour>")
	if (this.localeInfo.am==null){
	for (i=0; i < 24; i++){
	sHour=padL(i,2);
	this.write("<OPTION VALUE='"+sHour+"'"+
	(iUseHour==i ? " SELECTED" : "")+
	">"+sHour);
	}
	}else{
	for (i=1; i < 13; i++){
	this.write("<OPTION VALUE='"+i+"'"+
	(iUseHour==i ? " SELECTED" : "")+
	">"+i);
	}
	}
	this.write("</SELECT>");
	};

	TimePicker.prototype.renderMinutePicker=function(){
	var iUseMinute=this.minute,i,iMinute;
	if (this.charTime==null){
	iUseMinute=30;
	}
	this.write("\n<SELECT ID=IDMinutePicker NAME=tpMinute>")
	for (i=0; i < 12; i++){
	iMinute=i*5;
	sMinute=padL(iMinute,2);
	this.write("<OPTION VALUE='"+iMinute+"'"+
	(iUseMinute==iMinute ? " SELECTED" : "")+
	">"+sMinute);
	}
	this.write("</SELECT>");
	};

	TimePicker.prototype.renderAMPMPicker=function(){
	this.write("\n<SELECT ID=IDAMPMPicker NAME=tpAMPM>");
	this.write("<OPTION VALUE='0'"+(this.hour<12 ? " SELECTED" : "")+">"+this.localeInfo.am);
	this.write("<OPTION VALUE='1'"+(this.hour>=12 ? " SELECTED" : "")+">"+this.localeInfo.pm);
	this.write("</SELECT>");
	};


	TimePicker.prototype.write=function(sText){
	this.buf+=sText;
	};

	TimePicker.prototype.toString=function(){
	return this.buf;
	};
/**
	* A lax time parser to set the current value of the fields.
	* 
	* @author gsexton (7/28/2011)
	* 
	* @param sTime 
	*/
	TimePicker.prototype.parseTime=function(sTime){
	if (sTime!=null && sTime.length==0){
	sTime=null;
	}
	this.charTime=sTime;
	this.hour=0;
	this.minute=0;
	if (sTime==null){
	return;
	}
	var sTemp='';
	for (var i=0; i < sTime.length; i++){
	var c=sTime.charAt(i);
	if (c>='0' && c<='9'){
	sTemp+=c;
	if (sTemp.length==4){
	break;
	}
	}
	}
	if (sTemp.length==0){
	return;
	}
	var iMil=parseInt(sTemp,10);
	this.hour=Math.floor(iMil/100);
	if ((this.localeInfo.am!=null) && (sTime.toLowerCase().indexOf(this.localeInfo.pm.toLowerCase())>=0) && (this.hour<12)){
	this.hour+=12;
	}

	this.minute=iMil%100;
	};
/**
	* Helper function to set the default end time to start time 
	* plus one hour. 
	* 
	* @author gsexton (7/28/2011)
	* 
	* @param localeInfo - A TimeLocaleInfo object. This is used for
	*                   parsing the time.
	*/
	function setDefaultEndTime(localeInfo,localeOverride){
	var sStart=nullIfEmpty(document.frmEditItem.starting_time.value),
	sEnd=nullIfEmpty(document.frmEditItem.ending_time.value);
	//	alert('sStart='+sStart+' sEnd='+sEnd);
	if (sEnd==null && sStart!=null){
	var tpTemp=new TimePicker(sStart,localeInfo);
	tpTemp.hour++;
	if (tpTemp.hour>=24){
	tpTemp.hour=0;
	}
	tpTemp.formatTime();
	document.frmEditItem.ending_time.value=tpTemp.charTime;
	}
	}

/**
	* Helper function to set the default end date for an event to 
	* the same as the event start date. 
	* 
	* @param localeOverride - If true, override the locale and use yyyy-mm-dd. Necessary if we're 
	* using the native pickers of the browser.
	*/
	function setDefaultEndDate(localeOverride){
	var sStart=nullIfEmpty(document.frmEditItem.starting_date.value),
	sEnd=nullIfEmpty(document.frmEditItem.ending_date.value);
	if (sStart==null){
	// There's nothing we want to do.
	}else{
	if (sEnd==null){
	document.frmEditItem.ending_date.value=sStart;
	}else{
	// Look to see if sStart>sEnd, and if so, set sEnd=sStart
	var sFormat=(localeOverride ? "yyyy-mm-dd" : Calendar.defaultLocaleInfo.format.toLowerCase());
	var d1=SimpleDate.parseDate(sStart,sFormat), d2=SimpleDate.parseDate(sEnd,sFormat);
	if (d1!=null && d2!=null && d1.toString()>d2.toString()){
	document.frmEditItem.ending_date.value=sStart;
	}
	}
	}
	

	}

/**
	* This is the callback that actually takes the value and sticks 
	* it into the form. 
	*  
	* @param sDevice the ID of the input widget to receive the 
	*                result.
	*/
	function timePickerFinished(sDevice){
	if (document.frmTimePicker.cancelled.value=='0'){
	var pckr=TimePicker.getInstance();
	TimePicker.update(pckr);
	var element=document.getElementById(sDevice);
	if (element==null){
	alert('Element ['+sDevice+'] not found!');
	}else{
	element.value=pckr.charTime;
	if (sDevice=='IDstarting_time'){
	setDefaultEndTime(pckr.localeInfo);
	}
	}
	}
	closeDialog('TimePickerDiv');
	}

/**
	* This function kicks off the time picker dialog. 
	*  
	* @param sCaption the caption to display. E.G. start time. 
	* @param sDefault, the default value for the picker. IOW, the 
	*                current time value.
	* @param lc - The TimeLocaleInfo object used for formatting. 
	*           Can be null.
	* @param sDevice - the String ID of the input device to receive 
	*                the results of the picker.
	*  
	*/
	function startTimePicker(sCaption,sDefault,lc,sDevice){

	tp=TimePicker.getInstance(sDefault,lc);
	tp.caption=sCaption;
	tp.submitFunction="timePickerFinished('"+sDevice+"',document.frmTimePicker.cancelled.value);";
	displayDialog(tp.render(),'TimePickerDiv');
	return false;
	}

	function nullIfEmpty(sValue){
	if (sValue==null || sValue.length==0){
	return null;
	}
	var c;
	for (var i=0; i < sValue.length; i++){
	c=sValue.charAt(i);
	if (c!=' ' && c!='\n' && c!='\t'){
	return sValue;
	}
	}
	return null;
	}

	function advancePickerMonth(yr,mo,direction){
	var sd=new SimpleDate(yr,mo,1);
	sd.goMonth(direction);
	var cal=new Calendar();					// Instantiate the class.
	cal.setClass("MonthPicker");					// Set the CSS Class for the table.
	cal.daySelectCallback='datePickerFinished';
	cal.selectName=null;
	cal.advanceFunction='advancePickerMonth';
	cal.drawCancel=true;
	cal.render(sd.year,sd.month);										// Render the calendar.
	
	var dlg=document.getElementById('DatePickerDiv');
	dlg.innerHTML=cal.getHTML();
	}


	function datePickerFinished(yr,mo,da){

	if (yr>0){
	var dlg=document.getElementById('DatePickerDiv'), 
	sTarget=dlg.getAttribute('data-targetid');
	target=document.getElementById(sTarget);
	if (target==null){
	alert('target: '+sTarget+' not found in datePickerFinished()!');
	}else{
	var sFormat=Calendar.defaultLocaleInfo.format.toLowerCase();
	var s=sFormat.replace(/y{2,4}/,padL(yr,4));
	s=s.replace(/m+/,padL(mo,2));
	s=s.replace(/d+/,padL(da,2));
	target.value=s;
	if (sTarget=='IDstarting_date'){
	setDefaultEndDate();
	}
	}

	//     alert('Year='+yr+' Month='+mo+' day='+da+' target='+sTarget);
	}
	closeDialog('DatePickerDiv');
	}


	function startCalendarPicker(sDefault,lc,sDevice){
	var sd=(sDefault==null || sDefault.length==0) ? new SimpleDate() :
	SimpleDate.parseDate(sDefault,Calendar.defaultLocaleInfo.format.toLowerCase());
	var cal=new Calendar();					// Instantiate the class.
	cal.setClass("MonthPicker");					// Set the CSS Class for the table.
	if (typeof(lc)!="undefined"){
	Calendar.defaultLocaleInfo=lc;
	}
	cal.daySelectCallback='datePickerFinished';
	cal.selectName=null;
	cal.advanceFunction='advancePickerMonth';
	cal.drawCancel=true;
	cal.render(sd.year,sd.month);										// Render the calendar.
	
	displayDialog(cal.getHTML(),'DatePickerDiv');
	var dlg=document.getElementById('DatePickerDiv');
	dlg.setAttribute("data-targetid",sDevice);
	
	return false;
	}


/**
	* You can identify a swipe gesture as follows:
	* 1. Begin gesture if you receive a touchstart event containing one target touch.
	* 2. Abort gesture if, at any time, you receive an event with >1 touches.
	* 3. Continue gesture if you receive a touchmove event mostly in the x-direction.
	* 4. Abort gesture if you receive a touchmove event mostly the y-direction.
	* 5. End gesture if you receive a touchend event.
	* 
	* @author Dave Dunkin
	* @copyright public domain
	*/
	function addSwipeListener(el, listener){
	var startX;
	var dx;
	var direction;
	
	function cancelTouch(){
	el.removeEventListener('touchmove', onTouchMove);
	el.removeEventListener('touchend', onTouchEnd);
	startX = null;
	startY = null;
	direction = null;
	}
	
	function onTouchMove(e){
	if (e.touches.length > 1){
	cancelTouch();
	}else{
	dx = e.touches[0].pageX - startX;
	var dy = e.touches[0].pageY - startY;
	if (direction == null){
	direction = dx;
	//  e.preventDefault();
	e.stopPropagation();
	}else if ((direction < 0 && dx > 0) || (direction > 0 && dx < 0) || Math.abs(dy) > 30){
	cancelTouch();
	}
	}
	}

	function onTouchEnd(e){
	cancelTouch();

	if (Math.abs(dx) > 50){
	e.stopPropagation();
	el.removeEventListener("touchstart",onTouchStart);		// 
	el.cancelSwipeListener=null;
	
	listener({ target: el, direction: dx > 0 ? -1 : 1});
	// addSwipeListener(el,listener);
	}
	}
	
	function onTouchStart(e){
	if (e.touches.length == 1){
	startX = e.touches[0].pageX;
	startY = e.touches[0].pageY;
	el.addEventListener('touchmove', onTouchMove, false);
	el.addEventListener('touchend', onTouchEnd, false);
	}
	}
	function cancelListener(){
	el.cancelSwipeListener=null;
	cancelTouch();
	el.removeEventListener("touchstart",onTouchStart);
	}

	if (el.cancelSwipeListener==undefined || el.cancelSwipeListener==null){
	el.cancelSwipeListener=cancelListener;
	el.addEventListener('touchstart', onTouchStart, false);
	}
	}

	function supportsSwipe(){
	var sAgent=navigator.userAgent.toLowerCase();
	if (sAgent.match(/.*(ip[a|o]d|iphone|android).*safari.*/)){
	return true;
	}
	return false;
	}

	function addSwipeNavigation(){
		return false;
		/*
	if (supportsSwipe()){
	addSwipeListener(document.body,function(e){ advanceDisplay(e.direction);});
	}	 
		*/ 
	}


/**
	* Essentially this is a handler to respond to update/changes 
	* for the location dropdown list. It looks for an address 
	* already entered for the location and displays it. If the 
	* entry is flagged as Verified, then it disables the address 
	* input box. 
	*  
	* @author George Sexton 
	*  
	* @date 2013-05-30 
	*  
	*/
function locationUpdateHandler(value){
	require(["dojo/dom","dojo/dom-attr","dojo/request/xhr"],function(dom,domAttr,xhr){

	var xhrArgs = {
		"url" : "json/location"+new Date().getTime()+".js?request_number=8&location="+encodeURIComponent(value),
		"handleAs" : "json",
		"preventCache" : true
	};

	xhr(xhrArgs.url,xhrArgs).then(function(data){
	var res=eval(data);
	var address=dom.byId("IDLocationAddress"),idPicker=dom.byId("IDlocation_id");

	domAttr.set(address,"value",res.location_address==null ? "" : res.location_address);
	if (res.verified || idPicker!=null){
		domAttr.set(address,"readonly","true");
	} else {
		domAttr.remove(address,"readonly");
	}

	},
	function(error){
		alert('An error occurred getting the location info. Error was:'+error);
	});


	});



}

	
function saveMover(oMover,oTo){
    // oMover is a SELECT, oTo is a text field.
    var sOutput='';
    var i;
    var s;
    
    for (i=0; i < oMover.length; i++)
    {
        s=oMover.options[i].value;
        if (s.length>0)
        {
            sOutput=sOutput+s+',';
        }
    }
    
    if (sOutput.length>0)
    {
        sOutput=sOutput.substring(0,sOutput.length-1);
    }
    oTo.value=sOutput;
    // if there's an onchange handler assigned to the field, fire it.
    // We have to do this because it won't automatically fire.
    if (typeof(oTo.onchange)=='function') oTo.onchange();
}

function moverEvent(lstAvailable, lstSelected, iDirection, iptSave) {
    if (iDirection > 0)
    {
        moveIt(lstAvailable,lstSelected);
    } else
    {
        moveIt(lstSelected,lstAvailable);
    }
    saveMover(lstSelected,iptSave);
}

/**
 * Known Issues: If you have a mover with an OPTGROUP with IE 9, 
 * it fails when you try to remove with a DOM Exception 
 * NOT_FOUND_ERR 8 
 */
function moveIt(oFrom, oTo) {
    try {

        if (oFrom.selectedIndex == -1)
        {
            alert('No items selected!');
            return;
        }
        var i, oNewOption, iSelect=0, aRmv = new Array();
        for (i = 0; i < oFrom.length; i++)
        {
            if (oFrom.options[i].selected)
            {
                if (oFrom.options[i].value!="")
                {
                    oNewOption=new Option(oFrom.options[i].text, oFrom.options[i].value);
                    if (oFrom.options[i].title)
                    {
                        oNewOption.title=oFrom.options[i].title;
                    }
                    oTo.options[oTo.options.length]=oNewOption;
                    aRmv.push(i);
                }
            }
        }

        while (aRmv.length>0)
        {
            iSelect=aRmv.pop();
            oFrom.remove(iSelect);
        }

        if (iSelect >= oFrom.length)
            iSelect=oFrom.length-1;
        if (oFrom.length > 0 && oFrom.options[iSelect]!=null)
            oFrom.options[iSelect].selected=true;
    } catch (err) {
        oFrom.selectedIndex=1;
        // alert('An error happened. The message was: '+err.message==null ? err : err.message);
    }
}



// -------------------------------------------------------------------
// swapOptions(select_object,option1,option2)
//  Swap positions of two options in a select list
// -------------------------------------------------------------------
function swapOptions(obj,i,j) {
    var o = obj.options;
    var i_selected = o[i].selected;
    var j_selected = o[j].selected;
    var i_title=null,j_title=null;
    if (o[i].title) i_title=o[i].title;
    if (o[j].title) j_title=o[j].title;
    var temp = new Option(o[i].text, o[i].value, o[i].defaultSelected, o[i].selected);
    var temp2= new Option(o[j].text, o[j].value, o[j].defaultSelected, o[j].selected);
    if (i_title!=null) temp.title=i_title;
    if (j_title!=null) temp2.title=j_title;
    o[i] = temp2;
    o[j] = temp;
    o[i].selected = j_selected;
    o[j].selected = i_selected;
}
function moveSelectedSave(oControl, iDirection,oSaveTo) {
    moveSelected(oControl,iDirection);
    saveMover(oControl,oSaveTo);
}
/** 
 * Move selected items in a HTML SELECT element up or down.
 * 
 * @param oControl  Reference to the HTML SELECT element.
 * @param iDirection 1 for up, -1 for down.
 */
function moveSelected(oControl, iDirection) {
    var i;
    if (iDirection > 0)
    {

        // Move things up.
        for (i = 1; i < oControl.length; i++)
        {
            if (oControl.options[i].selected && !oControl.options[i-1].selected)
            {
                // This one is  selected, the one above is not.
                swapOptions(oControl,i,i-1);
                oControl.options[i-1].selected=true;
            }
        }
    } else
    {
        // Move Things down.
        for (i=oControl.length-2; i>=0; i--)
        {
            if (oControl.options[i].selected &&  !oControl.options[i+1].selected)
            {
                swapOptions(oControl,i,i+1);
                oControl.options[i+1].selected=true;
            }
        }
    }
}


function xferAllSelValues(oSelect) {
    if (oSelect!=null)
    {
        for (i=0; i < oSelect.options.length; i++)
        {
            if (!oSelect.options[i].disabled)
            {
                oSelect.options[i].selected=true;
            }
        }
    }
    return true;
}

function getSelectedOptionsAsCSVList(element) {
var sResult="",i,opt;
for (i=0; i < element.options.length; i++) {
	opt=element.options[i];
	if (opt.selected) {
	sResult+=(sResult.length>0 ? ',' : '')+opt.value;
	}
}	
return sResult;
}
